
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.desyre.builder.wrapper.meta.jet;

import com.eu.ales.desyre.configuration.DesyreConfiguration;
import com.eu.ales.desyre.builder.wrapper.meta.*;
import com.eu.ales.desyre.model.desyre.Component;
import com.eu.ales.desyre.model.desyre.Port;
import com.eu.ales.desyre.model.desyre.PortDirection;
import com.eu.ales.desyre.model.desyre.PortKind;
import java.util.Set;
import java.util.*;
import com.eu.ales.desyre.configuration.*;

public class ComponentDesyreMETAWrapperSourceTemplate
{
  protected static String nl;
  public static synchronized ComponentDesyreMETAWrapperSourceTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    ComponentDesyreMETAWrapperSourceTemplate result = new ComponentDesyreMETAWrapperSourceTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "/*****************************************************************************" + NL + "Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy" + NL + "Developed with the sponsorship of the Defense Advanced Research Projects Agency (DARPA)." + NL + "" + NL + "Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074." + NL + "" + NL + "THE DATA IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR" + NL + "IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY," + NL + "FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE" + NL + "AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE" + NL + "FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF" + NL + "CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE" + NL + "DATA OR THE USE OR OTHER DEALINGS IN THE DATA." + NL + "*****************************************************************************/" + NL + "" + NL + "/**" + NL + " * ";
  protected final String TEXT_2 = " Desyre META Source" + NL + " * @generated" + NL + " */" + NL + "  " + NL + "#include <";
  protected final String TEXT_3 = ">" + NL + "" + NL + "using namespace ";
  protected final String TEXT_4 = ";" + NL + "" + NL + "/**************************************************************" + NL + " **             PUBLIC INTERFACE" + NL + " *************************************************************/" + NL;
  protected final String TEXT_5 = NL;
  protected final String TEXT_6 = "::";
  protected final String TEXT_7 = "(sc_module_name nm ,  IP_Configuration& configuration)" + NL + ": IP_Interface(nm,configuration)" + NL + "{" + NL + "\tTRACE_DEBUG(\"Instance of ";
  protected final String TEXT_8 = "\");";
  protected final String TEXT_9 = NL + "\t// TD Attributes initialization" + NL + "\t//Get model configurable parameters" + NL + "\trate_ \t= 1;" + NL + "\tdelay_ \t= 0;" + NL + "\tif(configuration.isAttributePresent(\"timestep_S\")){" + NL + "\t\tTm_ = sca_core::sca_time(configuration.getFloatAttributeValue(\"timestep_S\"), SC_SEC);" + NL + "\t}" + NL + "\telse{" + NL + "\t\tTm_ = sca_core::sca_time(0.02,SC_SEC);" + NL + "\t}" + NL + "\t";
  protected final String TEXT_10 = "\t" + NL + "" + NL + "\tbody_ = new ";
  protected final String TEXT_11 = "Body(\"";
  protected final String TEXT_12 = "Body\", configuration);" + NL + "\t " + NL + "\t//Connecting the component body output" + NL + " }" + NL + " " + NL + " void ";
  protected final String TEXT_13 = "::before_end_of_elaboration(void){" + NL + "\tTRACE_DEBUG(\"before_end_of_elaboration()\");" + NL + " ";
  protected final String TEXT_14 = NL + "\t// TD Inputs" + NL + "\t";
  protected final String TEXT_15 = "->configure(Tm_,  delay_, rate_);" + NL + "\tsca_tdf::sca_signal<";
  protected final String TEXT_16 = ">& ";
  protected final String TEXT_17 = "_Sig = ";
  protected final String TEXT_18 = "->getDtOutputSignal();" + NL + "\tbody_->";
  protected final String TEXT_19 = "(";
  protected final String TEXT_20 = "_Sig);" + NL + " \t\t\t";
  protected final String TEXT_21 = NL + " \t";
  protected final String TEXT_22 = "->configure(Tm_,  delay_, rate_);" + NL + "\tsca_tdf::sca_signal<";
  protected final String TEXT_23 = ">& ";
  protected final String TEXT_24 = "_Sig = ";
  protected final String TEXT_25 = "->getDtInputSignal();" + NL + "\tbody_->";
  protected final String TEXT_26 = "(";
  protected final String TEXT_27 = "_Sig);" + NL + " \t\t\t";
  protected final String TEXT_28 = NL + "\t//Connecting the component body input (LSF = Cont)" + NL + "\tsca_lsf::sca_signal& ";
  protected final String TEXT_29 = "_Sig = ";
  protected final String TEXT_30 = "->getCtOutputSignal();" + NL + "\tbody_->";
  protected final String TEXT_31 = "(";
  protected final String TEXT_32 = "_Sig);" + NL + " \t\t\t";
  protected final String TEXT_33 = NL + "\t//Connecting the component body output" + NL + "\tsca_lsf::sca_signal& ";
  protected final String TEXT_34 = "_Sig = ";
  protected final String TEXT_35 = "->getCtInputSignal();" + NL + "\tbody_->";
  protected final String TEXT_36 = "(";
  protected final String TEXT_37 = "_Sig);" + NL + " \t\t\t";
  protected final String TEXT_38 = NL + "\tsc_core::sc_signal<";
  protected final String TEXT_39 = ">& ";
  protected final String TEXT_40 = "_Sig = ";
  protected final String TEXT_41 = "->getDeOutputSignal();" + NL + "\tbody_->";
  protected final String TEXT_42 = "(";
  protected final String TEXT_43 = "_Sig);\t \t\t\t" + NL + " \t\t\t";
  protected final String TEXT_44 = NL + "\tsc_core::sc_signal<";
  protected final String TEXT_45 = ">& ";
  protected final String TEXT_46 = "_Sig = ";
  protected final String TEXT_47 = "->getDeInputSignal();" + NL + "\tbody_->";
  protected final String TEXT_48 = "(";
  protected final String TEXT_49 = "_Sig);\t \t\t\t" + NL + " \t\t\t";
  protected final String TEXT_50 = NL + " " + NL + " }" + NL + " ";
  protected final String TEXT_51 = NL + " ";

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
     	
	METAJetTemplateArgument arg = (METAJetTemplateArgument)argument;
 	Component component = arg.component;
 	DesyrePathHelper desyrePathHelper = arg.desyrePathHelper;
 	
 	String componentIPName = DesyreNamesHelper.getDesyreComponentName(component);
 	String componentSpeedsName = DesyreNamesHelper.getSpeedsComponentName(component);
 	String systemName = DesyreNamesHelper.getSpeedsComponentName(desyrePathHelper.getDesyreSystem().getRoot());
 	String viewName = arg.view.getName();
 	String scaleFactor = arg.scaleFactor;

    stringBuffer.append(TEXT_1);
    stringBuffer.append(componentIPName);
    stringBuffer.append(TEXT_2);
    stringBuffer.append(desyrePathHelper.getRelativePathFromRoot(desyrePathHelper.getWrapperHeaderFile(component, viewName)));
    stringBuffer.append(TEXT_3);
    stringBuffer.append(DesyreNamesHelper.getDesyreComponentQNamespace(component));
    stringBuffer.append(TEXT_4);
    stringBuffer.append(TEXT_5);
    stringBuffer.append(viewName);
    stringBuffer.append(TEXT_6);
    stringBuffer.append(viewName);
    stringBuffer.append(TEXT_7);
    stringBuffer.append(componentIPName);
    stringBuffer.append(TEXT_8);
    
	boolean bHasTDPorts = false;
	
	for( Port port : component.getPort())
	{
		if( port.getKind() == PortKind.DISCRETE_PERIODIC )
		{
			bHasTDPorts = true;
			break;
		}
	}
	
	if( bHasTDPorts )
	{
    stringBuffer.append(TEXT_9);
    }
    stringBuffer.append(TEXT_10);
    stringBuffer.append(componentSpeedsName);
    stringBuffer.append(TEXT_11);
    stringBuffer.append(componentSpeedsName);
    stringBuffer.append(TEXT_12);
    stringBuffer.append(viewName);
    stringBuffer.append(TEXT_13);
    
 	for(Port port : component.getPort() )
 	{
 		 String portTypeString = port.getType() != null ? port.getType().getName() : "void" ;
 		if( port.getKind() == PortKind.DISCRETE_PERIODIC )
 		{
 			if( port.getDirection() == PortDirection.IN )
 			{
    stringBuffer.append(TEXT_14);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_15);
    stringBuffer.append(portTypeString);
    stringBuffer.append(TEXT_16);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_17);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_18);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_19);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_20);
    
 			}else{ // output
    stringBuffer.append(TEXT_21);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_22);
    stringBuffer.append(portTypeString);
    stringBuffer.append(TEXT_23);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_24);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_25);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_26);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_27);
    }
 		}else if( port.getKind() == PortKind.CONTINUOUS ){
 			if( port.getDirection() == PortDirection.IN )
 			{
    stringBuffer.append(TEXT_28);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_29);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_30);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_31);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_32);
    }else{
    stringBuffer.append(TEXT_33);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_34);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_35);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_36);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_37);
    } 		
 		}else if( port.getKind() == PortKind.DISCRETE_EVENT){ // EVENT
 			if( port.getDirection() == PortDirection.IN )
 			{
    stringBuffer.append(TEXT_38);
    stringBuffer.append(portTypeString);
    stringBuffer.append(TEXT_39);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_40);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_41);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_42);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_43);
    }else{
    stringBuffer.append(TEXT_44);
    stringBuffer.append(portTypeString);
    stringBuffer.append(TEXT_45);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_46);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_47);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_48);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_49);
    }
 		}
 	}
 
 
 
    stringBuffer.append(TEXT_50);
    stringBuffer.append(TEXT_51);
    return stringBuffer.toString();
  }
}
