
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.desyre.builder.wrapper.meta.jet;

import com.eu.ales.desyre.configuration.DesyreConfiguration;
import com.eu.ales.desyre.builder.wrapper.meta.*;
import com.eu.ales.desyre.model.desyre.Component;
import com.eu.ales.desyre.model.desyre.Port;
import com.eu.ales.desyre.model.desyre.PortDirection;
import com.eu.ales.desyre.model.desyre.PortKind;
import java.util.Set;
import java.util.*;
import com.eu.ales.desyre.configuration.*;

public class ComponentDesyreRpyIPInterfaceTemplate
{
  protected static String nl;
  public static synchronized ComponentDesyreRpyIPInterfaceTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    ComponentDesyreRpyIPInterfaceTemplate result = new ComponentDesyreRpyIPInterfaceTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "/*****************************************************************************" + NL + "Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy" + NL + "Developed with the sponsorship of the Defense Advanced Research Projects Agency (DARPA)." + NL + "" + NL + "Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074." + NL + "" + NL + "THE DATA IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR" + NL + "IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY," + NL + "FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE" + NL + "AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE" + NL + "FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF" + NL + "CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE" + NL + "DATA OR THE USE OR OTHER DEALINGS IN THE DATA." + NL + "*****************************************************************************/" + NL + "  " + NL + "#ifndef ";
  protected final String TEXT_2 = "_";
  protected final String TEXT_3 = "_INTERFACE_H " + NL + "#define ";
  protected final String TEXT_4 = "_";
  protected final String TEXT_5 = "_INTERFACE_H " + NL + "" + NL + "#include <DESYRE.h>" + NL + " ";
  protected final String TEXT_6 = NL + NL + "/*" + NL + "* Rhapsody Interface inclusion" + NL + "*/" + NL + "#include <ThickConnectors/RH_Interface/interface/ServiceIf.h>" + NL + "" + NL + "/*" + NL + "* META Data types" + NL + "*/" + NL + "" + NL + "// library namespace" + NL + "namespace ";
  protected final String TEXT_7 = " {" + NL + "\t" + NL + "\tnamespace ";
  protected final String TEXT_8 = " {" + NL + "" + NL + "\t\tclass IP_Interface {" + NL + "" + NL + " \t\tpublic: " + NL + "  \t\t/**************************************************************" + NL + "   \t\t**             PORTS " + NL + "   \t\t*************************************************************/ \t\t\t \t" + NL + "\t";
  protected final String TEXT_9 = "\t \t\t\t" + NL + "\t\t/** Interaction point */" + NL + "\t\t";
  protected final String TEXT_10 = "<thickconnectors::";
  protected final String TEXT_11 = "::ServiceIf<";
  protected final String TEXT_12 = "> > ";
  protected final String TEXT_13 = ";" + NL + "\t" + NL + "\t";
  protected final String TEXT_14 = "    " + NL + "\t\t" + NL + "\t\t  " + NL + "\t  /************************************************************** " + NL + "\t   **             CONSTRUCTOR " + NL + "\t   *************************************************************/" + NL + "\t   " + NL + "  \t// Constructor\t" + NL + "\tIP_Interface(sc_module_name nm,IP_Configuration& configuration) :" + NL + "\t\t";
  protected final String TEXT_15 = "\t \t" + NL + "\t\t\t";
  protected final String TEXT_16 = "(\"";
  protected final String TEXT_17 = "\")";
  protected final String TEXT_18 = NL + "\t\t";
  protected final String TEXT_19 = "\t" + NL + "\t\t{};" + NL + " \t\t// Destructor" + NL + "\t  virtual ~IP_Interface() {};" + NL + "\t  };" + NL + "\t}; // IP namespace" + NL + "}; // lib namespace" + NL + "#endif";

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
	METAJetTemplateArgument arg = (METAJetTemplateArgument)argument;
 	DesyrePathHelper desyrePathHelper = arg.desyrePathHelper;
	Component component = arg.component;

 	String componentIPName = DesyreNamesHelper.getDesyreComponentName(component);
 	String componentSpeedsName = DesyreNamesHelper.getSpeedsComponentName(component);
 	String packageName = (component.getDeclarationZone()!=null) ? component.getDeclarationZone().getName() : "";
 	 


    stringBuffer.append(TEXT_1);
    stringBuffer.append(packageName.toUpperCase());
    stringBuffer.append(TEXT_2);
    stringBuffer.append(componentSpeedsName.toUpperCase());
    stringBuffer.append(TEXT_3);
    stringBuffer.append(packageName.toUpperCase());
    stringBuffer.append(TEXT_4);
    stringBuffer.append(componentSpeedsName.toUpperCase());
    stringBuffer.append(TEXT_5);
    
	/*
	 * for each interaction point collect channel name to put in a set 
	 * and generate the proper header include file 
	 */
	List<String> channelType = new LinkedList<String>();	
	for( Port interactionPoint : component.getPort() ) {
		channelType.add( interactionPoint.getType().getName() );
	}

    stringBuffer.append(TEXT_6);
    stringBuffer.append(DesyreNamesHelper.getDesyreComponentLibraryNamespace(component));
    stringBuffer.append(TEXT_7);
    stringBuffer.append(DesyreNamesHelper.getDesyreComponentNamespace(component));
    stringBuffer.append(TEXT_8);
    	/*
		* Define ports and exports of the component
		*/
		for( Port intPoint : component.getPort() )
		{
			String portSCString; // sc_port or sc_export
			String portChannelKindString; //flowdiscretechannel or floweventchannel
			String portTypeString; // data types
			
			/* select system c port type */
			if( intPoint.getDirection() == PortDirection.IN )
	 		{ 	
	 			portSCString = "sc_export";	
			}else{
				portSCString = "sc_port";
			}
			
			/* select channel type */
			if( intPoint.getKind() == PortKind.RHAPSODY_4METAII )
			{
				portChannelKindString = "rhinterface";
			}
			else{
				portChannelKindString = "unknowninterface";
			}
			
			/* port type */
			portTypeString = intPoint.getType().getName();
		
	 	
    stringBuffer.append(TEXT_9);
    stringBuffer.append(portSCString);
    stringBuffer.append(TEXT_10);
    stringBuffer.append(portChannelKindString);
    stringBuffer.append(TEXT_11);
    stringBuffer.append(portTypeString);
    stringBuffer.append(TEXT_12);
    stringBuffer.append(intPoint.getName());
    stringBuffer.append(TEXT_13);
    
		}
	
    stringBuffer.append(TEXT_14);
    
		int i = 0;
		for( Port intPoint : component.getPort() ){
			i++;
			String comma = (i!=component.getPort().size())?",":"";	
		
    stringBuffer.append(TEXT_15);
    stringBuffer.append(intPoint.getName());
    stringBuffer.append(TEXT_16);
    stringBuffer.append(intPoint.getName());
    stringBuffer.append(TEXT_17);
    stringBuffer.append(comma);
    stringBuffer.append(TEXT_18);
    
		}
		
    stringBuffer.append(TEXT_19);
    return stringBuffer.toString();
  }
}
