
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.desyre.builder.wrapper.meta.jet;

import java.util.*;
import com.eu.ales.desyre.model.desyre.*;
import com.eu.ales.desyre.builder.wrapper.meta.*;
import java.lang.System;
import com.eu.ales.desyre.builder.wrapper.*;
import com.eu.ales.desyre.configuration.*;

public class ComponentDesyreRpyInterfaceTemplate
{
  protected static String nl;
  public static synchronized ComponentDesyreRpyInterfaceTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    ComponentDesyreRpyInterfaceTemplate result = new ComponentDesyreRpyInterfaceTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "<spirit:component xmlns:spirit=\"http://www.spiritconsortium.org/XMLSchema/SPIRIT/1.4\" " + NL + "\txmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"" + NL + "\txsi:schemaLocation=\"http://www.spiritconsortium.org/XMLSchema/SPIRIT/1.4 http://www.spiritconsortium.org/XMLSchema/SPIRIT/1.4/index.xsd\">" + NL + "\t<spirit:vendor>ALES</spirit:vendor> " + NL + "    <spirit:library>";
  protected final String TEXT_2 = "</spirit:library> " + NL + "\t<spirit:name>";
  protected final String TEXT_3 = "</spirit:name> " + NL + "\t<spirit:version>1.0</spirit:version> " + NL + "\t<spirit:model> " + NL + "\t\t<spirit:views>";
  protected final String TEXT_4 = "\t \t\t\t" + NL + "\t\t\t<spirit:view> " + NL + "\t\t\t\t<spirit:name>";
  protected final String TEXT_5 = "</spirit:name> " + NL + "\t\t\t\t<spirit:envIdentifier>systemCsource:ModelBuilder:ALES</spirit:envIdentifier>";
  protected final String TEXT_6 = NL + "\t\t\t\t<spirit:hierarchyRef spirit:vendor=\"ALES\" spirit:library=\"";
  protected final String TEXT_7 = "\" spirit:name=\"";
  protected final String TEXT_8 = "_design\" spirit:version=\"1.0\"/>";
  protected final String TEXT_9 = NL + "\t\t\t\t<spirit:modelName>Hardware specific name of the model</spirit:modelName> <!--optional.-->";
  protected final String TEXT_10 = NL + "\t\t\t\t<spirit:parameter spirit:name=\"";
  protected final String TEXT_11 = "\" spirit:resolve=\"dependent\" spirit:dependency=\"";
  protected final String TEXT_12 = "\"></spirit:parameter>";
  protected final String TEXT_13 = NL + "\t\t\t</spirit:view>\t\t\t";
  protected final String TEXT_14 = NL + NL + "\t\t\t\t\t\t\t\t\t" + NL + "\t\t</spirit:views> " + NL + "" + NL + "\t\t<spirit:ports>" + NL + "\t\t";
  protected final String TEXT_15 = "\t\t" + NL + "\t\t\t<spirit:port>" + NL + "\t\t\t\t<spirit:name>";
  protected final String TEXT_16 = "</spirit:name>";
  protected final String TEXT_17 = NL + "\t\t\t\t<spirit:direction>in</spirit:direction>" + NL + "\t\t\t\t<spirit:export>true</spirit:export>";
  protected final String TEXT_18 = "\t\t" + NL + "\t\t\t\t<spirit:direction>out</spirit:direction>" + NL + "\t\t\t\t<spirit:export>false</spirit:export>";
  protected final String TEXT_19 = "\t\t\t\t\t\t\t\t\t" + NL + "\t\t\t\t<spirit:portAccessHandle>thickconnectors::";
  protected final String TEXT_20 = "::";
  protected final String TEXT_21 = "</spirit:portAccessHandle>" + NL + "\t\t\t</spirit:port>";
  protected final String TEXT_22 = "\t\t" + NL + "\t\t</spirit:ports>" + NL + "\t\t<spirit:modelParameters>" + NL + "\t\t";
  protected final String TEXT_23 = NL + "\t\t\t\t<spirit:modelParameter spirit:name=\"";
  protected final String TEXT_24 = "\" spirit:id=\"";
  protected final String TEXT_25 = "\" spirit:resolve=\"user\" spirit:dataType=\"";
  protected final String TEXT_26 = "\">";
  protected final String TEXT_27 = "</spirit:modelParameter>";
  protected final String TEXT_28 = NL + "\t\t</spirit:modelParameters>" + NL + "\t</spirit:model> " + NL + "</spirit:component>" + NL + "  ";
  protected final String TEXT_29 = NL + "  ";

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
	METAJetTemplateArgument hsarg = (METAJetTemplateArgument)argument;
	Component component = hsarg.component;
 	DesyrePathHelper desyrePathHelper = ((METAJetTemplateArgument)argument).desyrePathHelper;
 	String componentName = DesyreNamesHelper.getDesyreComponentNamespace(component);

 	String systemNS = DesyreNamesHelper.getDesyreComponentLibraryNamespace(component);

	boolean isTraceComponent = desyrePathHelper.isTraceComponent(component);
	boolean isHierarchicalComponent = !component.getPart().isEmpty();


    stringBuffer.append(TEXT_1);
    stringBuffer.append(DesyreNamesHelper.getDesyreComponentLibraryNamespace(component));
    stringBuffer.append(TEXT_2);
    stringBuffer.append(DesyreNamesHelper.getDesyreComponentNamespace(component));
    stringBuffer.append(TEXT_3);
    
		for( View v : component.getView() ) {
			String viewName = v.getName().toLowerCase();

    stringBuffer.append(TEXT_4);
    stringBuffer.append(DesyreNamesHelper.getDesyreComponentViewQNamespace(component, viewName));
    stringBuffer.append(TEXT_5);
    				if( isHierarchicalComponent ) {

    stringBuffer.append(TEXT_6);
    stringBuffer.append(systemNS);
    stringBuffer.append(TEXT_7);
    stringBuffer.append(componentName);
    stringBuffer.append(TEXT_8);
    				
				}else{

    stringBuffer.append(TEXT_9);
    				
				}
				
				for( Parameter prm : component.getParameter() ) {

    stringBuffer.append(TEXT_10);
    stringBuffer.append(prm.getName());
    stringBuffer.append(TEXT_11);
    stringBuffer.append(prm.getName().toUpperCase());
    stringBuffer.append(TEXT_12);
    
				}

    stringBuffer.append(TEXT_13);
    		} // end-for

    stringBuffer.append(TEXT_14);
    
			for( Port port : component.getPort() ) {

    stringBuffer.append(TEXT_15);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_16);
    
				if( port.getDirection() == PortDirection.IN ) {

    stringBuffer.append(TEXT_17);
    
				} else {

    stringBuffer.append(TEXT_18);
    
				}
				String portKindString;

				if(port.getKind() == PortKind.RHAPSODY_4METAII){
					portKindString = "rhinterface";
				}else{
					portKindString = "unknown";
				}				
				String typeString = port.getType() != null ? "ServiceIf%lt" + port.getType().getName() + "%gt" : "ServiceIf%lt" + "void" + "%gt";

    stringBuffer.append(TEXT_19);
    stringBuffer.append(portKindString);
    stringBuffer.append(TEXT_20);
    stringBuffer.append(typeString);
    stringBuffer.append(TEXT_21);
    
			}

    stringBuffer.append(TEXT_22);
    
		
		for( Parameter prm : component.getParameter() ) {
			DataType paramType = prm.getType();
			Litteral paramVal = prm.getValue();			

    stringBuffer.append(TEXT_23);
    stringBuffer.append(prm.getName());
    stringBuffer.append(TEXT_24);
    stringBuffer.append(prm.getName().toUpperCase());
    stringBuffer.append(TEXT_25);
    stringBuffer.append(paramType.getName());
    stringBuffer.append(TEXT_26);
    stringBuffer.append(paramVal.getValue().toString());
    stringBuffer.append(TEXT_27);
    
		}
		
		
    stringBuffer.append(TEXT_28);
    stringBuffer.append(TEXT_29);
    return stringBuffer.toString();
  }
}
