
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.desyre.builder.wrapper.meta.jet;

import java.util.*;
import com.eu.ales.desyre.model.desyre.*;
import com.eu.ales.desyre.builder.wrapper.meta.*;
import java.lang.System;
import com.eu.ales.desyre.builder.wrapper.*;
import com.eu.ales.desyre.configuration.*;

public class ComponentSpiritDesignConfigTemplate
{
  protected static String nl;
  public static synchronized ComponentSpiritDesignConfigTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    ComponentSpiritDesignConfigTemplate result = new ComponentSpiritDesignConfigTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "<spirit:designConfiguration xmlns:spirit=\"http://www.spiritconsortium.org/XMLSchema/SPIRIT/1.4\" " + NL + "\txmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"" + NL + "\txsi:schemaLocation=\"http://www.spiritconsortium.org/XMLSchema/SPIRIT/1.4 http://www.spiritconsortium.org/XMLSchema/SPIRIT/1.4/index.xsd\">" + NL + "\t" + NL + "\t<spirit:vendor>ALES</spirit:vendor>" + NL + "\t<spirit:library>";
  protected final String TEXT_2 = "</spirit:library>" + NL + "\t<spirit:name>";
  protected final String TEXT_3 = "_designConfig</spirit:name>" + NL + "\t<spirit:version>1.0</spirit:version>" + NL + "\t" + NL + "\t<spirit:designRef spirit:vendor=\"ALES\" spirit:library=\"";
  protected final String TEXT_4 = "\" spirit:name=\"";
  protected final String TEXT_5 = "_design\" spirit:version=\"1.0\"/>" + NL + "\t";
  protected final String TEXT_6 = NL + "\t\t<spirit:viewConfiguration>" + NL + "\t\t\t<spirit:instanceName>";
  protected final String TEXT_7 = "</spirit:instanceName>" + NL + "\t\t\t<spirit:viewName>";
  protected final String TEXT_8 = "</spirit:viewName>" + NL + "\t\t</spirit:viewConfiguration>" + NL + "\t\t";
  protected final String TEXT_9 = "\t" + NL + "" + NL + "\t<spirit:description>String</spirit:description>" + NL + "\t<spirit:vendorExtensions/>" + NL + "</spirit:designConfiguration>";
  protected final String TEXT_10 = NL;

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
	METAJetTemplateArgument hsarg = (METAJetTemplateArgument)argument;
	Component component = hsarg.component;
	DesyrePathHelper desyrePathHelper = ((METAJetTemplateArgument)argument).desyrePathHelper;

 	String componentName = DesyreNamesHelper.getDesyreComponentNamespace(component);
 	
 	
 	String libraryNS = DesyreNamesHelper.getDesyreComponentLibraryNamespace(component);


    stringBuffer.append(TEXT_1);
    stringBuffer.append(libraryNS);
    stringBuffer.append(TEXT_2);
    stringBuffer.append(DesyreNamesHelper.getDesyreComponentName(component));
    stringBuffer.append(TEXT_3);
    stringBuffer.append(libraryNS);
    stringBuffer.append(TEXT_4);
    stringBuffer.append(componentName);
    stringBuffer.append(TEXT_5);
    
		for( ComponentProperty prop : component.getPart() ){ 
		 	//String viewName = DesyreBuilderWrapperHelper.getViewName(prop.getType(), hsarg.view);
		 	String propName = prop.getName();
		 	String qnameWithSingleColon = "None";
		 	View propView = prop.getView();
			if(propView != null){
				String viewName = propView.getName();
				Component type = prop.getType();
				
				//FIXME Patch to fix the simulink or modelica view name
				String completePropType = "";				
				if(prop.getType() != null){
					if(prop.getType().getTarget() != null){
						if(prop.getType().getTarget().getBxURI() != null){
							completePropType += prop.getType().getTarget().getBxURI();
						}
						if(prop.getType().getTarget().getWxURI() != null){
							completePropType += prop.getType().getTarget().getWxURI();
						}
					}
				}
				
				if(completePropType.contains("simulink://") || completePropType.contains("rtw://") || completePropType.contains("smk://")){
					viewName = "rtw";
				}
				
				qnameWithSingleColon = DesyreNamesHelper.getDesyreComponentViewQNamespace(type, viewName);
				
				if(completePropType.contains("modelica://") || completePropType.contains("fmi://") ){
					qnameWithSingleColon = "modelicalib::dessmodelicawrapper::Basic";
				}				
				//////////////////////////////////////////////////////////////////////////////
				
			}
			else{
				qnameWithSingleColon = "NotWorking";
			}

    stringBuffer.append(TEXT_6);
    stringBuffer.append(prop.getName());
    stringBuffer.append(TEXT_7);
    stringBuffer.append(qnameWithSingleColon);
    stringBuffer.append(TEXT_8);
    
		}

    stringBuffer.append(TEXT_9);
    stringBuffer.append(TEXT_10);
    return stringBuffer.toString();
  }
}
