
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.desyre.builder.wrapper.meta.jet;

import java.util.*;
import com.eu.ales.desyre.model.desyre.*;
import com.eu.ales.desyre.builder.wrapper.meta.*;
import java.lang.System;
import com.eu.ales.desyre.builder.wrapper.*;
import com.eu.ales.desyre.configuration.*;

public class ComponentSpiritDesignTemplate
{
  protected static String nl;
  public static synchronized ComponentSpiritDesignTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    ComponentSpiritDesignTemplate result = new ComponentSpiritDesignTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "<spirit:design xmlns:spirit=\"http://www.spiritconsortium.org/XMLSchema/SPIRIT/1.4\" " + NL + "\txmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"" + NL + "\txsi:schemaLocation=\"http://www.spiritconsortium.org/XMLSchema/SPIRIT/1.4 http://www.spiritconsortium.org/XMLSchema/SPIRIT/1.4/index.xsd\">" + NL + "" + NL + "\t<spirit:vendor>ALES</spirit:vendor> " + NL + "\t<spirit:library>";
  protected final String TEXT_2 = "</spirit:library> " + NL + "\t<spirit:name>";
  protected final String TEXT_3 = "_design</spirit:name>" + NL + "\t<spirit:version>1.0</spirit:version>" + NL + "\t" + NL + "\t<spirit:componentInstances> " + NL;
  protected final String TEXT_4 = NL + "\t\t<spirit:componentInstance> " + NL + "\t\t\t<spirit:instanceName>";
  protected final String TEXT_5 = "</spirit:instanceName> " + NL + "\t\t\t<spirit:componentRef spirit:vendor=\"ALES\" spirit:library=\"";
  protected final String TEXT_6 = "\" spirit:name=\"";
  protected final String TEXT_7 = "\" spirit:version=\"1.0\" />" + NL + "\t\t\t<spirit:configuration>\t\t\t     \t\t\t\t";
  protected final String TEXT_8 = NL + "\t\t\t\t<spirit:configurableElement spirit:referenceId=\"FMU_FILE_PATH\" > <spirit:configurableElementValue>METAII\\ModelicaFMU\\";
  protected final String TEXT_9 = ".fmu</spirit:configurableElementValue> </spirit:configurableElement>" + NL + "\t\t\t\t<spirit:configurableElement spirit:referenceId=\"N_OUTPUTS\" > <spirit:configurableElementValue>";
  protected final String TEXT_10 = "</spirit:configurableElementValue> </spirit:configurableElement>";
  protected final String TEXT_11 = NL + "\t\t\t\t<spirit:configurableElement spirit:referenceId=\"TEMPLATE_PORT_TYPE\"> <spirit:configurableElementValue>";
  protected final String TEXT_12 = "</spirit:configurableElementValue> </spirit:configurableElement>";
  protected final String TEXT_13 = NL + "\t\t\t\t<spirit:configurableElement spirit:referenceId=\"";
  protected final String TEXT_14 = "\">" + NL + "\t\t\t\t\t<spirit:configurableElementValue>";
  protected final String TEXT_15 = "</spirit:configurableElementValue>" + NL + "\t            </spirit:configurableElement>";
  protected final String TEXT_16 = NL + "\t\t\t</spirit:configuration>" + NL + "\t\t</spirit:componentInstance>\t" + NL;
  protected final String TEXT_17 = "\t" + NL + "\t</spirit:componentInstances>" + NL + "\t" + NL + "\t" + NL + "\t<spirit:adHocConnections>\t";
  protected final String TEXT_18 = NL + "\t\t<spirit:adHocConnection> " + NL + "\t\t\t<spirit:portReference spirit:componentRef=\"";
  protected final String TEXT_19 = "\"  spirit:portRef=\"";
  protected final String TEXT_20 = "\" ";
  protected final String TEXT_21 = "/> " + NL + "\t\t\t<spirit:portReference spirit:componentRef=\"";
  protected final String TEXT_22 = "\"  spirit:portRef=\"";
  protected final String TEXT_23 = "\" ";
  protected final String TEXT_24 = "/> " + NL + "\t\t</spirit:adHocConnection>";
  protected final String TEXT_25 = NL + "\t</spirit:adHocConnections>" + NL + "\t" + NL + "\t<spirit:hierConnections>";
  protected final String TEXT_26 = "\t\t" + NL + "\t\t<spirit:hierConnection spirit:interfaceName=\"";
  protected final String TEXT_27 = "\" >" + NL + "\t\t\t<spirit:componentRef>";
  protected final String TEXT_28 = "</spirit:componentRef> " + NL + "\t\t\t<spirit:interfaceRef>";
  protected final String TEXT_29 = "</spirit:interfaceRef> " + NL + "\t\t</spirit:hierConnection>\t" + NL;
  protected final String TEXT_30 = " " + NL + "\t</spirit:hierConnections>" + NL + "\t\t" + NL + "</spirit:design> ";
  protected final String TEXT_31 = NL + " ";

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
	METAJetTemplateArgument hsarg = (METAJetTemplateArgument)argument;
	Component component = hsarg.component;
 	DesyrePathHelper desyrePathHelper = ((METAJetTemplateArgument)argument).desyrePathHelper;
 	String componentName = DesyreNamesHelper.getDesyreComponentNamespace(component);

 	String libraryNS = DesyreNamesHelper.getDesyreComponentLibraryNamespace(component);
 	

    stringBuffer.append(TEXT_1);
    stringBuffer.append(libraryNS);
    stringBuffer.append(TEXT_2);
    stringBuffer.append(componentName);
    stringBuffer.append(TEXT_3);
    	
	//String topLibraryName = component.getDeclarationZone().getName().toLowerCase();
	//String topTypeName = componentName;
	// Missing main system here!! (for hierarchical components	

	//FIXME: AM: Patch to fix modelica output connection (get index to solve the prpblem)
	int numModOutputLinks = 0;
	Map<String, String> thickConnectorsTemplateTypeMap = new HashMap<String, String>();
    for (Link link : component.getLink()){
		if(link.isHierarchicalLink()){
			continue;
		}
		
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		//Retriving Link Information
		LinkEnd 			linkEnd0 = null;
		LinkEnd 			linkEnd1 = null;
		ComponentProperty 	linkEnd0Part = null;
		ComponentProperty 	linkEnd1Part = null;		
		Component 			linkEnd0PartType = null;
		Component 			linkEnd1PartType = null;
		Target				linkEnd0PartTypeTarget = null;
		Target				linkEnd1PartTypeTarget = null;
		
		linkEnd0 = link.getEnd().get(0);
		linkEnd1 = link.getEnd().get(1);
		
		if(linkEnd0 != null){
			linkEnd0Part = linkEnd0.getPart();
		}
		
		if(linkEnd1 != null){
			linkEnd1Part = linkEnd1.getPart();
		}
		
		if(linkEnd0Part != null){
			linkEnd0PartType = linkEnd0Part.getType();
		}
		
		if(linkEnd1Part != null){
			linkEnd1PartType = linkEnd1Part.getType();
		}
		
		if(linkEnd0PartType != null){
			linkEnd0PartTypeTarget = linkEnd0PartType.getTarget();
		}
		
		if(linkEnd1PartType != null){
			linkEnd1PartTypeTarget = linkEnd1PartType.getTarget();
		}
		
		//FMI Connection Index Computation
		String completeCompPath = "";
		if(linkEnd0PartTypeTarget != null){			
			if(linkEnd0PartTypeTarget.getBxURI() != null){
				completeCompPath += linkEnd0PartTypeTarget.getBxURI();
			}
			if(linkEnd0PartTypeTarget.getWxURI() != null){
				completeCompPath += linkEnd0PartTypeTarget.getWxURI();
			}
		}
		if(linkEnd1PartTypeTarget != null){
			if(linkEnd1PartTypeTarget.getBxURI() != null){
				completeCompPath += linkEnd1PartTypeTarget.getBxURI();
			}
			if(linkEnd1PartTypeTarget.getWxURI() != null){
				completeCompPath += linkEnd1PartTypeTarget.getWxURI();
			}
		}
		
		if(completeCompPath.contains("modelica://") || completeCompPath.contains("fmi://") ){
			numModOutputLinks++;
		}
		
		//Thick Connections connection
		String 		portTypeName 	= 	"";
		boolean 	updatePortType 	= 	false;
		DataType 	portType 		=	null;
		
		if(linkEnd0PartType == null || linkEnd0PartType.getUri() == null){			
		}
		else{
			if(!linkEnd0PartType.getUri().toLowerCase().contains("thickconnectors") && (link.getEnd().get(0).getPort().getType()!=null) ){
				portType = link.getEnd().get(0).getPort().getType();
				if(portType.getName() == null){
					portTypeName = "double";
				}
				else{
					portTypeName = portType.getName();
				}				
				updatePortType = true;
			}
		}
		
		if(linkEnd1PartType == null || linkEnd1PartType.getUri() == null){			
		}
		else{
			if(!linkEnd1PartType.getUri().toLowerCase().contains("thickconnectors") && (link.getEnd().get(1).getPort().getType()!=null) ){
				portType = link.getEnd().get(1).getPort().getType();
				if(portType.getName() == null){
					portTypeName = "double";
				}
				else{
					portTypeName = portType.getName();
				}				
				updatePortType = true;
			}
		}
			
		if(updatePortType){
			//Insert thick connector into the map
			portTypeName = portTypeName.equals("float")? "double": portTypeName;
			
			if((linkEnd0PartType.getUri().toLowerCase().contains("thickconnectors")) && (portType!=null)){				
				thickConnectorsTemplateTypeMap.put(linkEnd0Part.getName(), portTypeName);				
			}
			
			if((linkEnd1PartType.getUri().toLowerCase().contains("thickconnectors")) && (portType!=null)){
				thickConnectorsTemplateTypeMap.put(linkEnd1PartType.getName(), portTypeName);				
			}
		}
	}
	//////////////////////////////////////////////////////////////////////////////////////////////////////////

	for (ComponentProperty prop : component.getPart()){
		String libraryName = DesyreNamesHelper.getDesyreComponentLibraryNamespace(prop.getType());
		String typeName = DesyreNamesHelper.getDesyreComponentNamespace(prop.getType());
	
		//FIXME AM: PATH to set the modelica/ FMI components library name and typename
		Component 			partType = null;
		Target				partTypeTarget = null;
		
		partType = prop.getType();
		
		if(partType != null){
			partTypeTarget = partType.getTarget();
		}

		String completePropType = "";
		if(partTypeTarget != null){
			if(partTypeTarget.getBxURI() != null){
				completePropType += partTypeTarget.getBxURI();
			}
			if(partTypeTarget.getWxURI() != null){
				completePropType += partTypeTarget.getWxURI();
			}
		}
				
		if(completePropType.contains("modelica://") || completePropType.contains("fmu://") ){
			libraryName = "modelicalib";
			typeName = "dessmodelicawrapper";
		}
		//////////////////////////////////////////////////////////////////////////////////////////
	

    stringBuffer.append(TEXT_4);
    stringBuffer.append(prop.getName());
    stringBuffer.append(TEXT_5);
    stringBuffer.append(libraryName);
    stringBuffer.append(TEXT_6);
    stringBuffer.append(typeName);
    stringBuffer.append(TEXT_7);
     	
		//FIXME: AM: patch to add parameters to the modelica components
		if(libraryName.equals("modelicalib") && (partTypeTarget != null)){		
				String modelicaWsPath = partTypeTarget.getWxURI();
				String[] splittedPath = modelicaWsPath.split("://");
				String fmuName = splittedPath[1].replace("/", "_");		

    stringBuffer.append(TEXT_8);
    stringBuffer.append(fmuName);
    stringBuffer.append(TEXT_9);
    stringBuffer.append(numModOutputLinks);
    stringBuffer.append(TEXT_10);
    
		}
		
		if(libraryName.toLowerCase().equals("thickconnectors")){
			String templateDataTypeValue = thickConnectorsTemplateTypeMap.get(prop.getName());
			if(templateDataTypeValue != null){

    stringBuffer.append(TEXT_11);
    stringBuffer.append(templateDataTypeValue);
    stringBuffer.append(TEXT_12);
    
			}
		}		
		////////////////////////////////////////////////////////////////////////////////////////
				
		if (libraryName.equals("speedschannels")) {
			// find the type of the multicast
			String multicastTypeName = null; 
			for (Link link : component.getLink()) {
				LinkEnd end0 = link.getEnd().get(0);
				LinkEnd end1 = link.getEnd().get(1);
				
				if (end0.getPart() == prop) {
					multicastTypeName = end1.getPort().getType().getName();
				}
				if (end1.getPart() == prop) {
					multicastTypeName = end0.getPort().getType().getName();
				}
			}
		}

    
		for ( ConfigurationElement elem : prop.getConfigurationElements() ) { 

    stringBuffer.append(TEXT_13);
    stringBuffer.append(elem.getReferenceId().getValue().toUpperCase());
    stringBuffer.append(TEXT_14);
    stringBuffer.append(elem.getConfigurableElementValue().getValue());
    stringBuffer.append(TEXT_15);
    
		}

    stringBuffer.append(TEXT_16);
    
	}

    stringBuffer.append(TEXT_17);
    
	//FIXME:
    int modelicaOutLnkCtr = 0;
    /////////////////////
	for (Link link : component.getLink()) {
	
		if (link.isHierarchicalLink()) 
			continue;
	
		LinkEnd end0 = link.getEnd().get(0);
		LinkEnd end1 = link.getEnd().get(1);
		
		ComponentProperty prop0 = end0.getPart();
		ComponentProperty prop1 = end1.getPart();
	
		Port port0 = end0.getPort();
		Port port1 = end1.getPort();
		
		//FIXME: AM: ////////////////////////////////////////////////////////////
		String port0Name = " ";
		String port1Name = " ";
		String comp0Name = " ";
		String comp1Name = " ";
		/////////////////////////////////////////////////////////////////////////
		
		String port0Index = " ";
		String port1Index = " ";
		
		if( port0.getSize() > 1 ) {
			int pI = end0.getPortIndex();
			port0Index = (port0.getSize() > 1) ? "spirit:left=\"" + pI + "\" spirit:right=\"" + pI + "\"" : "";
		}
			
		if( port1.getSize() > 1 ) {
			int pI = end1.getPortIndex();
			port1Index = (port1.getSize() > 1) ? "spirit:left=\"" + pI + "\" spirit:right=\"" + pI + "\"" : "";
		}
		
				//FIXME: AM /////////////////////////////////////////////////////////////
		comp0Name = prop0.getName();
		port0Name = port0.getName();
		comp1Name = prop1.getName();
		port1Name = port1.getName();
				
		String completePropType = "";
		if(prop0.getType() != null){
			if(prop0.getType().getTarget() != null){
				if(prop0.getType().getTarget().getBxURI() != null){
					completePropType += prop0.getType().getTarget().getBxURI();
				}
				if(prop0.getType().getTarget().getWxURI() != null){
					completePropType += prop0.getType().getTarget().getWxURI();
				}
							
				if(completePropType.contains("modelica://") || completePropType.contains("fmu://") ){
					//prop0 is modelica
					if(port0.getDirection() == PortDirection.IN){
						//Modelica is Input
						port0Name  = "inputs_";
						port0Index = "";
					}
					else{
						//Modelica is output
						port0Name  = "outputs_";
						port0Index = "spirit:left=\"" + modelicaOutLnkCtr + "\" spirit:right=\"" + modelicaOutLnkCtr + "\"" ;
						modelicaOutLnkCtr++;
					}
				}
			}
		}
					
		completePropType = "";
		if(prop1.getType() != null){
			if(prop1.getType().getTarget() != null){
				if(prop1.getType().getTarget().getBxURI() != null){
					completePropType += prop1.getType().getTarget().getBxURI();
				}
				if(prop1.getType().getTarget().getWxURI() != null){
					completePropType += prop1.getType().getTarget().getWxURI();
				}
							
				if(completePropType.contains("modelica://") || completePropType.contains("fmi://") ){
					//prop0 is modelica
					if(port1.getDirection() == PortDirection.IN){
						//Modelica is Input
						port1Name  = "inputs_";
						port1Index = "";
					}
					else{
						//Modelica is output
						port1Name  = "outputs_";
						port1Index = "spirit:left=\"" + modelicaOutLnkCtr + "\" spirit:right=\"" + modelicaOutLnkCtr + "\"" ;
						modelicaOutLnkCtr++;
					}
				}
			}
		}
		/////////////////////////////////////////////////////////////////////////
	
    stringBuffer.append(TEXT_18);
    stringBuffer.append(comp0Name);
    stringBuffer.append(TEXT_19);
    stringBuffer.append(port0Name);
    stringBuffer.append(TEXT_20);
    stringBuffer.append(port0Index);
    stringBuffer.append(TEXT_21);
    stringBuffer.append(comp1Name);
    stringBuffer.append(TEXT_22);
    stringBuffer.append(port1Name);
    stringBuffer.append(TEXT_23);
    stringBuffer.append(port1Index);
    stringBuffer.append(TEXT_24);
    
	}

    stringBuffer.append(TEXT_25);
    
	for (Link link : component.getLink()) {
		LinkEnd end0 = link.getEnd().get(0);
		LinkEnd end1 = link.getEnd().get(1);

		ComponentProperty prop0 = end0.getPart();
		ComponentProperty prop1 = end1.getPart();

		if (prop0 != null && prop1 != null) 
			continue;

		String partName = null, portName = null, parentPortName = null;

		if ( prop0 == null ){
			partName = end1.getPart().getName();
			portName = end1.getPort().getName();
			if (end1.getPort().getSize() > 1)
				portName += "_" + end1.getPortIndex();
			parentPortName = end0.getPort().getName();

		}else if( prop1 == null ){
			partName = end0.getPart().getName();
			portName = end0.getPort().getName();
			if (end0.getPort().getSize() > 1)
				portName += "_" + end0.getPortIndex();
			parentPortName = end1.getPort().getName();
		}

    stringBuffer.append(TEXT_26);
    stringBuffer.append(parentPortName);
    stringBuffer.append(TEXT_27);
    stringBuffer.append(partName);
    stringBuffer.append(TEXT_28);
    stringBuffer.append(portName);
    stringBuffer.append(TEXT_29);
    
	}

    stringBuffer.append(TEXT_30);
    stringBuffer.append(TEXT_31);
    return stringBuffer.toString();
  }
}
