
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.desyre.builder.wrapper.meta.jet;

import com.eu.ales.desyre.configuration.DesyreConfiguration;
import com.eu.ales.desyre.builder.wrapper.meta.*;
import com.eu.ales.desyre.model.desyre.Component;
import com.eu.ales.desyre.model.desyre.Port;
import com.eu.ales.desyre.model.desyre.PortDirection;
import com.eu.ales.desyre.model.desyre.PortKind;
import java.util.Set;
import com.eu.ales.desyre.configuration.*;

public class ComponentDesyreMETAWrapperHeaderTemplate
{
  protected static String nl;
  public static synchronized ComponentDesyreMETAWrapperHeaderTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    ComponentDesyreMETAWrapperHeaderTemplate result = new ComponentDesyreMETAWrapperHeaderTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "/*****************************************************************************" + NL + "Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy" + NL + "Developed with the sponsorship of the Defense Advanced Research Projects Agency (DARPA)." + NL + "" + NL + "Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074." + NL + "" + NL + "THE DATA IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR" + NL + "IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY," + NL + "FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE" + NL + "AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE" + NL + "FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF" + NL + "CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE" + NL + "DATA OR THE USE OR OTHER DEALINGS IN THE DATA." + NL + "*****************************************************************************/" + NL + "" + NL + "/**" + NL + " * ";
  protected final String TEXT_2 = " Desyre META Header" + NL + " * @generated" + NL + " */" + NL + " " + NL + "#ifndef ";
  protected final String TEXT_3 = "_";
  protected final String TEXT_4 = "_";
  protected final String TEXT_5 = "_H " + NL + "#define ";
  protected final String TEXT_6 = "_";
  protected final String TEXT_7 = "_";
  protected final String TEXT_8 = "_H " + NL + "" + NL + "#include <";
  protected final String TEXT_9 = ">" + NL + "" + NL + "#include <";
  protected final String TEXT_10 = "/Types/interface/LogInfo.h>" + NL + "#include <";
  protected final String TEXT_11 = "/";
  protected final String TEXT_12 = "/sc_implementation/";
  protected final String TEXT_13 = "/include/";
  protected final String TEXT_14 = "Body.h>" + NL + "" + NL + "// library namespace" + NL + "namespace ";
  protected final String TEXT_15 = " {" + NL + "// IP namespace" + NL + "namespace ";
  protected final String TEXT_16 = " {" + NL + "" + NL + "class ";
  protected final String TEXT_17 = " : public IP_Interface" + NL + "{" + NL + " public:" + NL + "  /**************************************************************" + NL + "   **             CONSTRUCTOR(S)/DESTRUCTOR" + NL + "   *************************************************************/" + NL + "  SC_HAS_PROCESS(";
  protected final String TEXT_18 = ");" + NL + "" + NL + "  // Constructor";
  protected final String TEXT_19 = NL + "  ";
  protected final String TEXT_20 = "(sc_module_name nm , IP_Configuration& configuration);" + NL + "" + NL + "" + NL + "  // Destructor" + NL + "  virtual ~";
  protected final String TEXT_21 = "(){};" + NL + "  " + NL + "  void before_end_of_elaboration(void);" + NL + "" + NL + "\t/************************************************************** " + NL + "\t **             SERVICES" + NL + "\t *************************************************************/" + NL + "" + NL + " protected:" + NL + "" + NL + " private:" + NL + "\t" + NL + "\t/**************************************************************" + NL + "\t **             PRIVATE MEMBERS" + NL + "\t **************************************************************/" + NL + "\t";
  protected final String TEXT_22 = "Body* \tbody_;";
  protected final String TEXT_23 = NL + "\t// TD Attributes" + NL + "\tdouble rate_;" + NL + "\tdouble delay_;" + NL + "\tsca_core::sca_time Tm_;" + NL + "\t";
  protected final String TEXT_24 = "\t" + NL + "\t" + NL + "\t" + NL + "\t" + NL + "}; //class declaration" + NL + "" + NL + "}; // IP namespace" + NL + "}; // lib namespace" + NL + "" + NL + "#endif";

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
	com.eu.ales.desyre.builder.wrapper.meta.METAJetTemplateArgument arg = (com.eu.ales.desyre.builder.wrapper.meta.METAJetTemplateArgument)argument;
 	Component component = arg.component;
 	DesyrePathHelper desyrePathHelper = arg.desyrePathHelper;
 	
 	String componentIPName = DesyreNamesHelper.getDesyreComponentName(component);
 	String componentSpeedsName = DesyreNamesHelper.getSpeedsComponentName(component);
 	String systemName = component.getDeclarationZone().getName();
 	
 	String rootCompoName = ((METAJetTemplateArgument)argument).sys.getRoot().getName();
 	String viewName = ((METAJetTemplateArgument)argument).view.getName();
 	
 	Set<String> includeFiles = ((METAJetTemplateArgument)argument).includeFiles;

    stringBuffer.append(TEXT_1);
    stringBuffer.append(componentSpeedsName);
    stringBuffer.append(TEXT_2);
    stringBuffer.append(systemName.toUpperCase());
    stringBuffer.append(TEXT_3);
    stringBuffer.append(componentSpeedsName.toUpperCase());
    stringBuffer.append(TEXT_4);
    stringBuffer.append(viewName.toUpperCase());
    stringBuffer.append(TEXT_5);
    stringBuffer.append(systemName.toUpperCase());
    stringBuffer.append(TEXT_6);
    stringBuffer.append(componentSpeedsName.toUpperCase());
    stringBuffer.append(TEXT_7);
    stringBuffer.append(viewName.toUpperCase());
    stringBuffer.append(TEXT_8);
    stringBuffer.append(desyrePathHelper.getRelativePathFromRoot(desyrePathHelper.getComponentIPInterfaceFile(component)));
    stringBuffer.append(TEXT_9);
    stringBuffer.append(rootCompoName);
    stringBuffer.append(TEXT_10);
    stringBuffer.append(systemName);
    stringBuffer.append(TEXT_11);
    stringBuffer.append(componentSpeedsName);
    stringBuffer.append(TEXT_12);
    stringBuffer.append(viewName);
    stringBuffer.append(TEXT_13);
    stringBuffer.append(componentSpeedsName);
    stringBuffer.append(TEXT_14);
    stringBuffer.append(DesyreNamesHelper.getDesyreComponentLibraryNamespace(component));
    stringBuffer.append(TEXT_15);
    stringBuffer.append(DesyreNamesHelper.getDesyreComponentNamespace(component));
    stringBuffer.append(TEXT_16);
    stringBuffer.append(viewName);
    stringBuffer.append(TEXT_17);
    stringBuffer.append(viewName);
    stringBuffer.append(TEXT_18);
    stringBuffer.append(TEXT_19);
    stringBuffer.append(viewName);
    stringBuffer.append(TEXT_20);
    stringBuffer.append(viewName);
    stringBuffer.append(TEXT_21);
    stringBuffer.append(componentSpeedsName);
    stringBuffer.append(TEXT_22);
    
	boolean bHasTDPorts = false;
	
	for( Port port : component.getPort())
	{
		if( port.getKind() == PortKind.DISCRETE_PERIODIC )
		{
			bHasTDPorts = true;
			break;
		}
	}
	
	if( bHasTDPorts )
	{
    stringBuffer.append(TEXT_23);
    }
    stringBuffer.append(TEXT_24);
    return stringBuffer.toString();
  }
}
