
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.desyre.builder.wrapper.meta.jet;

import com.eu.ales.desyre.configuration.DesyreConfiguration;
import com.eu.ales.desyre.builder.wrapper.meta.*;
import com.eu.ales.desyre.model.desyre.Component;
import com.eu.ales.desyre.model.desyre.Port;
import com.eu.ales.desyre.model.desyre.PortDirection;
import com.eu.ales.desyre.model.desyre.PortKind;
import java.util.Set;
import java.util.*;
import com.eu.ales.desyre.configuration.*;

public class ComponentDesyreRpyWrapperSourceTemplate
{
  protected static String nl;
  public static synchronized ComponentDesyreRpyWrapperSourceTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    ComponentDesyreRpyWrapperSourceTemplate result = new ComponentDesyreRpyWrapperSourceTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "/*****************************************************************************" + NL + "Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy" + NL + "Developed with the sponsorship of the Defense Advanced Research Projects Agency (DARPA)." + NL + "" + NL + "Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074." + NL + "" + NL + "THE DATA IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR" + NL + "IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY," + NL + "FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE" + NL + "AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE" + NL + "FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF" + NL + "CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE" + NL + "DATA OR THE USE OR OTHER DEALINGS IN THE DATA." + NL + "*****************************************************************************/" + NL + "" + NL + "/**" + NL + " * ";
  protected final String TEXT_2 = " Desyre META Source" + NL + " * @generated" + NL + " */" + NL + "  " + NL + "#include <";
  protected final String TEXT_3 = ">" + NL + "" + NL + "using namespace ";
  protected final String TEXT_4 = ";" + NL + "" + NL + "/**************************************************************" + NL + " **             CONSTRUCTOR" + NL + " *************************************************************/" + NL;
  protected final String TEXT_5 = NL;
  protected final String TEXT_6 = "::";
  protected final String TEXT_7 = "(sc_module_name nm ,  IP_Configuration& configuration)" + NL + ": IP_Interface(nm,configuration), rhapsodylib::dessrhapwrapper::Basic(nm, configuration)" + NL + "{" + NL + "\tTRACE_DBG(\"Instance of ";
  protected final String TEXT_8 = "\");" + NL + "\t";
  protected final String TEXT_9 = NL + "\tRhInputStub<";
  protected final String TEXT_10 = ">* Stub";
  protected final String TEXT_11 = " = new RhInputStub<";
  protected final String TEXT_12 = ">(\"ch";
  protected final String TEXT_13 = "\", this);" + NL + "\tsc_connect(";
  protected final String TEXT_14 = ", *Stub";
  protected final String TEXT_15 = ");" + NL + "\t" + NL + "\t";
  protected final String TEXT_16 = NL + "\tRhIntOutputStub* Stub";
  protected final String TEXT_17 = " = new RhIntOutputStub(\"";
  protected final String TEXT_18 = "\");" + NL + "\toutPortMap_.insert( make_pair(\"ch";
  protected final String TEXT_19 = "\" , Stub";
  protected final String TEXT_20 = " ) );" + NL + "\tsc_connect(Stub";
  protected final String TEXT_21 = "->OutPort, ";
  protected final String TEXT_22 = ");" + NL + "\t" + NL + "\t";
  protected final String TEXT_23 = "\t" + NL + "\t" + NL + "\tTRACE_DBG(\"Controller Meta View Created\");" + NL + "}" + NL + " " + NL + "void meta::notifyOutgoingEvent(const String& evType, std::list<String> evData){" + NL + "\tTRACE_DBG(\"notifyOutgoingEvent() - \" << evType << \" - \" << evData.front());" + NL + "\tif(outPortMap_.find(evType) != outPortMap_.end()){" + NL + "\t\t(outPortMap_.find(evType)->second)->notifyEvent(evData);" + NL + "\t}" + NL + "\telse{" + NL + "\t\tTRACE_ERROR(\"notifyOutgoingEvent() - ERROR: Event/Port Not found - \" << evType << \" - \" << evData.front());" + NL + "\t\texit(1);" + NL + "\t}" + NL + "}" + NL + "" + NL + "template <class T>" + NL + "RhInputStub<T>::RhInputStub(std::string inputEventName, meta* parent){" + NL + "\tTRACE_DBG(\"RhInputStub::RhInputStub() - \" << inputEventName);" + NL + "\tinputEventName_ = inputEventName;" + NL + "\tparent_ = parent;" + NL + "};" + NL + "" + NL + "template <class T>" + NL + "std::string RhInputStub<T>::name(void){" + NL + "\treturn inputEventName_;" + NL + "}" + NL + "" + NL + "template <class T>" + NL + "void RhInputStub<T>::notifyEvent(std::vector<T> evValue){" + NL + "\tTRACE_DBG(\"RhInputStub::notifyEvent() - \" << inputEventName_ << \" - \" << evValue.front());" + NL + "" + NL + "\tif(evValue.size() == 0){" + NL + "\t\tTRACE_ERROR(\"RhInputStub::notifyEvent() - No event notified\");" + NL + "\t\texit(1);" + NL + "\t}" + NL + "" + NL + "\tT eventValue = evValue[0];" + NL + "\tstd::list<String> evValueList;" + NL + "" + NL + "\t//Conversion" + NL + "\tint \tintType;" + NL + "\tdouble \tdoubleType;" + NL + "\tbool \tboolType;" + NL + "\tintType = 0;" + NL + "\tdoubleType = 0;" + NL + "\tboolType = false;" + NL + "\tstd::string strType;" + NL + "\tif(typeid(eventValue) == typeid(intType)){" + NL + "\t\t//INT Casting" + NL + "\t\tIntVector2StringList(evValue, evValueList);" + NL + "\t}" + NL + "\telse if(std::strcmp(typeid(eventValue).name(), typeid(boolType).name()) == 0){" + NL + "\t\t//Bool Casting" + NL + "\t\tBoolVector2StringList(evValue, evValueList);" + NL + "\t}" + NL + "\telse if(std::strcmp(typeid(eventValue).name(), typeid(doubleType).name()) == 0){" + NL + "\t\t//Double Casting" + NL + "\t\tDoubleVector2StringList(evValue, evValueList);" + NL + "\t}" + NL + "\telse if(std::strcmp(typeid(eventValue).name(), typeid(strType).name()) == 0){" + NL + "\t\t//String Casting" + NL + "\t\tStringVector2StringList(evValue, evValueList);" + NL + "\t}" + NL + "\telse{" + NL + "\t\tTRACE_ERROR(\"RhInputStub::notifyEvent() - No conversion rule available for event type \" << typeid(eventValue).name());" + NL + "\t\texit(1);" + NL + "\t}" + NL + "" + NL + "\tparent_->notifyIncomingEvent(inputEventName_, evValueList);" + NL + "};" + NL + "" + NL + "//Conversion Functions" + NL + "template <class T>" + NL + "void RhInputStub<T>::IntVector2StringList(std::vector<T> evValue, std::list<String>& evValueList){" + NL + "\tfor(unsigned int i=0; i<evValue.size(); i++ ){" + NL + "\t\tstd::ostringstream buffer;" + NL + "\t\tbuffer << ((int)evValue[i]);" + NL + "\t\tevValueList.push_back(buffer.str());" + NL + "\t}" + NL + "}" + NL + "" + NL + "template <class T>" + NL + "void RhInputStub<T>::BoolVector2StringList(std::vector<T> evValue, std::list<String>& evValueList){" + NL + "\tfor(unsigned int i=0; i<evValue.size(); i++ ){" + NL + "\t\tif(((bool)evValue[i])){" + NL + "\t\t\tevValueList.push_back(\"true\");" + NL + "\t\t}" + NL + "\t\telse{" + NL + "\t\t\tevValueList.push_back(\"false\");" + NL + "\t\t}" + NL + "\t}" + NL + "}" + NL + "" + NL + "template <class T>" + NL + "void RhInputStub<T>::DoubleVector2StringList(std::vector<T> evValue, std::list<String>& evValueList){" + NL + "\tfor(unsigned int i=0; i<evValue.size(); i++ ){" + NL + "\t\tstd::ostringstream buffer;" + NL + "\t\tbuffer << ((double)evValue[i]);" + NL + "\t\tevValueList.push_back(buffer.str());" + NL + "\t}" + NL + "}" + NL + "" + NL + "template <class T>" + NL + "void RhInputStub<T>::StringVector2StringList(std::vector<T> evValue, std::list<String>& evValueList){" + NL + "\tfor(unsigned int i=0; i<evValue.size(); i++ ){" + NL + "\t\tstd::ostringstream buffer;" + NL + "\t\tbuffer << evValue[i];" + NL + "\t\tevValueList.push_back(buffer.str());" + NL + "\t}" + NL + "}" + NL + "" + NL + "//Output Stub" + NL + "RhDoubleOutputStub::RhDoubleOutputStub(std::string outputEventName){" + NL + "\toutputEventName_ = outputEventName;" + NL + "}" + NL + "" + NL + "RhStringOutputStub::RhStringOutputStub(std::string outputEventName){" + NL + "\toutputEventName_ = outputEventName;" + NL + "}" + NL + "" + NL + "RhIntOutputStub::RhIntOutputStub(std::string outputEventName){" + NL + "\toutputEventName_ = outputEventName;" + NL + "}" + NL + "" + NL + "RhBoolOutputStub::RhBoolOutputStub(std::string outputEventName){" + NL + "\toutputEventName_ = outputEventName;" + NL + "}" + NL + "" + NL + "void RhDoubleOutputStub::notifyEvent(std::list<String> evData){" + NL + "\tstd::vector<double> convertedValueVector;" + NL + "\tConvert(evData, convertedValueVector);" + NL + "\tOutPort->notifyEvent(convertedValueVector);" + NL + "}" + NL + "" + NL + "void RhStringOutputStub::notifyEvent(std::list<String> evData){" + NL + "\tstd::vector<std::string> convertedValueVector;" + NL + "\tConvert(evData, convertedValueVector);" + NL + "\tOutPort->notifyEvent(convertedValueVector);" + NL + "}" + NL + "" + NL + "void RhIntOutputStub::notifyEvent(std::list<String> evData){" + NL + "\tstd::vector<int> convertedValueVector;" + NL + "\tConvert(evData, convertedValueVector);" + NL + "\tOutPort->notifyEvent(convertedValueVector);" + NL + "}" + NL + "" + NL + "void RhBoolOutputStub::notifyEvent(std::list<String> evData){" + NL + "\tstd::vector<bool> convertedValueVector;" + NL + "\tConvert(evData, convertedValueVector);" + NL + "\tOutPort->notifyEvent(convertedValueVector);" + NL + "}" + NL + "" + NL + "void RhDoubleOutputStub::Convert(std::list<String> stringEventList, std::vector<double>& evValueVector){" + NL + "\tstd::list<String>::iterator iter = stringEventList.begin();" + NL + "\twhile(iter != stringEventList.end()){" + NL + "\t\tevValueVector.push_back(atof ( (*iter).c_str()));" + NL + "\t\titer++;" + NL + "\t}" + NL + "}" + NL + "" + NL + "void RhStringOutputStub::Convert(std::list<String> stringEventList, std::vector<std::string>& evValueVector){" + NL + "\tstd::list<String>::iterator iter = stringEventList.begin();" + NL + "\twhile(iter != stringEventList.end()){" + NL + "\t\tevValueVector.push_back(*iter);" + NL + "\t\titer++;" + NL + "\t}" + NL + "}" + NL + "" + NL + "void RhIntOutputStub::Convert(std::list<String> stringEventList, std::vector<int>& evValueVector){" + NL + "\tstd::list<String>::iterator iter = stringEventList.begin();" + NL + "\twhile(iter != stringEventList.end()){" + NL + "\t\tevValueVector.push_back(atoi ( (*iter).c_str()));" + NL + "\t\titer++;" + NL + "\t}" + NL + "}" + NL + "" + NL + "void RhBoolOutputStub::Convert(std::list<String> stringEventList, std::vector<bool>& evValueVector){" + NL + "\tstd::list<String>::iterator iter = stringEventList.begin();" + NL + "\twhile(iter != stringEventList.end()){" + NL + "\t\tif( (std::strcmp((*iter).c_str(),\"false\")) == 0 ){" + NL + "\t\t\tevValueVector.push_back(false);" + NL + "\t\t}" + NL + "\t\telse{" + NL + "\t\t\tevValueVector.push_back(true);" + NL + "\t\t}" + NL + "\t\titer++;" + NL + "\t}" + NL + "}" + NL + "" + NL + " ";
  protected final String TEXT_24 = NL + " ";

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
     	
	METAJetTemplateArgument arg = (METAJetTemplateArgument)argument;
 	Component component = arg.component;
 	DesyrePathHelper desyrePathHelper = arg.desyrePathHelper;
 	
 	String componentIPName = DesyreNamesHelper.getDesyreComponentName(component);
 	String componentSpeedsName = DesyreNamesHelper.getSpeedsComponentName(component);
 	String systemName = DesyreNamesHelper.getSpeedsComponentName(desyrePathHelper.getDesyreSystem().getRoot());
 	String viewName = arg.view.getName();
 	String scaleFactor = arg.scaleFactor;

    stringBuffer.append(TEXT_1);
    stringBuffer.append(componentIPName);
    stringBuffer.append(TEXT_2);
    stringBuffer.append(desyrePathHelper.getRelativePathFromRoot(desyrePathHelper.getWrapperHeaderFile(component, viewName)));
    stringBuffer.append(TEXT_3);
    stringBuffer.append(DesyreNamesHelper.getDesyreComponentQNamespace(component));
    stringBuffer.append(TEXT_4);
    stringBuffer.append(TEXT_5);
    stringBuffer.append(viewName);
    stringBuffer.append(TEXT_6);
    stringBuffer.append(viewName);
    stringBuffer.append(TEXT_7);
    stringBuffer.append(componentIPName);
    stringBuffer.append(TEXT_8);
    
	for( Port port : component.getPort())
	{
		if(port.getDirection() == PortDirection.IN){
	
    stringBuffer.append(TEXT_9);
    stringBuffer.append(port.getType().getName());
    stringBuffer.append(TEXT_10);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_11);
    stringBuffer.append(port.getType().getName());
    stringBuffer.append(TEXT_12);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_13);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_14);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_15);
    
		}
		else{
	
    stringBuffer.append(TEXT_16);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_17);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_18);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_19);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_20);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_21);
    stringBuffer.append(port.getName());
    stringBuffer.append(TEXT_22);
    
		}
	}
	
	
    stringBuffer.append(TEXT_23);
    stringBuffer.append(TEXT_24);
    return stringBuffer.toString();
  }
}
