
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.metaii2desyre.impl;

import com.eu.ales.desyre.model.desyre.PrimitiveTypeKind;
import com.eu.ales.modeltransformation.impl.DerivedMappingImpl;
import com.eu.ales.rpyplugins.MClassifier;
import com.eu.ales.rpyplugins.utils.Logger;

public class Classifier2UnsupportedType extends DerivedMappingImpl<MClassifier, com.eu.ales.desyre.model.desyre.PrimitiveType> {
	private static final Logger logger = Logger.getLogger(Classifier2UnsupportedType.class);

	public Classifier2UnsupportedType(MClassifier self) {
		super(self);
	}

	@Override
	public boolean when() {
		return true;
	}

	@Override
	public void populate() {
		logger.logWarning(self, "unsupported data type, creating integer primitive data type instead");
		result.setKind(PrimitiveTypeKind.INTEGER);
	}

	@Override
	protected void initInheritance() {
		inherits(ModelElement2NamedElement.class);
	}


}
