
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.metaii2desyre.impl;

import com.eu.ales.modeltransformation.impl.MappingImpl;
import com.eu.ales.rpyplugins.MClassifier;

public class Classifier2View extends MappingImpl<MClassifier, com.eu.ales.desyre.model.desyre.View> {
	public static final String BASIC_VIEW_NAME = "meta";
	public static final String META_VIEW_NAME = "meta";
	public static final String RTW_VIEW_NAME = "rtw";

	public Classifier2View(MClassifier self) {
		super(self);
	}

	@Override
	public void populate() {
		if (Tag2Target.isSimulinkTarget(self)) {
			result.setName(RTW_VIEW_NAME);
		} else if (Classifier2Component.isAdaptor(self)) {
			result.setName(BASIC_VIEW_NAME);
		} else {
			result.setName(META_VIEW_NAME);
		}
	}

}
