
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.metaii2desyre.impl;

import java.util.HashMap;
import java.util.Map;

import com.eu.ales.rpyplugins.MModelElement;

public class NameMapping {
	private static final Map<String,String> nameMapping = new HashMap<String,String>(){{put("Default","Default");}};
	private static final String SEPARATOR = "_";
	private static final String REGEX = "[.:]:?";
	private static final String ID = "[a-zA-Z_][a-zA-Z0-9_]*";

	public static String getName(MModelElement modelElement) {
		return getName(modelElement.getFullPathName());
	}

	public static String getName(String name) {
		String targetName = nameMapping.get(name);
		if (targetName == null) {
			String names[] = name.split(REGEX);
			if (names != null && names.length > 0) {
				return names[names.length-1];
			} else {
				return null;
			}
		} else {
			return targetName;
		}
	}

	public static String getParentName(MModelElement modelElement) {
		return getParentName(modelElement.getFullPathName());
	}

	public static String getParentName(String name) {
		return getName(name.replaceAll(REGEX + ID + "$", ""));
	}

	public static String getQualifiedName(String name) {
		return name.replaceAll(REGEX, SEPARATOR);
	}
}
