
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.metaiivalidator;

import com.eu.ales.rpyplugins.MModelElement;
import com.eu.ales.rpyplugins.utils.Logger;

public class ValidationResult {
	private MModelElement modelElement;
	private String message;

	public ValidationResult(MModelElement modelElement, String message) {
		this.modelElement = modelElement;
		this.message = message;
	}

	public void printOut(Logger logger) {
		if (logger == null) {
			throw new IllegalArgumentException("Invalid null logger");
		}
		if (modelElement != null) {
			logger.logInfo("[" + this.getClass().getSimpleName()  + "] on model element '" + modelElement.eClass().getName() + "' with name '" + modelElement.getName() + "': " + (message != null && !message.isEmpty() ? message : "empty message"));
		} else {
			logger.logInfo("[" + this.getClass().getSimpleName()  + "] " + (message != null && !message.isEmpty() ? message : "empty message"));
		}
	}
}
