
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.metaiivalidator;

import java.util.ArrayList;
import java.util.List;

import com.eu.ales.rpyplugins.utils.Logger;

public class ValidationResults {
	private List<ValidationResult> validationResults;

	public ValidationResults() {
		validationResults = new ArrayList<ValidationResult>();
	}

	public void printOut(Logger logger) {
		if (logger == null) {
			throw new IllegalArgumentException("Invalid null logger");
		}
		if (validationResults.isEmpty()) {
			logger.logInfo("The MetaII model is valid!");
		}
		for (ValidationResult result : validationResults) {
			result.printOut(logger);
		}
	}

	public void addValidationResult(ValidationResult validationResult) {
		if (validationResult == null) {
			throw new IllegalArgumentException("Invalid null validation result");
		}
		validationResults.add(validationResult);
	}
}
