
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.metaiivalidator.impl;

import com.eu.ales.rpyplugins.MLink;
import com.eu.ales.rpyplugins.MStereotype;
import com.eu.ales.rpyplugins.metaiivalidator.ValidationResult;

public class CheckMoCCCompatibilityResult extends ValidationResult {
	private MStereotype fromStereotype;
	public CheckMoCCCompatibilityResult(MLink link, String message) {
		super(link, message);
		this.fromStereotype = null;
	}
	public CheckMoCCCompatibilityResult(MLink link, MStereotype fromStereotype) {
		super(link, fromStereotype != null && link.getTo() != null && link.getToSysMLPort() != null && link.getFrom() != null && link.getFromSysMLPort() != null
				? "cannot find valid match (same or MoCC generalization) on 'port '" + link.getTo().getName() + "." + link.getToSysMLPort().getName() + "' for MoCC specification '" + fromStereotype.getName() + "' on port '" + link.getFrom().getName() + "." + link.getFromSysMLPort().getName() + "'"
				: fromStereotype != null && link.getTo() != null && link.getFrom() != null && link.getFromSysMLPort() != null
				? "cannot find valid match (same or MoCC generalization) on 'port '" + link.getTo().getName() + "' for MoCC specification '" + fromStereotype.getName() + "' on port '" + link.getFrom().getName() + "." + link.getFromSysMLPort().getName() + "'"
				: fromStereotype != null && link.getTo() != null && link.getToSysMLPort() != null && link.getFrom() != null
				? "cannot find valid match (same or MoCC generalization) on 'port '" + link.getTo().getName() + "." + link.getToSysMLPort().getName() + "' for MoCC specification '" + fromStereotype.getName() + "' on port '" + link.getFrom().getName() + "'"
				: "missing MoCC specification on 'from' port");
		this.fromStereotype = fromStereotype;
	}
}
