
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>MClassifier</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.eu.ales.rpyplugins.MClassifier#getMPorts <em>MPorts</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MClassifier#getMRelations <em>MRelations</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MClassifier#getMOperations <em>MOperations</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MClassifier#getMGeneralizations <em>MGeneralizations</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MClassifier#getMAttributes <em>MAttributes</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MClassifier#getMInterfaceItems <em>MInterface Items</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MClassifier#getMFlows <em>MFlows</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MClassifier#getMFlowItems <em>MFlow Items</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MClassifier#getMLinks <em>MLinks</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMClassifier()
 * @model
 * @generated
 */
public interface MClassifier extends MUnit {
	/**
	 * Returns the value of the '<em><b>MPorts</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MPort}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MPorts</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MPorts</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMClassifier_MPorts()
	 * @model
	 * @generated
	 */
	EList<MPort> getMPorts();

	/**
	 * Returns the value of the '<em><b>MRelations</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MRelation}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MRelations</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MRelations</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMClassifier_MRelations()
	 * @model
	 * @generated
	 */
	EList<MRelation> getMRelations();

	/**
	 * Returns the value of the '<em><b>MOperations</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MOperation}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MOperations</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MOperations</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMClassifier_MOperations()
	 * @model
	 * @generated
	 */
	EList<MOperation> getMOperations();

	/**
	 * Returns the value of the '<em><b>MGeneralizations</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MGeneralization}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MGeneralizations</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MGeneralizations</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMClassifier_MGeneralizations()
	 * @model
	 * @generated
	 */
	EList<MGeneralization> getMGeneralizations();

	/**
	 * Returns the value of the '<em><b>MAttributes</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MAttribute}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MAttributes</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MAttributes</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMClassifier_MAttributes()
	 * @model
	 * @generated
	 */
	EList<MAttribute> getMAttributes();

	/**
	 * Returns the value of the '<em><b>MInterface Items</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MInterfaceItem}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MInterface Items</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MInterface Items</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMClassifier_MInterfaceItems()
	 * @model
	 * @generated
	 */
	EList<MInterfaceItem> getMInterfaceItems();

	/**
	 * Returns the value of the '<em><b>MFlows</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MFlow}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MFlows</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MFlows</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMClassifier_MFlows()
	 * @model
	 * @generated
	 */
	EList<MFlow> getMFlows();

	/**
	 * Returns the value of the '<em><b>MFlow Items</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MFlowItem}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MFlow Items</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MFlow Items</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMClassifier_MFlowItems()
	 * @model
	 * @generated
	 */
	EList<MFlowItem> getMFlowItems();

	/**
	 * Returns the value of the '<em><b>MLinks</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MLink}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MLinks</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MLinks</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMClassifier_MLinks()
	 * @model
	 * @generated
	 */
	EList<MLink> getMLinks();

} // MClassifier
