
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>MLink</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.eu.ales.rpyplugins.MLink#getFrom <em>From</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MLink#getTo <em>To</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MLink#getFromSysMLPort <em>From Sys ML Port</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MLink#getToSysMLPort <em>To Sys ML Port</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MLink#getFromPort <em>From Port</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MLink#getToPort <em>To Port</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMLink()
 * @model
 * @generated
 */
public interface MLink extends MModelElement {
	/**
	 * Returns the value of the '<em><b>From</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>From</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>From</em>' reference.
	 * @see #setFrom(MInstance)
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMLink_From()
	 * @model
	 * @generated
	 */
	MInstance getFrom();

	/**
	 * Sets the value of the '{@link com.eu.ales.rpyplugins.MLink#getFrom <em>From</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>From</em>' reference.
	 * @see #getFrom()
	 * @generated
	 */
	void setFrom(MInstance value);

	/**
	 * Returns the value of the '<em><b>To</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>To</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>To</em>' reference.
	 * @see #setTo(MInstance)
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMLink_To()
	 * @model
	 * @generated
	 */
	MInstance getTo();

	/**
	 * Sets the value of the '{@link com.eu.ales.rpyplugins.MLink#getTo <em>To</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>To</em>' reference.
	 * @see #getTo()
	 * @generated
	 */
	void setTo(MInstance value);

	/**
	 * Returns the value of the '<em><b>From Sys ML Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>From Sys ML Port</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>From Sys ML Port</em>' reference.
	 * @see #setFromSysMLPort(MSysMLPort)
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMLink_FromSysMLPort()
	 * @model
	 * @generated
	 */
	MSysMLPort getFromSysMLPort();

	/**
	 * Sets the value of the '{@link com.eu.ales.rpyplugins.MLink#getFromSysMLPort <em>From Sys ML Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>From Sys ML Port</em>' reference.
	 * @see #getFromSysMLPort()
	 * @generated
	 */
	void setFromSysMLPort(MSysMLPort value);

	/**
	 * Returns the value of the '<em><b>To Sys ML Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>To Sys ML Port</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>To Sys ML Port</em>' reference.
	 * @see #setToSysMLPort(MSysMLPort)
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMLink_ToSysMLPort()
	 * @model
	 * @generated
	 */
	MSysMLPort getToSysMLPort();

	/**
	 * Sets the value of the '{@link com.eu.ales.rpyplugins.MLink#getToSysMLPort <em>To Sys ML Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>To Sys ML Port</em>' reference.
	 * @see #getToSysMLPort()
	 * @generated
	 */
	void setToSysMLPort(MSysMLPort value);

	/**
	 * Returns the value of the '<em><b>From Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>From Port</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>From Port</em>' reference.
	 * @see #setFromPort(MPort)
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMLink_FromPort()
	 * @model
	 * @generated
	 */
	MPort getFromPort();

	/**
	 * Sets the value of the '{@link com.eu.ales.rpyplugins.MLink#getFromPort <em>From Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>From Port</em>' reference.
	 * @see #getFromPort()
	 * @generated
	 */
	void setFromPort(MPort value);

	/**
	 * Returns the value of the '<em><b>To Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>To Port</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>To Port</em>' reference.
	 * @see #setToPort(MPort)
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMLink_ToPort()
	 * @model
	 * @generated
	 */
	MPort getToPort();

	/**
	 * Sets the value of the '{@link com.eu.ales.rpyplugins.MLink#getToPort <em>To Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>To Port</em>' reference.
	 * @see #getToPort()
	 * @generated
	 */
	void setToPort(MPort value);

} // MLink
