
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>MModel Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.eu.ales.rpyplugins.MModelElement#getMUnsupportedModelElements <em>MUnsupported Model Elements</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MModelElement#getName <em>Name</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MModelElement#getFullPathName <em>Full Path Name</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MModelElement#getMProject <em>MProject</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MModelElement#getMStereotypes <em>MStereotypes</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MModelElement#getMAllTags <em>MAll Tags</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MModelElement#getMLocalTags <em>MLocal Tags</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MModelElement#getMNestedElements <em>MNested Elements</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MModelElement#getMDependencies <em>MDependencies</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MModelElement#getUri <em>Uri</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MModelElement#getMModelElementRefs <em>MModel Element Refs</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMModelElement()
 * @model
 * @generated
 */
public interface MModelElement extends EObject {
	/**
	 * Returns the value of the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MModelElement}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MUnsupported Model Elements</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MUnsupported Model Elements</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMModelElement_MUnsupportedModelElements()
	 * @model
	 * @generated
	 */
	EList<MModelElement> getMUnsupportedModelElements();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMModelElement_Name()
	 * @model
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link com.eu.ales.rpyplugins.MModelElement#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Full Path Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Full Path Name</em>' attribute.
	 * @see #setFullPathName(String)
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMModelElement_FullPathName()
	 * @model
	 * @generated
	 */
	String getFullPathName();

	/**
	 * Sets the value of the '{@link com.eu.ales.rpyplugins.MModelElement#getFullPathName <em>Full Path Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Full Path Name</em>' attribute.
	 * @see #getFullPathName()
	 * @generated
	 */
	void setFullPathName(String value);

	/**
	 * Returns the value of the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MProject</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MProject</em>' reference.
	 * @see #setMProject(MProject)
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMModelElement_MProject()
	 * @model
	 * @generated
	 */
	MProject getMProject();

	/**
	 * Sets the value of the '{@link com.eu.ales.rpyplugins.MModelElement#getMProject <em>MProject</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>MProject</em>' reference.
	 * @see #getMProject()
	 * @generated
	 */
	void setMProject(MProject value);

	/**
	 * Returns the value of the '<em><b>MStereotypes</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MStereotype}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MStereotypes</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MStereotypes</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMModelElement_MStereotypes()
	 * @model
	 * @generated
	 */
	EList<MStereotype> getMStereotypes();

	/**
	 * Returns the value of the '<em><b>MAll Tags</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MTag}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MAll Tags</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MAll Tags</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMModelElement_MAllTags()
	 * @model
	 * @generated
	 */
	EList<MTag> getMAllTags();

	/**
	 * Returns the value of the '<em><b>MLocal Tags</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MTag}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MLocal Tags</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MLocal Tags</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMModelElement_MLocalTags()
	 * @model
	 * @generated
	 */
	EList<MTag> getMLocalTags();

	/**
	 * Returns the value of the '<em><b>MNested Elements</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MModelElement}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MNested Elements</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MNested Elements</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMModelElement_MNestedElements()
	 * @model
	 * @generated
	 */
	EList<MModelElement> getMNestedElements();

	/**
	 * Returns the value of the '<em><b>MDependencies</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MDependency}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MDependencies</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MDependencies</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMModelElement_MDependencies()
	 * @model
	 * @generated
	 */
	EList<MDependency> getMDependencies();

	/**
	 * Returns the value of the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Uri</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Uri</em>' attribute.
	 * @see #setUri(String)
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMModelElement_Uri()
	 * @model
	 * @generated
	 */
	String getUri();

	/**
	 * Sets the value of the '{@link com.eu.ales.rpyplugins.MModelElement#getUri <em>Uri</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Uri</em>' attribute.
	 * @see #getUri()
	 * @generated
	 */
	void setUri(String value);

	/**
	 * Returns the value of the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MModelElementRef}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MModel Element Refs</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MModel Element Refs</em>' containment reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMModelElement_MModelElementRefs()
	 * @model containment="true"
	 * @generated
	 */
	EList<MModelElementRef> getMModelElementRefs();

} // MModelElement
