
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>MProject</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.eu.ales.rpyplugins.MProject#getMComponents <em>MComponents</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MProject#getMObjectModelDiagrams <em>MObject Model Diagrams</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MProject#getMProfiles <em>MProfiles</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MProject#getMStructureDiagrams <em>MStructure Diagrams</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.MProject#getMModelElements <em>MModel Elements</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMProject()
 * @model
 * @generated
 */
public interface MProject extends MPackage {
	/**
	 * Returns the value of the '<em><b>MComponents</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MComponent}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MComponents</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MComponents</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMProject_MComponents()
	 * @model
	 * @generated
	 */
	EList<MComponent> getMComponents();

	/**
	 * Returns the value of the '<em><b>MObject Model Diagrams</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MObjectModelDiagram}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MObject Model Diagrams</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MObject Model Diagrams</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMProject_MObjectModelDiagrams()
	 * @model
	 * @generated
	 */
	EList<MObjectModelDiagram> getMObjectModelDiagrams();

	/**
	 * Returns the value of the '<em><b>MProfiles</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MProfile}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MProfiles</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MProfiles</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMProject_MProfiles()
	 * @model
	 * @generated
	 */
	EList<MProfile> getMProfiles();

	/**
	 * Returns the value of the '<em><b>MStructure Diagrams</b></em>' reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MStructureDiagram}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MStructure Diagrams</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MStructure Diagrams</em>' reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMProject_MStructureDiagrams()
	 * @model
	 * @generated
	 */
	EList<MStructureDiagram> getMStructureDiagrams();

	/**
	 * Returns the value of the '<em><b>MModel Elements</b></em>' containment reference list.
	 * The list contents are of type {@link com.eu.ales.rpyplugins.MModelElement}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MModel Elements</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MModel Elements</em>' containment reference list.
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#getMProject_MModelElements()
	 * @model containment="true"
	 * @generated
	 */
	EList<MModelElement> getMModelElements();

} // MProject
