
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.eu.ales.rpyplugins.RpypluginsPackage
 * @generated
 */
public interface RpypluginsFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	RpypluginsFactory eINSTANCE = com.eu.ales.rpyplugins.impl.RpypluginsFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>MAttribute</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MAttribute</em>'.
	 * @generated
	 */
	MAttribute createMAttribute();

	/**
	 * Returns a new object of class '<em>MClass</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MClass</em>'.
	 * @generated
	 */
	MClass createMClass();

	/**
	 * Returns a new object of class '<em>MClassifier</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MClassifier</em>'.
	 * @generated
	 */
	MClassifier createMClassifier();

	/**
	 * Returns a new object of class '<em>MComponent</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MComponent</em>'.
	 * @generated
	 */
	MComponent createMComponent();

	/**
	 * Returns a new object of class '<em>MConfiguration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MConfiguration</em>'.
	 * @generated
	 */
	MConfiguration createMConfiguration();

	/**
	 * Returns a new object of class '<em>MDependency</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MDependency</em>'.
	 * @generated
	 */
	MDependency createMDependency();

	/**
	 * Returns a new object of class '<em>MDiagram</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MDiagram</em>'.
	 * @generated
	 */
	MDiagram createMDiagram();

	/**
	 * Returns a new object of class '<em>MEnumeration Literal</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MEnumeration Literal</em>'.
	 * @generated
	 */
	MEnumerationLiteral createMEnumerationLiteral();

	/**
	 * Returns a new object of class '<em>MFile</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MFile</em>'.
	 * @generated
	 */
	MFile createMFile();

	/**
	 * Returns a new object of class '<em>MFlow</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MFlow</em>'.
	 * @generated
	 */
	MFlow createMFlow();

	/**
	 * Returns a new object of class '<em>MFlow Item</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MFlow Item</em>'.
	 * @generated
	 */
	MFlowItem createMFlowItem();

	/**
	 * Returns a new object of class '<em>MGeneralization</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MGeneralization</em>'.
	 * @generated
	 */
	MGeneralization createMGeneralization();

	/**
	 * Returns a new object of class '<em>MInstance</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MInstance</em>'.
	 * @generated
	 */
	MInstance createMInstance();

	/**
	 * Returns a new object of class '<em>MInterface Item</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MInterface Item</em>'.
	 * @generated
	 */
	MInterfaceItem createMInterfaceItem();

	/**
	 * Returns a new object of class '<em>MLink</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MLink</em>'.
	 * @generated
	 */
	MLink createMLink();

	/**
	 * Returns a new object of class '<em>MLiteral Specification</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MLiteral Specification</em>'.
	 * @generated
	 */
	MLiteralSpecification createMLiteralSpecification();

	/**
	 * Returns a new object of class '<em>MModel Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MModel Element</em>'.
	 * @generated
	 */
	MModelElement createMModelElement();

	/**
	 * Returns a new object of class '<em>MModel Element Ref</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MModel Element Ref</em>'.
	 * @generated
	 */
	MModelElementRef createMModelElementRef();

	/**
	 * Returns a new object of class '<em>MModule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MModule</em>'.
	 * @generated
	 */
	MModule createMModule();

	/**
	 * Returns a new object of class '<em>MObject Model Diagram</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MObject Model Diagram</em>'.
	 * @generated
	 */
	MObjectModelDiagram createMObjectModelDiagram();

	/**
	 * Returns a new object of class '<em>MOperation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MOperation</em>'.
	 * @generated
	 */
	MOperation createMOperation();

	/**
	 * Returns a new object of class '<em>MPackage</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MPackage</em>'.
	 * @generated
	 */
	MPackage createMPackage();

	/**
	 * Returns a new object of class '<em>MPort</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MPort</em>'.
	 * @generated
	 */
	MPort createMPort();

	/**
	 * Returns a new object of class '<em>MProfile</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MProfile</em>'.
	 * @generated
	 */
	MProfile createMProfile();

	/**
	 * Returns a new object of class '<em>MProject</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MProject</em>'.
	 * @generated
	 */
	MProject createMProject();

	/**
	 * Returns a new object of class '<em>MRelation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MRelation</em>'.
	 * @generated
	 */
	MRelation createMRelation();

	/**
	 * Returns a new object of class '<em>MStereotype</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MStereotype</em>'.
	 * @generated
	 */
	MStereotype createMStereotype();

	/**
	 * Returns a new object of class '<em>MStructure Diagram</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MStructure Diagram</em>'.
	 * @generated
	 */
	MStructureDiagram createMStructureDiagram();

	/**
	 * Returns a new object of class '<em>MSys ML Port</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MSys ML Port</em>'.
	 * @generated
	 */
	MSysMLPort createMSysMLPort();

	/**
	 * Returns a new object of class '<em>MTag</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MTag</em>'.
	 * @generated
	 */
	MTag createMTag();

	/**
	 * Returns a new object of class '<em>MTemplate Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MTemplate Parameter</em>'.
	 * @generated
	 */
	MTemplateParameter createMTemplateParameter();

	/**
	 * Returns a new object of class '<em>MType</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MType</em>'.
	 * @generated
	 */
	MType createMType();

	/**
	 * Returns a new object of class '<em>MUnit</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MUnit</em>'.
	 * @generated
	 */
	MUnit createMUnit();

	/**
	 * Returns a new object of class '<em>MUnsupported Model Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MUnsupported Model Element</em>'.
	 * @generated
	 */
	MUnsupportedModelElement createMUnsupportedModelElement();

	/**
	 * Returns a new object of class '<em>MValue Specification</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MValue Specification</em>'.
	 * @generated
	 */
	MValueSpecification createMValueSpecification();

	/**
	 * Returns a new object of class '<em>MVariable</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MVariable</em>'.
	 * @generated
	 */
	MVariable createMVariable();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	RpypluginsPackage getRpypluginsPackage();

} //RpypluginsFactory
