
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.impl;

import com.eu.ales.rpyplugins.MAttribute;
import com.eu.ales.rpyplugins.MClassifier;
import com.eu.ales.rpyplugins.MFlow;
import com.eu.ales.rpyplugins.MFlowItem;
import com.eu.ales.rpyplugins.MGeneralization;
import com.eu.ales.rpyplugins.MInterfaceItem;
import com.eu.ales.rpyplugins.MLink;
import com.eu.ales.rpyplugins.MOperation;
import com.eu.ales.rpyplugins.MPort;
import com.eu.ales.rpyplugins.MRelation;
import com.eu.ales.rpyplugins.RpypluginsPackage;

import java.util.Collection;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>MClassifier</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MClassifierImpl#getMPorts <em>MPorts</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MClassifierImpl#getMRelations <em>MRelations</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MClassifierImpl#getMOperations <em>MOperations</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MClassifierImpl#getMGeneralizations <em>MGeneralizations</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MClassifierImpl#getMAttributes <em>MAttributes</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MClassifierImpl#getMInterfaceItems <em>MInterface Items</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MClassifierImpl#getMFlows <em>MFlows</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MClassifierImpl#getMFlowItems <em>MFlow Items</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MClassifierImpl#getMLinks <em>MLinks</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MClassifierImpl extends MUnitImpl implements MClassifier {
	/**
	 * The cached value of the '{@link #getMPorts() <em>MPorts</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMPorts()
	 * @generated
	 * @ordered
	 */
	protected EList<MPort> mPorts;

	/**
	 * The cached value of the '{@link #getMRelations() <em>MRelations</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMRelations()
	 * @generated
	 * @ordered
	 */
	protected EList<MRelation> mRelations;

	/**
	 * The cached value of the '{@link #getMOperations() <em>MOperations</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMOperations()
	 * @generated
	 * @ordered
	 */
	protected EList<MOperation> mOperations;

	/**
	 * The cached value of the '{@link #getMGeneralizations() <em>MGeneralizations</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMGeneralizations()
	 * @generated
	 * @ordered
	 */
	protected EList<MGeneralization> mGeneralizations;

	/**
	 * The cached value of the '{@link #getMAttributes() <em>MAttributes</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMAttributes()
	 * @generated
	 * @ordered
	 */
	protected EList<MAttribute> mAttributes;

	/**
	 * The cached value of the '{@link #getMInterfaceItems() <em>MInterface Items</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMInterfaceItems()
	 * @generated
	 * @ordered
	 */
	protected EList<MInterfaceItem> mInterfaceItems;

	/**
	 * The cached value of the '{@link #getMFlows() <em>MFlows</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMFlows()
	 * @generated
	 * @ordered
	 */
	protected EList<MFlow> mFlows;

	/**
	 * The cached value of the '{@link #getMFlowItems() <em>MFlow Items</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMFlowItems()
	 * @generated
	 * @ordered
	 */
	protected EList<MFlowItem> mFlowItems;

	/**
	 * The cached value of the '{@link #getMLinks() <em>MLinks</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMLinks()
	 * @generated
	 * @ordered
	 */
	protected EList<MLink> mLinks;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MClassifierImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RpypluginsPackage.Literals.MCLASSIFIER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MPort> getMPorts() {
		if (mPorts == null) {
			mPorts = new EObjectResolvingEList<MPort>(MPort.class, this, RpypluginsPackage.MCLASSIFIER__MPORTS);
		}
		return mPorts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MRelation> getMRelations() {
		if (mRelations == null) {
			mRelations = new EObjectResolvingEList<MRelation>(MRelation.class, this, RpypluginsPackage.MCLASSIFIER__MRELATIONS);
		}
		return mRelations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MOperation> getMOperations() {
		if (mOperations == null) {
			mOperations = new EObjectResolvingEList<MOperation>(MOperation.class, this, RpypluginsPackage.MCLASSIFIER__MOPERATIONS);
		}
		return mOperations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MGeneralization> getMGeneralizations() {
		if (mGeneralizations == null) {
			mGeneralizations = new EObjectResolvingEList<MGeneralization>(MGeneralization.class, this, RpypluginsPackage.MCLASSIFIER__MGENERALIZATIONS);
		}
		return mGeneralizations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MAttribute> getMAttributes() {
		if (mAttributes == null) {
			mAttributes = new EObjectResolvingEList<MAttribute>(MAttribute.class, this, RpypluginsPackage.MCLASSIFIER__MATTRIBUTES);
		}
		return mAttributes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MInterfaceItem> getMInterfaceItems() {
		if (mInterfaceItems == null) {
			mInterfaceItems = new EObjectResolvingEList<MInterfaceItem>(MInterfaceItem.class, this, RpypluginsPackage.MCLASSIFIER__MINTERFACE_ITEMS);
		}
		return mInterfaceItems;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MFlow> getMFlows() {
		if (mFlows == null) {
			mFlows = new EObjectResolvingEList<MFlow>(MFlow.class, this, RpypluginsPackage.MCLASSIFIER__MFLOWS);
		}
		return mFlows;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MFlowItem> getMFlowItems() {
		if (mFlowItems == null) {
			mFlowItems = new EObjectResolvingEList<MFlowItem>(MFlowItem.class, this, RpypluginsPackage.MCLASSIFIER__MFLOW_ITEMS);
		}
		return mFlowItems;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MLink> getMLinks() {
		if (mLinks == null) {
			mLinks = new EObjectResolvingEList<MLink>(MLink.class, this, RpypluginsPackage.MCLASSIFIER__MLINKS);
		}
		return mLinks;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RpypluginsPackage.MCLASSIFIER__MPORTS:
				return getMPorts();
			case RpypluginsPackage.MCLASSIFIER__MRELATIONS:
				return getMRelations();
			case RpypluginsPackage.MCLASSIFIER__MOPERATIONS:
				return getMOperations();
			case RpypluginsPackage.MCLASSIFIER__MGENERALIZATIONS:
				return getMGeneralizations();
			case RpypluginsPackage.MCLASSIFIER__MATTRIBUTES:
				return getMAttributes();
			case RpypluginsPackage.MCLASSIFIER__MINTERFACE_ITEMS:
				return getMInterfaceItems();
			case RpypluginsPackage.MCLASSIFIER__MFLOWS:
				return getMFlows();
			case RpypluginsPackage.MCLASSIFIER__MFLOW_ITEMS:
				return getMFlowItems();
			case RpypluginsPackage.MCLASSIFIER__MLINKS:
				return getMLinks();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RpypluginsPackage.MCLASSIFIER__MPORTS:
				getMPorts().clear();
				getMPorts().addAll((Collection<? extends MPort>)newValue);
				return;
			case RpypluginsPackage.MCLASSIFIER__MRELATIONS:
				getMRelations().clear();
				getMRelations().addAll((Collection<? extends MRelation>)newValue);
				return;
			case RpypluginsPackage.MCLASSIFIER__MOPERATIONS:
				getMOperations().clear();
				getMOperations().addAll((Collection<? extends MOperation>)newValue);
				return;
			case RpypluginsPackage.MCLASSIFIER__MGENERALIZATIONS:
				getMGeneralizations().clear();
				getMGeneralizations().addAll((Collection<? extends MGeneralization>)newValue);
				return;
			case RpypluginsPackage.MCLASSIFIER__MATTRIBUTES:
				getMAttributes().clear();
				getMAttributes().addAll((Collection<? extends MAttribute>)newValue);
				return;
			case RpypluginsPackage.MCLASSIFIER__MINTERFACE_ITEMS:
				getMInterfaceItems().clear();
				getMInterfaceItems().addAll((Collection<? extends MInterfaceItem>)newValue);
				return;
			case RpypluginsPackage.MCLASSIFIER__MFLOWS:
				getMFlows().clear();
				getMFlows().addAll((Collection<? extends MFlow>)newValue);
				return;
			case RpypluginsPackage.MCLASSIFIER__MFLOW_ITEMS:
				getMFlowItems().clear();
				getMFlowItems().addAll((Collection<? extends MFlowItem>)newValue);
				return;
			case RpypluginsPackage.MCLASSIFIER__MLINKS:
				getMLinks().clear();
				getMLinks().addAll((Collection<? extends MLink>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RpypluginsPackage.MCLASSIFIER__MPORTS:
				getMPorts().clear();
				return;
			case RpypluginsPackage.MCLASSIFIER__MRELATIONS:
				getMRelations().clear();
				return;
			case RpypluginsPackage.MCLASSIFIER__MOPERATIONS:
				getMOperations().clear();
				return;
			case RpypluginsPackage.MCLASSIFIER__MGENERALIZATIONS:
				getMGeneralizations().clear();
				return;
			case RpypluginsPackage.MCLASSIFIER__MATTRIBUTES:
				getMAttributes().clear();
				return;
			case RpypluginsPackage.MCLASSIFIER__MINTERFACE_ITEMS:
				getMInterfaceItems().clear();
				return;
			case RpypluginsPackage.MCLASSIFIER__MFLOWS:
				getMFlows().clear();
				return;
			case RpypluginsPackage.MCLASSIFIER__MFLOW_ITEMS:
				getMFlowItems().clear();
				return;
			case RpypluginsPackage.MCLASSIFIER__MLINKS:
				getMLinks().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RpypluginsPackage.MCLASSIFIER__MPORTS:
				return mPorts != null && !mPorts.isEmpty();
			case RpypluginsPackage.MCLASSIFIER__MRELATIONS:
				return mRelations != null && !mRelations.isEmpty();
			case RpypluginsPackage.MCLASSIFIER__MOPERATIONS:
				return mOperations != null && !mOperations.isEmpty();
			case RpypluginsPackage.MCLASSIFIER__MGENERALIZATIONS:
				return mGeneralizations != null && !mGeneralizations.isEmpty();
			case RpypluginsPackage.MCLASSIFIER__MATTRIBUTES:
				return mAttributes != null && !mAttributes.isEmpty();
			case RpypluginsPackage.MCLASSIFIER__MINTERFACE_ITEMS:
				return mInterfaceItems != null && !mInterfaceItems.isEmpty();
			case RpypluginsPackage.MCLASSIFIER__MFLOWS:
				return mFlows != null && !mFlows.isEmpty();
			case RpypluginsPackage.MCLASSIFIER__MFLOW_ITEMS:
				return mFlowItems != null && !mFlowItems.isEmpty();
			case RpypluginsPackage.MCLASSIFIER__MLINKS:
				return mLinks != null && !mLinks.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //MClassifierImpl
