
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.impl;

import com.eu.ales.rpyplugins.MClassifier;
import com.eu.ales.rpyplugins.MGeneralization;
import com.eu.ales.rpyplugins.RpypluginsPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>MGeneralization</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MGeneralizationImpl#getBaseClass <em>Base Class</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MGeneralizationImpl#getDerivedClass <em>Derived Class</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MGeneralizationImpl extends MModelElementImpl implements MGeneralization {
	/**
	 * The cached value of the '{@link #getBaseClass() <em>Base Class</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBaseClass()
	 * @generated
	 * @ordered
	 */
	protected MClassifier baseClass;
	/**
	 * The cached value of the '{@link #getDerivedClass() <em>Derived Class</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDerivedClass()
	 * @generated
	 * @ordered
	 */
	protected MClassifier derivedClass;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MGeneralizationImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RpypluginsPackage.Literals.MGENERALIZATION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MClassifier getBaseClass() {
		if (baseClass != null && baseClass.eIsProxy()) {
			InternalEObject oldBaseClass = (InternalEObject)baseClass;
			baseClass = (MClassifier)eResolveProxy(oldBaseClass);
			if (baseClass != oldBaseClass) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RpypluginsPackage.MGENERALIZATION__BASE_CLASS, oldBaseClass, baseClass));
			}
		}
		return baseClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MClassifier basicGetBaseClass() {
		return baseClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBaseClass(MClassifier newBaseClass) {
		MClassifier oldBaseClass = baseClass;
		baseClass = newBaseClass;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RpypluginsPackage.MGENERALIZATION__BASE_CLASS, oldBaseClass, baseClass));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MClassifier getDerivedClass() {
		if (derivedClass != null && derivedClass.eIsProxy()) {
			InternalEObject oldDerivedClass = (InternalEObject)derivedClass;
			derivedClass = (MClassifier)eResolveProxy(oldDerivedClass);
			if (derivedClass != oldDerivedClass) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RpypluginsPackage.MGENERALIZATION__DERIVED_CLASS, oldDerivedClass, derivedClass));
			}
		}
		return derivedClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MClassifier basicGetDerivedClass() {
		return derivedClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDerivedClass(MClassifier newDerivedClass) {
		MClassifier oldDerivedClass = derivedClass;
		derivedClass = newDerivedClass;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RpypluginsPackage.MGENERALIZATION__DERIVED_CLASS, oldDerivedClass, derivedClass));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RpypluginsPackage.MGENERALIZATION__BASE_CLASS:
				if (resolve) return getBaseClass();
				return basicGetBaseClass();
			case RpypluginsPackage.MGENERALIZATION__DERIVED_CLASS:
				if (resolve) return getDerivedClass();
				return basicGetDerivedClass();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RpypluginsPackage.MGENERALIZATION__BASE_CLASS:
				setBaseClass((MClassifier)newValue);
				return;
			case RpypluginsPackage.MGENERALIZATION__DERIVED_CLASS:
				setDerivedClass((MClassifier)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RpypluginsPackage.MGENERALIZATION__BASE_CLASS:
				setBaseClass((MClassifier)null);
				return;
			case RpypluginsPackage.MGENERALIZATION__DERIVED_CLASS:
				setDerivedClass((MClassifier)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RpypluginsPackage.MGENERALIZATION__BASE_CLASS:
				return baseClass != null;
			case RpypluginsPackage.MGENERALIZATION__DERIVED_CLASS:
				return derivedClass != null;
		}
		return super.eIsSet(featureID);
	}

} //MGeneralizationImpl
