
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.impl;

import com.eu.ales.rpyplugins.MInstance;
import com.eu.ales.rpyplugins.MLink;
import com.eu.ales.rpyplugins.MPort;
import com.eu.ales.rpyplugins.MSysMLPort;
import com.eu.ales.rpyplugins.RpypluginsPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>MLink</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MLinkImpl#getFrom <em>From</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MLinkImpl#getTo <em>To</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MLinkImpl#getFromSysMLPort <em>From Sys ML Port</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MLinkImpl#getToSysMLPort <em>To Sys ML Port</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MLinkImpl#getFromPort <em>From Port</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MLinkImpl#getToPort <em>To Port</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MLinkImpl extends MModelElementImpl implements MLink {
	/**
	 * The cached value of the '{@link #getFrom() <em>From</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFrom()
	 * @generated
	 * @ordered
	 */
	protected MInstance from;

	/**
	 * The cached value of the '{@link #getTo() <em>To</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTo()
	 * @generated
	 * @ordered
	 */
	protected MInstance to;

	/**
	 * The cached value of the '{@link #getFromSysMLPort() <em>From Sys ML Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFromSysMLPort()
	 * @generated
	 * @ordered
	 */
	protected MSysMLPort fromSysMLPort;

	/**
	 * The cached value of the '{@link #getToSysMLPort() <em>To Sys ML Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getToSysMLPort()
	 * @generated
	 * @ordered
	 */
	protected MSysMLPort toSysMLPort;

	/**
	 * The cached value of the '{@link #getFromPort() <em>From Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFromPort()
	 * @generated
	 * @ordered
	 */
	protected MPort fromPort;

	/**
	 * The cached value of the '{@link #getToPort() <em>To Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getToPort()
	 * @generated
	 * @ordered
	 */
	protected MPort toPort;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MLinkImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RpypluginsPackage.Literals.MLINK;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MInstance getFrom() {
		if (from != null && from.eIsProxy()) {
			InternalEObject oldFrom = (InternalEObject)from;
			from = (MInstance)eResolveProxy(oldFrom);
			if (from != oldFrom) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RpypluginsPackage.MLINK__FROM, oldFrom, from));
			}
		}
		return from;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MInstance basicGetFrom() {
		return from;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFrom(MInstance newFrom) {
		MInstance oldFrom = from;
		from = newFrom;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RpypluginsPackage.MLINK__FROM, oldFrom, from));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MInstance getTo() {
		if (to != null && to.eIsProxy()) {
			InternalEObject oldTo = (InternalEObject)to;
			to = (MInstance)eResolveProxy(oldTo);
			if (to != oldTo) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RpypluginsPackage.MLINK__TO, oldTo, to));
			}
		}
		return to;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MInstance basicGetTo() {
		return to;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTo(MInstance newTo) {
		MInstance oldTo = to;
		to = newTo;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RpypluginsPackage.MLINK__TO, oldTo, to));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MSysMLPort getFromSysMLPort() {
		if (fromSysMLPort != null && fromSysMLPort.eIsProxy()) {
			InternalEObject oldFromSysMLPort = (InternalEObject)fromSysMLPort;
			fromSysMLPort = (MSysMLPort)eResolveProxy(oldFromSysMLPort);
			if (fromSysMLPort != oldFromSysMLPort) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RpypluginsPackage.MLINK__FROM_SYS_ML_PORT, oldFromSysMLPort, fromSysMLPort));
			}
		}
		return fromSysMLPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MSysMLPort basicGetFromSysMLPort() {
		return fromSysMLPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFromSysMLPort(MSysMLPort newFromSysMLPort) {
		MSysMLPort oldFromSysMLPort = fromSysMLPort;
		fromSysMLPort = newFromSysMLPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RpypluginsPackage.MLINK__FROM_SYS_ML_PORT, oldFromSysMLPort, fromSysMLPort));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MSysMLPort getToSysMLPort() {
		if (toSysMLPort != null && toSysMLPort.eIsProxy()) {
			InternalEObject oldToSysMLPort = (InternalEObject)toSysMLPort;
			toSysMLPort = (MSysMLPort)eResolveProxy(oldToSysMLPort);
			if (toSysMLPort != oldToSysMLPort) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RpypluginsPackage.MLINK__TO_SYS_ML_PORT, oldToSysMLPort, toSysMLPort));
			}
		}
		return toSysMLPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MSysMLPort basicGetToSysMLPort() {
		return toSysMLPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setToSysMLPort(MSysMLPort newToSysMLPort) {
		MSysMLPort oldToSysMLPort = toSysMLPort;
		toSysMLPort = newToSysMLPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RpypluginsPackage.MLINK__TO_SYS_ML_PORT, oldToSysMLPort, toSysMLPort));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MPort getFromPort() {
		if (fromPort != null && fromPort.eIsProxy()) {
			InternalEObject oldFromPort = (InternalEObject)fromPort;
			fromPort = (MPort)eResolveProxy(oldFromPort);
			if (fromPort != oldFromPort) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RpypluginsPackage.MLINK__FROM_PORT, oldFromPort, fromPort));
			}
		}
		return fromPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MPort basicGetFromPort() {
		return fromPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFromPort(MPort newFromPort) {
		MPort oldFromPort = fromPort;
		fromPort = newFromPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RpypluginsPackage.MLINK__FROM_PORT, oldFromPort, fromPort));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MPort getToPort() {
		if (toPort != null && toPort.eIsProxy()) {
			InternalEObject oldToPort = (InternalEObject)toPort;
			toPort = (MPort)eResolveProxy(oldToPort);
			if (toPort != oldToPort) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RpypluginsPackage.MLINK__TO_PORT, oldToPort, toPort));
			}
		}
		return toPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MPort basicGetToPort() {
		return toPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setToPort(MPort newToPort) {
		MPort oldToPort = toPort;
		toPort = newToPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RpypluginsPackage.MLINK__TO_PORT, oldToPort, toPort));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RpypluginsPackage.MLINK__FROM:
				if (resolve) return getFrom();
				return basicGetFrom();
			case RpypluginsPackage.MLINK__TO:
				if (resolve) return getTo();
				return basicGetTo();
			case RpypluginsPackage.MLINK__FROM_SYS_ML_PORT:
				if (resolve) return getFromSysMLPort();
				return basicGetFromSysMLPort();
			case RpypluginsPackage.MLINK__TO_SYS_ML_PORT:
				if (resolve) return getToSysMLPort();
				return basicGetToSysMLPort();
			case RpypluginsPackage.MLINK__FROM_PORT:
				if (resolve) return getFromPort();
				return basicGetFromPort();
			case RpypluginsPackage.MLINK__TO_PORT:
				if (resolve) return getToPort();
				return basicGetToPort();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RpypluginsPackage.MLINK__FROM:
				setFrom((MInstance)newValue);
				return;
			case RpypluginsPackage.MLINK__TO:
				setTo((MInstance)newValue);
				return;
			case RpypluginsPackage.MLINK__FROM_SYS_ML_PORT:
				setFromSysMLPort((MSysMLPort)newValue);
				return;
			case RpypluginsPackage.MLINK__TO_SYS_ML_PORT:
				setToSysMLPort((MSysMLPort)newValue);
				return;
			case RpypluginsPackage.MLINK__FROM_PORT:
				setFromPort((MPort)newValue);
				return;
			case RpypluginsPackage.MLINK__TO_PORT:
				setToPort((MPort)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RpypluginsPackage.MLINK__FROM:
				setFrom((MInstance)null);
				return;
			case RpypluginsPackage.MLINK__TO:
				setTo((MInstance)null);
				return;
			case RpypluginsPackage.MLINK__FROM_SYS_ML_PORT:
				setFromSysMLPort((MSysMLPort)null);
				return;
			case RpypluginsPackage.MLINK__TO_SYS_ML_PORT:
				setToSysMLPort((MSysMLPort)null);
				return;
			case RpypluginsPackage.MLINK__FROM_PORT:
				setFromPort((MPort)null);
				return;
			case RpypluginsPackage.MLINK__TO_PORT:
				setToPort((MPort)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RpypluginsPackage.MLINK__FROM:
				return from != null;
			case RpypluginsPackage.MLINK__TO:
				return to != null;
			case RpypluginsPackage.MLINK__FROM_SYS_ML_PORT:
				return fromSysMLPort != null;
			case RpypluginsPackage.MLINK__TO_SYS_ML_PORT:
				return toSysMLPort != null;
			case RpypluginsPackage.MLINK__FROM_PORT:
				return fromPort != null;
			case RpypluginsPackage.MLINK__TO_PORT:
				return toPort != null;
		}
		return super.eIsSet(featureID);
	}

} //MLinkImpl
