
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.impl;

import com.eu.ales.rpyplugins.MDependency;
import com.eu.ales.rpyplugins.MModelElement;
import com.eu.ales.rpyplugins.MModelElementRef;
import com.eu.ales.rpyplugins.MProject;
import com.eu.ales.rpyplugins.MStereotype;
import com.eu.ales.rpyplugins.MTag;
import com.eu.ales.rpyplugins.RpypluginsPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>MModel Element</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MModelElementImpl#getMUnsupportedModelElements <em>MUnsupported Model Elements</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MModelElementImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MModelElementImpl#getFullPathName <em>Full Path Name</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MModelElementImpl#getMProject <em>MProject</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MModelElementImpl#getMStereotypes <em>MStereotypes</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MModelElementImpl#getMAllTags <em>MAll Tags</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MModelElementImpl#getMLocalTags <em>MLocal Tags</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MModelElementImpl#getMNestedElements <em>MNested Elements</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MModelElementImpl#getMDependencies <em>MDependencies</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MModelElementImpl#getUri <em>Uri</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MModelElementImpl#getMModelElementRefs <em>MModel Element Refs</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MModelElementImpl extends EObjectImpl implements MModelElement {
	/**
	 * The cached value of the '{@link #getMUnsupportedModelElements() <em>MUnsupported Model Elements</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMUnsupportedModelElements()
	 * @generated
	 * @ordered
	 */
	protected EList<MModelElement> mUnsupportedModelElements;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getFullPathName() <em>Full Path Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFullPathName()
	 * @generated
	 * @ordered
	 */
	protected static final String FULL_PATH_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getFullPathName() <em>Full Path Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFullPathName()
	 * @generated
	 * @ordered
	 */
	protected String fullPathName = FULL_PATH_NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getMProject() <em>MProject</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMProject()
	 * @generated
	 * @ordered
	 */
	protected MProject mProject;

	/**
	 * The cached value of the '{@link #getMStereotypes() <em>MStereotypes</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMStereotypes()
	 * @generated
	 * @ordered
	 */
	protected EList<MStereotype> mStereotypes;

	/**
	 * The cached value of the '{@link #getMAllTags() <em>MAll Tags</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMAllTags()
	 * @generated
	 * @ordered
	 */
	protected EList<MTag> mAllTags;

	/**
	 * The cached value of the '{@link #getMLocalTags() <em>MLocal Tags</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMLocalTags()
	 * @generated
	 * @ordered
	 */
	protected EList<MTag> mLocalTags;

	/**
	 * The cached value of the '{@link #getMNestedElements() <em>MNested Elements</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMNestedElements()
	 * @generated
	 * @ordered
	 */
	protected EList<MModelElement> mNestedElements;

	/**
	 * The cached value of the '{@link #getMDependencies() <em>MDependencies</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMDependencies()
	 * @generated
	 * @ordered
	 */
	protected EList<MDependency> mDependencies;

	/**
	 * The default value of the '{@link #getUri() <em>Uri</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUri()
	 * @generated
	 * @ordered
	 */
	protected static final String URI_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getUri() <em>Uri</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUri()
	 * @generated
	 * @ordered
	 */
	protected String uri = URI_EDEFAULT;

	/**
	 * The cached value of the '{@link #getMModelElementRefs() <em>MModel Element Refs</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMModelElementRefs()
	 * @generated
	 * @ordered
	 */
	protected EList<MModelElementRef> mModelElementRefs;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MModelElementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RpypluginsPackage.Literals.MMODEL_ELEMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MModelElement> getMUnsupportedModelElements() {
		if (mUnsupportedModelElements == null) {
			mUnsupportedModelElements = new EObjectResolvingEList<MModelElement>(MModelElement.class, this, RpypluginsPackage.MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS);
		}
		return mUnsupportedModelElements;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RpypluginsPackage.MMODEL_ELEMENT__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getFullPathName() {
		return fullPathName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFullPathName(String newFullPathName) {
		String oldFullPathName = fullPathName;
		fullPathName = newFullPathName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RpypluginsPackage.MMODEL_ELEMENT__FULL_PATH_NAME, oldFullPathName, fullPathName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MProject getMProject() {
		if (mProject != null && mProject.eIsProxy()) {
			InternalEObject oldMProject = (InternalEObject)mProject;
			mProject = (MProject)eResolveProxy(oldMProject);
			if (mProject != oldMProject) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RpypluginsPackage.MMODEL_ELEMENT__MPROJECT, oldMProject, mProject));
			}
		}
		return mProject;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MProject basicGetMProject() {
		return mProject;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMProject(MProject newMProject) {
		MProject oldMProject = mProject;
		mProject = newMProject;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RpypluginsPackage.MMODEL_ELEMENT__MPROJECT, oldMProject, mProject));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MStereotype> getMStereotypes() {
		if (mStereotypes == null) {
			mStereotypes = new EObjectResolvingEList<MStereotype>(MStereotype.class, this, RpypluginsPackage.MMODEL_ELEMENT__MSTEREOTYPES);
		}
		return mStereotypes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MTag> getMAllTags() {
		if (mAllTags == null) {
			mAllTags = new EObjectResolvingEList<MTag>(MTag.class, this, RpypluginsPackage.MMODEL_ELEMENT__MALL_TAGS);
		}
		return mAllTags;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MTag> getMLocalTags() {
		if (mLocalTags == null) {
			mLocalTags = new EObjectResolvingEList<MTag>(MTag.class, this, RpypluginsPackage.MMODEL_ELEMENT__MLOCAL_TAGS);
		}
		return mLocalTags;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MModelElement> getMNestedElements() {
		if (mNestedElements == null) {
			mNestedElements = new EObjectResolvingEList<MModelElement>(MModelElement.class, this, RpypluginsPackage.MMODEL_ELEMENT__MNESTED_ELEMENTS);
		}
		return mNestedElements;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MDependency> getMDependencies() {
		if (mDependencies == null) {
			mDependencies = new EObjectResolvingEList<MDependency>(MDependency.class, this, RpypluginsPackage.MMODEL_ELEMENT__MDEPENDENCIES);
		}
		return mDependencies;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getUri() {
		return uri;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUri(String newUri) {
		String oldUri = uri;
		uri = newUri;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RpypluginsPackage.MMODEL_ELEMENT__URI, oldUri, uri));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MModelElementRef> getMModelElementRefs() {
		if (mModelElementRefs == null) {
			mModelElementRefs = new EObjectContainmentEList<MModelElementRef>(MModelElementRef.class, this, RpypluginsPackage.MMODEL_ELEMENT__MMODEL_ELEMENT_REFS);
		}
		return mModelElementRefs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RpypluginsPackage.MMODEL_ELEMENT__MMODEL_ELEMENT_REFS:
				return ((InternalEList<?>)getMModelElementRefs()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RpypluginsPackage.MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS:
				return getMUnsupportedModelElements();
			case RpypluginsPackage.MMODEL_ELEMENT__NAME:
				return getName();
			case RpypluginsPackage.MMODEL_ELEMENT__FULL_PATH_NAME:
				return getFullPathName();
			case RpypluginsPackage.MMODEL_ELEMENT__MPROJECT:
				if (resolve) return getMProject();
				return basicGetMProject();
			case RpypluginsPackage.MMODEL_ELEMENT__MSTEREOTYPES:
				return getMStereotypes();
			case RpypluginsPackage.MMODEL_ELEMENT__MALL_TAGS:
				return getMAllTags();
			case RpypluginsPackage.MMODEL_ELEMENT__MLOCAL_TAGS:
				return getMLocalTags();
			case RpypluginsPackage.MMODEL_ELEMENT__MNESTED_ELEMENTS:
				return getMNestedElements();
			case RpypluginsPackage.MMODEL_ELEMENT__MDEPENDENCIES:
				return getMDependencies();
			case RpypluginsPackage.MMODEL_ELEMENT__URI:
				return getUri();
			case RpypluginsPackage.MMODEL_ELEMENT__MMODEL_ELEMENT_REFS:
				return getMModelElementRefs();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RpypluginsPackage.MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS:
				getMUnsupportedModelElements().clear();
				getMUnsupportedModelElements().addAll((Collection<? extends MModelElement>)newValue);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__NAME:
				setName((String)newValue);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__FULL_PATH_NAME:
				setFullPathName((String)newValue);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__MPROJECT:
				setMProject((MProject)newValue);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__MSTEREOTYPES:
				getMStereotypes().clear();
				getMStereotypes().addAll((Collection<? extends MStereotype>)newValue);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__MALL_TAGS:
				getMAllTags().clear();
				getMAllTags().addAll((Collection<? extends MTag>)newValue);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__MLOCAL_TAGS:
				getMLocalTags().clear();
				getMLocalTags().addAll((Collection<? extends MTag>)newValue);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__MNESTED_ELEMENTS:
				getMNestedElements().clear();
				getMNestedElements().addAll((Collection<? extends MModelElement>)newValue);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__MDEPENDENCIES:
				getMDependencies().clear();
				getMDependencies().addAll((Collection<? extends MDependency>)newValue);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__URI:
				setUri((String)newValue);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__MMODEL_ELEMENT_REFS:
				getMModelElementRefs().clear();
				getMModelElementRefs().addAll((Collection<? extends MModelElementRef>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RpypluginsPackage.MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS:
				getMUnsupportedModelElements().clear();
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__NAME:
				setName(NAME_EDEFAULT);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__FULL_PATH_NAME:
				setFullPathName(FULL_PATH_NAME_EDEFAULT);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__MPROJECT:
				setMProject((MProject)null);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__MSTEREOTYPES:
				getMStereotypes().clear();
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__MALL_TAGS:
				getMAllTags().clear();
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__MLOCAL_TAGS:
				getMLocalTags().clear();
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__MNESTED_ELEMENTS:
				getMNestedElements().clear();
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__MDEPENDENCIES:
				getMDependencies().clear();
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__URI:
				setUri(URI_EDEFAULT);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT__MMODEL_ELEMENT_REFS:
				getMModelElementRefs().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RpypluginsPackage.MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS:
				return mUnsupportedModelElements != null && !mUnsupportedModelElements.isEmpty();
			case RpypluginsPackage.MMODEL_ELEMENT__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case RpypluginsPackage.MMODEL_ELEMENT__FULL_PATH_NAME:
				return FULL_PATH_NAME_EDEFAULT == null ? fullPathName != null : !FULL_PATH_NAME_EDEFAULT.equals(fullPathName);
			case RpypluginsPackage.MMODEL_ELEMENT__MPROJECT:
				return mProject != null;
			case RpypluginsPackage.MMODEL_ELEMENT__MSTEREOTYPES:
				return mStereotypes != null && !mStereotypes.isEmpty();
			case RpypluginsPackage.MMODEL_ELEMENT__MALL_TAGS:
				return mAllTags != null && !mAllTags.isEmpty();
			case RpypluginsPackage.MMODEL_ELEMENT__MLOCAL_TAGS:
				return mLocalTags != null && !mLocalTags.isEmpty();
			case RpypluginsPackage.MMODEL_ELEMENT__MNESTED_ELEMENTS:
				return mNestedElements != null && !mNestedElements.isEmpty();
			case RpypluginsPackage.MMODEL_ELEMENT__MDEPENDENCIES:
				return mDependencies != null && !mDependencies.isEmpty();
			case RpypluginsPackage.MMODEL_ELEMENT__URI:
				return URI_EDEFAULT == null ? uri != null : !URI_EDEFAULT.equals(uri);
			case RpypluginsPackage.MMODEL_ELEMENT__MMODEL_ELEMENT_REFS:
				return mModelElementRefs != null && !mModelElementRefs.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", fullPathName: ");
		result.append(fullPathName);
		result.append(", uri: ");
		result.append(uri);
		result.append(')');
		return result.toString();
	}

} //MModelElementImpl
