
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.impl;

import com.eu.ales.rpyplugins.MModelElement;
import com.eu.ales.rpyplugins.MModelElementRef;
import com.eu.ales.rpyplugins.RpypluginsPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>MModel Element Ref</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MModelElementRefImpl#getReference <em>Reference</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MModelElementRefImpl#getStructuralFeatureName <em>Structural Feature Name</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MModelElementRefImpl extends EObjectImpl implements MModelElementRef {
	/**
	 * The cached value of the '{@link #getReference() <em>Reference</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReference()
	 * @generated
	 * @ordered
	 */
	protected MModelElement reference;

	/**
	 * The default value of the '{@link #getStructuralFeatureName() <em>Structural Feature Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStructuralFeatureName()
	 * @generated
	 * @ordered
	 */
	protected static final String STRUCTURAL_FEATURE_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getStructuralFeatureName() <em>Structural Feature Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStructuralFeatureName()
	 * @generated
	 * @ordered
	 */
	protected String structuralFeatureName = STRUCTURAL_FEATURE_NAME_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MModelElementRefImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RpypluginsPackage.Literals.MMODEL_ELEMENT_REF;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MModelElement getReference() {
		if (reference != null && reference.eIsProxy()) {
			InternalEObject oldReference = (InternalEObject)reference;
			reference = (MModelElement)eResolveProxy(oldReference);
			if (reference != oldReference) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RpypluginsPackage.MMODEL_ELEMENT_REF__REFERENCE, oldReference, reference));
			}
		}
		return reference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MModelElement basicGetReference() {
		return reference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setReference(MModelElement newReference) {
		MModelElement oldReference = reference;
		reference = newReference;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RpypluginsPackage.MMODEL_ELEMENT_REF__REFERENCE, oldReference, reference));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getStructuralFeatureName() {
		return structuralFeatureName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStructuralFeatureName(String newStructuralFeatureName) {
		String oldStructuralFeatureName = structuralFeatureName;
		structuralFeatureName = newStructuralFeatureName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RpypluginsPackage.MMODEL_ELEMENT_REF__STRUCTURAL_FEATURE_NAME, oldStructuralFeatureName, structuralFeatureName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RpypluginsPackage.MMODEL_ELEMENT_REF__REFERENCE:
				if (resolve) return getReference();
				return basicGetReference();
			case RpypluginsPackage.MMODEL_ELEMENT_REF__STRUCTURAL_FEATURE_NAME:
				return getStructuralFeatureName();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RpypluginsPackage.MMODEL_ELEMENT_REF__REFERENCE:
				setReference((MModelElement)newValue);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT_REF__STRUCTURAL_FEATURE_NAME:
				setStructuralFeatureName((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RpypluginsPackage.MMODEL_ELEMENT_REF__REFERENCE:
				setReference((MModelElement)null);
				return;
			case RpypluginsPackage.MMODEL_ELEMENT_REF__STRUCTURAL_FEATURE_NAME:
				setStructuralFeatureName(STRUCTURAL_FEATURE_NAME_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RpypluginsPackage.MMODEL_ELEMENT_REF__REFERENCE:
				return reference != null;
			case RpypluginsPackage.MMODEL_ELEMENT_REF__STRUCTURAL_FEATURE_NAME:
				return STRUCTURAL_FEATURE_NAME_EDEFAULT == null ? structuralFeatureName != null : !STRUCTURAL_FEATURE_NAME_EDEFAULT.equals(structuralFeatureName);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (structuralFeatureName: ");
		result.append(structuralFeatureName);
		result.append(')');
		return result.toString();
	}

} //MModelElementRefImpl
