
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.impl;

import com.eu.ales.rpyplugins.MClass;
import com.eu.ales.rpyplugins.MLink;
import com.eu.ales.rpyplugins.MPackage;
import com.eu.ales.rpyplugins.MType;
import com.eu.ales.rpyplugins.RpypluginsPackage;

import java.util.Collection;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>MPackage</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MPackageImpl#getMClasses <em>MClasses</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MPackageImpl#getMLinks <em>MLinks</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MPackageImpl#getMTypes <em>MTypes</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MPackageImpl#getMPackages <em>MPackages</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MPackageImpl extends MUnitImpl implements MPackage {
	/**
	 * The cached value of the '{@link #getMClasses() <em>MClasses</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMClasses()
	 * @generated
	 * @ordered
	 */
	protected EList<MClass> mClasses;

	/**
	 * The cached value of the '{@link #getMLinks() <em>MLinks</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMLinks()
	 * @generated
	 * @ordered
	 */
	protected EList<MLink> mLinks;

	/**
	 * The cached value of the '{@link #getMTypes() <em>MTypes</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMTypes()
	 * @generated
	 * @ordered
	 */
	protected EList<MType> mTypes;

	/**
	 * The cached value of the '{@link #getMPackages() <em>MPackages</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMPackages()
	 * @generated
	 * @ordered
	 */
	protected EList<MPackage> mPackages;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MPackageImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RpypluginsPackage.Literals.MPACKAGE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MClass> getMClasses() {
		if (mClasses == null) {
			mClasses = new EObjectResolvingEList<MClass>(MClass.class, this, RpypluginsPackage.MPACKAGE__MCLASSES);
		}
		return mClasses;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MLink> getMLinks() {
		if (mLinks == null) {
			mLinks = new EObjectResolvingEList<MLink>(MLink.class, this, RpypluginsPackage.MPACKAGE__MLINKS);
		}
		return mLinks;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MType> getMTypes() {
		if (mTypes == null) {
			mTypes = new EObjectResolvingEList<MType>(MType.class, this, RpypluginsPackage.MPACKAGE__MTYPES);
		}
		return mTypes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MPackage> getMPackages() {
		if (mPackages == null) {
			mPackages = new EObjectResolvingEList<MPackage>(MPackage.class, this, RpypluginsPackage.MPACKAGE__MPACKAGES);
		}
		return mPackages;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RpypluginsPackage.MPACKAGE__MCLASSES:
				return getMClasses();
			case RpypluginsPackage.MPACKAGE__MLINKS:
				return getMLinks();
			case RpypluginsPackage.MPACKAGE__MTYPES:
				return getMTypes();
			case RpypluginsPackage.MPACKAGE__MPACKAGES:
				return getMPackages();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RpypluginsPackage.MPACKAGE__MCLASSES:
				getMClasses().clear();
				getMClasses().addAll((Collection<? extends MClass>)newValue);
				return;
			case RpypluginsPackage.MPACKAGE__MLINKS:
				getMLinks().clear();
				getMLinks().addAll((Collection<? extends MLink>)newValue);
				return;
			case RpypluginsPackage.MPACKAGE__MTYPES:
				getMTypes().clear();
				getMTypes().addAll((Collection<? extends MType>)newValue);
				return;
			case RpypluginsPackage.MPACKAGE__MPACKAGES:
				getMPackages().clear();
				getMPackages().addAll((Collection<? extends MPackage>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RpypluginsPackage.MPACKAGE__MCLASSES:
				getMClasses().clear();
				return;
			case RpypluginsPackage.MPACKAGE__MLINKS:
				getMLinks().clear();
				return;
			case RpypluginsPackage.MPACKAGE__MTYPES:
				getMTypes().clear();
				return;
			case RpypluginsPackage.MPACKAGE__MPACKAGES:
				getMPackages().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RpypluginsPackage.MPACKAGE__MCLASSES:
				return mClasses != null && !mClasses.isEmpty();
			case RpypluginsPackage.MPACKAGE__MLINKS:
				return mLinks != null && !mLinks.isEmpty();
			case RpypluginsPackage.MPACKAGE__MTYPES:
				return mTypes != null && !mTypes.isEmpty();
			case RpypluginsPackage.MPACKAGE__MPACKAGES:
				return mPackages != null && !mPackages.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //MPackageImpl
