
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.impl;

import com.eu.ales.rpyplugins.MComponent;
import com.eu.ales.rpyplugins.MModelElement;
import com.eu.ales.rpyplugins.MObjectModelDiagram;
import com.eu.ales.rpyplugins.MProfile;
import com.eu.ales.rpyplugins.MProject;
import com.eu.ales.rpyplugins.MStructureDiagram;
import com.eu.ales.rpyplugins.RpypluginsPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>MProject</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MProjectImpl#getMComponents <em>MComponents</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MProjectImpl#getMObjectModelDiagrams <em>MObject Model Diagrams</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MProjectImpl#getMProfiles <em>MProfiles</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MProjectImpl#getMStructureDiagrams <em>MStructure Diagrams</em>}</li>
 *   <li>{@link com.eu.ales.rpyplugins.impl.MProjectImpl#getMModelElements <em>MModel Elements</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MProjectImpl extends MPackageImpl implements MProject {
	/**
	 * The cached value of the '{@link #getMComponents() <em>MComponents</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMComponents()
	 * @generated
	 * @ordered
	 */
	protected EList<MComponent> mComponents;

	/**
	 * The cached value of the '{@link #getMObjectModelDiagrams() <em>MObject Model Diagrams</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMObjectModelDiagrams()
	 * @generated
	 * @ordered
	 */
	protected EList<MObjectModelDiagram> mObjectModelDiagrams;

	/**
	 * The cached value of the '{@link #getMProfiles() <em>MProfiles</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMProfiles()
	 * @generated
	 * @ordered
	 */
	protected EList<MProfile> mProfiles;

	/**
	 * The cached value of the '{@link #getMStructureDiagrams() <em>MStructure Diagrams</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMStructureDiagrams()
	 * @generated
	 * @ordered
	 */
	protected EList<MStructureDiagram> mStructureDiagrams;

	/**
	 * The cached value of the '{@link #getMModelElements() <em>MModel Elements</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMModelElements()
	 * @generated
	 * @ordered
	 */
	protected EList<MModelElement> mModelElements;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MProjectImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RpypluginsPackage.Literals.MPROJECT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MComponent> getMComponents() {
		if (mComponents == null) {
			mComponents = new EObjectResolvingEList<MComponent>(MComponent.class, this, RpypluginsPackage.MPROJECT__MCOMPONENTS);
		}
		return mComponents;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MObjectModelDiagram> getMObjectModelDiagrams() {
		if (mObjectModelDiagrams == null) {
			mObjectModelDiagrams = new EObjectResolvingEList<MObjectModelDiagram>(MObjectModelDiagram.class, this, RpypluginsPackage.MPROJECT__MOBJECT_MODEL_DIAGRAMS);
		}
		return mObjectModelDiagrams;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MProfile> getMProfiles() {
		if (mProfiles == null) {
			mProfiles = new EObjectResolvingEList<MProfile>(MProfile.class, this, RpypluginsPackage.MPROJECT__MPROFILES);
		}
		return mProfiles;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MStructureDiagram> getMStructureDiagrams() {
		if (mStructureDiagrams == null) {
			mStructureDiagrams = new EObjectResolvingEList<MStructureDiagram>(MStructureDiagram.class, this, RpypluginsPackage.MPROJECT__MSTRUCTURE_DIAGRAMS);
		}
		return mStructureDiagrams;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MModelElement> getMModelElements() {
		if (mModelElements == null) {
			mModelElements = new EObjectContainmentEList<MModelElement>(MModelElement.class, this, RpypluginsPackage.MPROJECT__MMODEL_ELEMENTS);
		}
		return mModelElements;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RpypluginsPackage.MPROJECT__MMODEL_ELEMENTS:
				return ((InternalEList<?>)getMModelElements()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RpypluginsPackage.MPROJECT__MCOMPONENTS:
				return getMComponents();
			case RpypluginsPackage.MPROJECT__MOBJECT_MODEL_DIAGRAMS:
				return getMObjectModelDiagrams();
			case RpypluginsPackage.MPROJECT__MPROFILES:
				return getMProfiles();
			case RpypluginsPackage.MPROJECT__MSTRUCTURE_DIAGRAMS:
				return getMStructureDiagrams();
			case RpypluginsPackage.MPROJECT__MMODEL_ELEMENTS:
				return getMModelElements();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RpypluginsPackage.MPROJECT__MCOMPONENTS:
				getMComponents().clear();
				getMComponents().addAll((Collection<? extends MComponent>)newValue);
				return;
			case RpypluginsPackage.MPROJECT__MOBJECT_MODEL_DIAGRAMS:
				getMObjectModelDiagrams().clear();
				getMObjectModelDiagrams().addAll((Collection<? extends MObjectModelDiagram>)newValue);
				return;
			case RpypluginsPackage.MPROJECT__MPROFILES:
				getMProfiles().clear();
				getMProfiles().addAll((Collection<? extends MProfile>)newValue);
				return;
			case RpypluginsPackage.MPROJECT__MSTRUCTURE_DIAGRAMS:
				getMStructureDiagrams().clear();
				getMStructureDiagrams().addAll((Collection<? extends MStructureDiagram>)newValue);
				return;
			case RpypluginsPackage.MPROJECT__MMODEL_ELEMENTS:
				getMModelElements().clear();
				getMModelElements().addAll((Collection<? extends MModelElement>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RpypluginsPackage.MPROJECT__MCOMPONENTS:
				getMComponents().clear();
				return;
			case RpypluginsPackage.MPROJECT__MOBJECT_MODEL_DIAGRAMS:
				getMObjectModelDiagrams().clear();
				return;
			case RpypluginsPackage.MPROJECT__MPROFILES:
				getMProfiles().clear();
				return;
			case RpypluginsPackage.MPROJECT__MSTRUCTURE_DIAGRAMS:
				getMStructureDiagrams().clear();
				return;
			case RpypluginsPackage.MPROJECT__MMODEL_ELEMENTS:
				getMModelElements().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RpypluginsPackage.MPROJECT__MCOMPONENTS:
				return mComponents != null && !mComponents.isEmpty();
			case RpypluginsPackage.MPROJECT__MOBJECT_MODEL_DIAGRAMS:
				return mObjectModelDiagrams != null && !mObjectModelDiagrams.isEmpty();
			case RpypluginsPackage.MPROJECT__MPROFILES:
				return mProfiles != null && !mProfiles.isEmpty();
			case RpypluginsPackage.MPROJECT__MSTRUCTURE_DIAGRAMS:
				return mStructureDiagrams != null && !mStructureDiagrams.isEmpty();
			case RpypluginsPackage.MPROJECT__MMODEL_ELEMENTS:
				return mModelElements != null && !mModelElements.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //MProjectImpl
