
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.impl;

import com.eu.ales.rpyplugins.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class RpypluginsFactoryImpl extends EFactoryImpl implements RpypluginsFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RpypluginsFactory init() {
		try {
			RpypluginsFactory theRpypluginsFactory = (RpypluginsFactory)EPackage.Registry.INSTANCE.getEFactory("http://www.ales.eu.com/2011/rpyplugins"); 
			if (theRpypluginsFactory != null) {
				return theRpypluginsFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new RpypluginsFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RpypluginsFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case RpypluginsPackage.MATTRIBUTE: return createMAttribute();
			case RpypluginsPackage.MCLASS: return createMClass();
			case RpypluginsPackage.MCLASSIFIER: return createMClassifier();
			case RpypluginsPackage.MCOMPONENT: return createMComponent();
			case RpypluginsPackage.MCONFIGURATION: return createMConfiguration();
			case RpypluginsPackage.MDEPENDENCY: return createMDependency();
			case RpypluginsPackage.MDIAGRAM: return createMDiagram();
			case RpypluginsPackage.MENUMERATION_LITERAL: return createMEnumerationLiteral();
			case RpypluginsPackage.MFILE: return createMFile();
			case RpypluginsPackage.MFLOW: return createMFlow();
			case RpypluginsPackage.MFLOW_ITEM: return createMFlowItem();
			case RpypluginsPackage.MGENERALIZATION: return createMGeneralization();
			case RpypluginsPackage.MINSTANCE: return createMInstance();
			case RpypluginsPackage.MINTERFACE_ITEM: return createMInterfaceItem();
			case RpypluginsPackage.MLINK: return createMLink();
			case RpypluginsPackage.MLITERAL_SPECIFICATION: return createMLiteralSpecification();
			case RpypluginsPackage.MMODEL_ELEMENT: return createMModelElement();
			case RpypluginsPackage.MMODEL_ELEMENT_REF: return createMModelElementRef();
			case RpypluginsPackage.MMODULE: return createMModule();
			case RpypluginsPackage.MOBJECT_MODEL_DIAGRAM: return createMObjectModelDiagram();
			case RpypluginsPackage.MOPERATION: return createMOperation();
			case RpypluginsPackage.MPACKAGE: return createMPackage();
			case RpypluginsPackage.MPORT: return createMPort();
			case RpypluginsPackage.MPROFILE: return createMProfile();
			case RpypluginsPackage.MPROJECT: return createMProject();
			case RpypluginsPackage.MRELATION: return createMRelation();
			case RpypluginsPackage.MSTEREOTYPE: return createMStereotype();
			case RpypluginsPackage.MSTRUCTURE_DIAGRAM: return createMStructureDiagram();
			case RpypluginsPackage.MSYS_ML_PORT: return createMSysMLPort();
			case RpypluginsPackage.MTAG: return createMTag();
			case RpypluginsPackage.MTEMPLATE_PARAMETER: return createMTemplateParameter();
			case RpypluginsPackage.MTYPE: return createMType();
			case RpypluginsPackage.MUNIT: return createMUnit();
			case RpypluginsPackage.MUNSUPPORTED_MODEL_ELEMENT: return createMUnsupportedModelElement();
			case RpypluginsPackage.MVALUE_SPECIFICATION: return createMValueSpecification();
			case RpypluginsPackage.MVARIABLE: return createMVariable();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MAttribute createMAttribute() {
		MAttributeImpl mAttribute = new MAttributeImpl();
		return mAttribute;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MClass createMClass() {
		MClassImpl mClass = new MClassImpl();
		return mClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MClassifier createMClassifier() {
		MClassifierImpl mClassifier = new MClassifierImpl();
		return mClassifier;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MComponent createMComponent() {
		MComponentImpl mComponent = new MComponentImpl();
		return mComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MConfiguration createMConfiguration() {
		MConfigurationImpl mConfiguration = new MConfigurationImpl();
		return mConfiguration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MDependency createMDependency() {
		MDependencyImpl mDependency = new MDependencyImpl();
		return mDependency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MDiagram createMDiagram() {
		MDiagramImpl mDiagram = new MDiagramImpl();
		return mDiagram;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MEnumerationLiteral createMEnumerationLiteral() {
		MEnumerationLiteralImpl mEnumerationLiteral = new MEnumerationLiteralImpl();
		return mEnumerationLiteral;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MFile createMFile() {
		MFileImpl mFile = new MFileImpl();
		return mFile;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MFlow createMFlow() {
		MFlowImpl mFlow = new MFlowImpl();
		return mFlow;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MFlowItem createMFlowItem() {
		MFlowItemImpl mFlowItem = new MFlowItemImpl();
		return mFlowItem;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MGeneralization createMGeneralization() {
		MGeneralizationImpl mGeneralization = new MGeneralizationImpl();
		return mGeneralization;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MInstance createMInstance() {
		MInstanceImpl mInstance = new MInstanceImpl();
		return mInstance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MInterfaceItem createMInterfaceItem() {
		MInterfaceItemImpl mInterfaceItem = new MInterfaceItemImpl();
		return mInterfaceItem;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MLink createMLink() {
		MLinkImpl mLink = new MLinkImpl();
		return mLink;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MLiteralSpecification createMLiteralSpecification() {
		MLiteralSpecificationImpl mLiteralSpecification = new MLiteralSpecificationImpl();
		return mLiteralSpecification;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MModelElement createMModelElement() {
		MModelElementImpl mModelElement = new MModelElementImpl();
		return mModelElement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MModelElementRef createMModelElementRef() {
		MModelElementRefImpl mModelElementRef = new MModelElementRefImpl();
		return mModelElementRef;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MModule createMModule() {
		MModuleImpl mModule = new MModuleImpl();
		return mModule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MObjectModelDiagram createMObjectModelDiagram() {
		MObjectModelDiagramImpl mObjectModelDiagram = new MObjectModelDiagramImpl();
		return mObjectModelDiagram;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MOperation createMOperation() {
		MOperationImpl mOperation = new MOperationImpl();
		return mOperation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MPackage createMPackage() {
		MPackageImpl mPackage = new MPackageImpl();
		return mPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MPort createMPort() {
		MPortImpl mPort = new MPortImpl();
		return mPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MProfile createMProfile() {
		MProfileImpl mProfile = new MProfileImpl();
		return mProfile;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MProject createMProject() {
		MProjectImpl mProject = new MProjectImpl();
		return mProject;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MRelation createMRelation() {
		MRelationImpl mRelation = new MRelationImpl();
		return mRelation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MStereotype createMStereotype() {
		MStereotypeImpl mStereotype = new MStereotypeImpl();
		return mStereotype;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MStructureDiagram createMStructureDiagram() {
		MStructureDiagramImpl mStructureDiagram = new MStructureDiagramImpl();
		return mStructureDiagram;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MSysMLPort createMSysMLPort() {
		MSysMLPortImpl mSysMLPort = new MSysMLPortImpl();
		return mSysMLPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MTag createMTag() {
		MTagImpl mTag = new MTagImpl();
		return mTag;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MTemplateParameter createMTemplateParameter() {
		MTemplateParameterImpl mTemplateParameter = new MTemplateParameterImpl();
		return mTemplateParameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MType createMType() {
		MTypeImpl mType = new MTypeImpl();
		return mType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MUnit createMUnit() {
		MUnitImpl mUnit = new MUnitImpl();
		return mUnit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MUnsupportedModelElement createMUnsupportedModelElement() {
		MUnsupportedModelElementImpl mUnsupportedModelElement = new MUnsupportedModelElementImpl();
		return mUnsupportedModelElement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MValueSpecification createMValueSpecification() {
		MValueSpecificationImpl mValueSpecification = new MValueSpecificationImpl();
		return mValueSpecification;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MVariable createMVariable() {
		MVariableImpl mVariable = new MVariableImpl();
		return mVariable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RpypluginsPackage getRpypluginsPackage() {
		return (RpypluginsPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static RpypluginsPackage getPackage() {
		return RpypluginsPackage.eINSTANCE;
	}

} //RpypluginsFactoryImpl
