
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.impl;

import com.eu.ales.rpyplugins.MAttribute;
import com.eu.ales.rpyplugins.MClass;
import com.eu.ales.rpyplugins.MClassifier;
import com.eu.ales.rpyplugins.MComponent;
import com.eu.ales.rpyplugins.MConfiguration;
import com.eu.ales.rpyplugins.MDependency;
import com.eu.ales.rpyplugins.MDiagram;
import com.eu.ales.rpyplugins.MEnumerationLiteral;
import com.eu.ales.rpyplugins.MFile;
import com.eu.ales.rpyplugins.MFlow;
import com.eu.ales.rpyplugins.MFlowItem;
import com.eu.ales.rpyplugins.MGeneralization;
import com.eu.ales.rpyplugins.MInstance;
import com.eu.ales.rpyplugins.MInterfaceItem;
import com.eu.ales.rpyplugins.MLink;
import com.eu.ales.rpyplugins.MLiteralSpecification;
import com.eu.ales.rpyplugins.MModelElement;
import com.eu.ales.rpyplugins.MModelElementRef;
import com.eu.ales.rpyplugins.MModule;
import com.eu.ales.rpyplugins.MObjectModelDiagram;
import com.eu.ales.rpyplugins.MOperation;
import com.eu.ales.rpyplugins.MPackage;
import com.eu.ales.rpyplugins.MPort;
import com.eu.ales.rpyplugins.MProfile;
import com.eu.ales.rpyplugins.MProject;
import com.eu.ales.rpyplugins.MRelation;
import com.eu.ales.rpyplugins.MStereotype;
import com.eu.ales.rpyplugins.MStructureDiagram;
import com.eu.ales.rpyplugins.MSysMLPort;
import com.eu.ales.rpyplugins.MTag;
import com.eu.ales.rpyplugins.MTemplateParameter;
import com.eu.ales.rpyplugins.MType;
import com.eu.ales.rpyplugins.MUnit;
import com.eu.ales.rpyplugins.MUnsupportedModelElement;
import com.eu.ales.rpyplugins.MValueSpecification;
import com.eu.ales.rpyplugins.MVariable;
import com.eu.ales.rpyplugins.RpypluginsFactory;
import com.eu.ales.rpyplugins.RpypluginsPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class RpypluginsPackageImpl extends EPackageImpl implements RpypluginsPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mAttributeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mClassEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mClassifierEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mComponentEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mConfigurationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mDependencyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mDiagramEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mEnumerationLiteralEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mFileEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mFlowEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mFlowItemEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mGeneralizationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mInstanceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mInterfaceItemEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mLinkEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mLiteralSpecificationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mModelElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mModelElementRefEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mModuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mObjectModelDiagramEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mOperationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mPackageEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mPortEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mProfileEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mProjectEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mRelationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mStereotypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mStructureDiagramEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mSysMLPortEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mTagEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mTemplateParameterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mUnitEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mUnsupportedModelElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mValueSpecificationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mVariableEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see com.eu.ales.rpyplugins.RpypluginsPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private RpypluginsPackageImpl() {
		super(eNS_URI, RpypluginsFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link RpypluginsPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static RpypluginsPackage init() {
		if (isInited) return (RpypluginsPackage)EPackage.Registry.INSTANCE.getEPackage(RpypluginsPackage.eNS_URI);

		// Obtain or create and register package
		RpypluginsPackageImpl theRpypluginsPackage = (RpypluginsPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof RpypluginsPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new RpypluginsPackageImpl());

		isInited = true;

		// Create package meta-data objects
		theRpypluginsPackage.createPackageContents();

		// Initialize created meta-data
		theRpypluginsPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theRpypluginsPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(RpypluginsPackage.eNS_URI, theRpypluginsPackage);
		return theRpypluginsPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMAttribute() {
		return mAttributeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMAttribute_Multiplicity() {
		return (EAttribute)mAttributeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMClass() {
		return mClassEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMClassifier() {
		return mClassifierEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMClassifier_MPorts() {
		return (EReference)mClassifierEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMClassifier_MRelations() {
		return (EReference)mClassifierEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMClassifier_MOperations() {
		return (EReference)mClassifierEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMClassifier_MGeneralizations() {
		return (EReference)mClassifierEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMClassifier_MAttributes() {
		return (EReference)mClassifierEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMClassifier_MInterfaceItems() {
		return (EReference)mClassifierEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMClassifier_MFlows() {
		return (EReference)mClassifierEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMClassifier_MFlowItems() {
		return (EReference)mClassifierEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMClassifier_MLinks() {
		return (EReference)mClassifierEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMComponent() {
		return mComponentEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMConfiguration() {
		return mConfigurationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMDependency() {
		return mDependencyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMDiagram() {
		return mDiagramEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMEnumerationLiteral() {
		return mEnumerationLiteralEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMFile() {
		return mFileEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMFlow() {
		return mFlowEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMFlowItem() {
		return mFlowItemEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMGeneralization() {
		return mGeneralizationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMGeneralization_BaseClass() {
		return (EReference)mGeneralizationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMGeneralization_DerivedClass() {
		return (EReference)mGeneralizationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMInstance() {
		return mInstanceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMInstance_MAttributeValues() {
		return (EReference)mInstanceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMInterfaceItem() {
		return mInterfaceItemEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMLink() {
		return mLinkEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMLink_From() {
		return (EReference)mLinkEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMLink_To() {
		return (EReference)mLinkEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMLink_FromSysMLPort() {
		return (EReference)mLinkEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMLink_ToSysMLPort() {
		return (EReference)mLinkEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMLink_FromPort() {
		return (EReference)mLinkEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMLink_ToPort() {
		return (EReference)mLinkEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMLiteralSpecification() {
		return mLiteralSpecificationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMLiteralSpecification_Value() {
		return (EAttribute)mLiteralSpecificationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMModelElement() {
		return mModelElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMModelElement_MUnsupportedModelElements() {
		return (EReference)mModelElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMModelElement_Name() {
		return (EAttribute)mModelElementEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMModelElement_FullPathName() {
		return (EAttribute)mModelElementEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMModelElement_MProject() {
		return (EReference)mModelElementEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMModelElement_MStereotypes() {
		return (EReference)mModelElementEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMModelElement_MAllTags() {
		return (EReference)mModelElementEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMModelElement_MLocalTags() {
		return (EReference)mModelElementEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMModelElement_MNestedElements() {
		return (EReference)mModelElementEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMModelElement_MDependencies() {
		return (EReference)mModelElementEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMModelElement_Uri() {
		return (EAttribute)mModelElementEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMModelElement_MModelElementRefs() {
		return (EReference)mModelElementEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMModelElementRef() {
		return mModelElementRefEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMModelElementRef_Reference() {
		return (EReference)mModelElementRefEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMModelElementRef_StructuralFeatureName() {
		return (EAttribute)mModelElementRefEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMModule() {
		return mModuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMObjectModelDiagram() {
		return mObjectModelDiagramEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMOperation() {
		return mOperationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMOperation_ReturnType() {
		return (EReference)mOperationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMPackage() {
		return mPackageEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMPackage_MClasses() {
		return (EReference)mPackageEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMPackage_MLinks() {
		return (EReference)mPackageEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMPackage_MTypes() {
		return (EReference)mPackageEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMPackage_MPackages() {
		return (EReference)mPackageEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMPort() {
		return mPortEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMProfile() {
		return mProfileEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMProject() {
		return mProjectEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMProject_MComponents() {
		return (EReference)mProjectEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMProject_MObjectModelDiagrams() {
		return (EReference)mProjectEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMProject_MProfiles() {
		return (EReference)mProjectEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMProject_MStructureDiagrams() {
		return (EReference)mProjectEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMProject_MModelElements() {
		return (EReference)mProjectEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMRelation() {
		return mRelationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMRelation_OtherClass() {
		return (EReference)mRelationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMRelation_OfClass() {
		return (EReference)mRelationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMRelation_Multiplicity() {
		return (EAttribute)mRelationEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMStereotype() {
		return mStereotypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMStereotype_IsNewTerm() {
		return (EAttribute)mStereotypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMStereotype_OfMetaClass() {
		return (EAttribute)mStereotypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMStructureDiagram() {
		return mStructureDiagramEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMSysMLPort() {
		return mSysMLPortEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMSysMLPort_Type() {
		return (EReference)mSysMLPortEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMSysMLPort_PortDirection() {
		return (EAttribute)mSysMLPortEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMTag() {
		return mTagEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMTag_Value() {
		return (EAttribute)mTagEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMTemplateParameter() {
		return mTemplateParameterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMType() {
		return mTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMUnit() {
		return mUnitEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMUnsupportedModelElement() {
		return mUnsupportedModelElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMUnsupportedModelElement_ClassName() {
		return (EAttribute)mUnsupportedModelElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMUnsupportedModelElement_StructuralFeatureName() {
		return (EAttribute)mUnsupportedModelElementEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMValueSpecification() {
		return mValueSpecificationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMVariable() {
		return mVariableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMVariable_Type() {
		return (EReference)mVariableEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMVariable_DefaultValue() {
		return (EAttribute)mVariableEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMVariable_MValueSpecifications() {
		return (EReference)mVariableEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RpypluginsFactory getRpypluginsFactory() {
		return (RpypluginsFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		mAttributeEClass = createEClass(MATTRIBUTE);
		createEAttribute(mAttributeEClass, MATTRIBUTE__MULTIPLICITY);

		mClassEClass = createEClass(MCLASS);

		mClassifierEClass = createEClass(MCLASSIFIER);
		createEReference(mClassifierEClass, MCLASSIFIER__MPORTS);
		createEReference(mClassifierEClass, MCLASSIFIER__MRELATIONS);
		createEReference(mClassifierEClass, MCLASSIFIER__MOPERATIONS);
		createEReference(mClassifierEClass, MCLASSIFIER__MGENERALIZATIONS);
		createEReference(mClassifierEClass, MCLASSIFIER__MATTRIBUTES);
		createEReference(mClassifierEClass, MCLASSIFIER__MINTERFACE_ITEMS);
		createEReference(mClassifierEClass, MCLASSIFIER__MFLOWS);
		createEReference(mClassifierEClass, MCLASSIFIER__MFLOW_ITEMS);
		createEReference(mClassifierEClass, MCLASSIFIER__MLINKS);

		mComponentEClass = createEClass(MCOMPONENT);

		mConfigurationEClass = createEClass(MCONFIGURATION);

		mDependencyEClass = createEClass(MDEPENDENCY);

		mDiagramEClass = createEClass(MDIAGRAM);

		mEnumerationLiteralEClass = createEClass(MENUMERATION_LITERAL);

		mFileEClass = createEClass(MFILE);

		mFlowEClass = createEClass(MFLOW);

		mFlowItemEClass = createEClass(MFLOW_ITEM);

		mGeneralizationEClass = createEClass(MGENERALIZATION);
		createEReference(mGeneralizationEClass, MGENERALIZATION__BASE_CLASS);
		createEReference(mGeneralizationEClass, MGENERALIZATION__DERIVED_CLASS);

		mInstanceEClass = createEClass(MINSTANCE);
		createEReference(mInstanceEClass, MINSTANCE__MATTRIBUTE_VALUES);

		mInterfaceItemEClass = createEClass(MINTERFACE_ITEM);

		mLinkEClass = createEClass(MLINK);
		createEReference(mLinkEClass, MLINK__FROM);
		createEReference(mLinkEClass, MLINK__TO);
		createEReference(mLinkEClass, MLINK__FROM_SYS_ML_PORT);
		createEReference(mLinkEClass, MLINK__TO_SYS_ML_PORT);
		createEReference(mLinkEClass, MLINK__FROM_PORT);
		createEReference(mLinkEClass, MLINK__TO_PORT);

		mLiteralSpecificationEClass = createEClass(MLITERAL_SPECIFICATION);
		createEAttribute(mLiteralSpecificationEClass, MLITERAL_SPECIFICATION__VALUE);

		mModelElementEClass = createEClass(MMODEL_ELEMENT);
		createEReference(mModelElementEClass, MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS);
		createEAttribute(mModelElementEClass, MMODEL_ELEMENT__NAME);
		createEAttribute(mModelElementEClass, MMODEL_ELEMENT__FULL_PATH_NAME);
		createEReference(mModelElementEClass, MMODEL_ELEMENT__MPROJECT);
		createEReference(mModelElementEClass, MMODEL_ELEMENT__MSTEREOTYPES);
		createEReference(mModelElementEClass, MMODEL_ELEMENT__MALL_TAGS);
		createEReference(mModelElementEClass, MMODEL_ELEMENT__MLOCAL_TAGS);
		createEReference(mModelElementEClass, MMODEL_ELEMENT__MNESTED_ELEMENTS);
		createEReference(mModelElementEClass, MMODEL_ELEMENT__MDEPENDENCIES);
		createEAttribute(mModelElementEClass, MMODEL_ELEMENT__URI);
		createEReference(mModelElementEClass, MMODEL_ELEMENT__MMODEL_ELEMENT_REFS);

		mModelElementRefEClass = createEClass(MMODEL_ELEMENT_REF);
		createEReference(mModelElementRefEClass, MMODEL_ELEMENT_REF__REFERENCE);
		createEAttribute(mModelElementRefEClass, MMODEL_ELEMENT_REF__STRUCTURAL_FEATURE_NAME);

		mModuleEClass = createEClass(MMODULE);

		mObjectModelDiagramEClass = createEClass(MOBJECT_MODEL_DIAGRAM);

		mOperationEClass = createEClass(MOPERATION);
		createEReference(mOperationEClass, MOPERATION__RETURN_TYPE);

		mPackageEClass = createEClass(MPACKAGE);
		createEReference(mPackageEClass, MPACKAGE__MCLASSES);
		createEReference(mPackageEClass, MPACKAGE__MLINKS);
		createEReference(mPackageEClass, MPACKAGE__MTYPES);
		createEReference(mPackageEClass, MPACKAGE__MPACKAGES);

		mPortEClass = createEClass(MPORT);

		mProfileEClass = createEClass(MPROFILE);

		mProjectEClass = createEClass(MPROJECT);
		createEReference(mProjectEClass, MPROJECT__MCOMPONENTS);
		createEReference(mProjectEClass, MPROJECT__MOBJECT_MODEL_DIAGRAMS);
		createEReference(mProjectEClass, MPROJECT__MPROFILES);
		createEReference(mProjectEClass, MPROJECT__MSTRUCTURE_DIAGRAMS);
		createEReference(mProjectEClass, MPROJECT__MMODEL_ELEMENTS);

		mRelationEClass = createEClass(MRELATION);
		createEReference(mRelationEClass, MRELATION__OTHER_CLASS);
		createEReference(mRelationEClass, MRELATION__OF_CLASS);
		createEAttribute(mRelationEClass, MRELATION__MULTIPLICITY);

		mStereotypeEClass = createEClass(MSTEREOTYPE);
		createEAttribute(mStereotypeEClass, MSTEREOTYPE__IS_NEW_TERM);
		createEAttribute(mStereotypeEClass, MSTEREOTYPE__OF_META_CLASS);

		mStructureDiagramEClass = createEClass(MSTRUCTURE_DIAGRAM);

		mSysMLPortEClass = createEClass(MSYS_ML_PORT);
		createEReference(mSysMLPortEClass, MSYS_ML_PORT__TYPE);
		createEAttribute(mSysMLPortEClass, MSYS_ML_PORT__PORT_DIRECTION);

		mTagEClass = createEClass(MTAG);
		createEAttribute(mTagEClass, MTAG__VALUE);

		mTemplateParameterEClass = createEClass(MTEMPLATE_PARAMETER);

		mTypeEClass = createEClass(MTYPE);

		mUnitEClass = createEClass(MUNIT);

		mUnsupportedModelElementEClass = createEClass(MUNSUPPORTED_MODEL_ELEMENT);
		createEAttribute(mUnsupportedModelElementEClass, MUNSUPPORTED_MODEL_ELEMENT__CLASS_NAME);
		createEAttribute(mUnsupportedModelElementEClass, MUNSUPPORTED_MODEL_ELEMENT__STRUCTURAL_FEATURE_NAME);

		mValueSpecificationEClass = createEClass(MVALUE_SPECIFICATION);

		mVariableEClass = createEClass(MVARIABLE);
		createEReference(mVariableEClass, MVARIABLE__TYPE);
		createEAttribute(mVariableEClass, MVARIABLE__DEFAULT_VALUE);
		createEReference(mVariableEClass, MVARIABLE__MVALUE_SPECIFICATIONS);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		mAttributeEClass.getESuperTypes().add(this.getMVariable());
		mClassEClass.getESuperTypes().add(this.getMClassifier());
		mClassifierEClass.getESuperTypes().add(this.getMUnit());
		mComponentEClass.getESuperTypes().add(this.getMUnit());
		mConfigurationEClass.getESuperTypes().add(this.getMModelElement());
		mDependencyEClass.getESuperTypes().add(this.getMModelElement());
		mDiagramEClass.getESuperTypes().add(this.getMUnit());
		mEnumerationLiteralEClass.getESuperTypes().add(this.getMModelElement());
		mFileEClass.getESuperTypes().add(this.getMUnit());
		mFlowEClass.getESuperTypes().add(this.getMModelElement());
		mFlowItemEClass.getESuperTypes().add(this.getMClassifier());
		mGeneralizationEClass.getESuperTypes().add(this.getMModelElement());
		mInstanceEClass.getESuperTypes().add(this.getMRelation());
		mInterfaceItemEClass.getESuperTypes().add(this.getMClassifier());
		mLinkEClass.getESuperTypes().add(this.getMModelElement());
		mLiteralSpecificationEClass.getESuperTypes().add(this.getMValueSpecification());
		mModuleEClass.getESuperTypes().add(this.getMInstance());
		mObjectModelDiagramEClass.getESuperTypes().add(this.getMDiagram());
		mOperationEClass.getESuperTypes().add(this.getMInterfaceItem());
		mPackageEClass.getESuperTypes().add(this.getMUnit());
		mPortEClass.getESuperTypes().add(this.getMInstance());
		mProfileEClass.getESuperTypes().add(this.getMPackage());
		mProjectEClass.getESuperTypes().add(this.getMPackage());
		mRelationEClass.getESuperTypes().add(this.getMUnit());
		mStereotypeEClass.getESuperTypes().add(this.getMClassifier());
		mStructureDiagramEClass.getESuperTypes().add(this.getMDiagram());
		mSysMLPortEClass.getESuperTypes().add(this.getMInstance());
		mTagEClass.getESuperTypes().add(this.getMVariable());
		mTemplateParameterEClass.getESuperTypes().add(this.getMVariable());
		mTypeEClass.getESuperTypes().add(this.getMClassifier());
		mUnitEClass.getESuperTypes().add(this.getMModelElement());
		mUnsupportedModelElementEClass.getESuperTypes().add(this.getMModelElement());
		mValueSpecificationEClass.getESuperTypes().add(this.getMModelElement());
		mVariableEClass.getESuperTypes().add(this.getMModelElement());

		// Initialize classes and features; add operations and parameters
		initEClass(mAttributeEClass, MAttribute.class, "MAttribute", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMAttribute_Multiplicity(), ecorePackage.getEString(), "multiplicity", null, 0, 1, MAttribute.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mClassEClass, MClass.class, "MClass", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mClassifierEClass, MClassifier.class, "MClassifier", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMClassifier_MPorts(), this.getMPort(), null, "mPorts", null, 0, -1, MClassifier.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMClassifier_MRelations(), this.getMRelation(), null, "mRelations", null, 0, -1, MClassifier.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMClassifier_MOperations(), this.getMOperation(), null, "mOperations", null, 0, -1, MClassifier.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMClassifier_MGeneralizations(), this.getMGeneralization(), null, "mGeneralizations", null, 0, -1, MClassifier.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMClassifier_MAttributes(), this.getMAttribute(), null, "mAttributes", null, 0, -1, MClassifier.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMClassifier_MInterfaceItems(), this.getMInterfaceItem(), null, "mInterfaceItems", null, 0, -1, MClassifier.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMClassifier_MFlows(), this.getMFlow(), null, "mFlows", null, 0, -1, MClassifier.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMClassifier_MFlowItems(), this.getMFlowItem(), null, "mFlowItems", null, 0, -1, MClassifier.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMClassifier_MLinks(), this.getMLink(), null, "mLinks", null, 0, -1, MClassifier.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mComponentEClass, MComponent.class, "MComponent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mConfigurationEClass, MConfiguration.class, "MConfiguration", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mDependencyEClass, MDependency.class, "MDependency", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mDiagramEClass, MDiagram.class, "MDiagram", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mEnumerationLiteralEClass, MEnumerationLiteral.class, "MEnumerationLiteral", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mFileEClass, MFile.class, "MFile", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mFlowEClass, MFlow.class, "MFlow", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mFlowItemEClass, MFlowItem.class, "MFlowItem", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mGeneralizationEClass, MGeneralization.class, "MGeneralization", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMGeneralization_BaseClass(), this.getMClassifier(), null, "baseClass", null, 0, 1, MGeneralization.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMGeneralization_DerivedClass(), this.getMClassifier(), null, "derivedClass", null, 0, 1, MGeneralization.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mInstanceEClass, MInstance.class, "MInstance", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMInstance_MAttributeValues(), this.getMAttribute(), null, "mAttributeValues", null, 0, -1, MInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mInterfaceItemEClass, MInterfaceItem.class, "MInterfaceItem", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mLinkEClass, MLink.class, "MLink", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMLink_From(), this.getMInstance(), null, "from", null, 0, 1, MLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMLink_To(), this.getMInstance(), null, "to", null, 0, 1, MLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMLink_FromSysMLPort(), this.getMSysMLPort(), null, "fromSysMLPort", null, 0, 1, MLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMLink_ToSysMLPort(), this.getMSysMLPort(), null, "toSysMLPort", null, 0, 1, MLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMLink_FromPort(), this.getMPort(), null, "fromPort", null, 0, 1, MLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMLink_ToPort(), this.getMPort(), null, "toPort", null, 0, 1, MLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mLiteralSpecificationEClass, MLiteralSpecification.class, "MLiteralSpecification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMLiteralSpecification_Value(), ecorePackage.getEString(), "value", null, 0, 1, MLiteralSpecification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mModelElementEClass, MModelElement.class, "MModelElement", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMModelElement_MUnsupportedModelElements(), this.getMModelElement(), null, "mUnsupportedModelElements", null, 0, -1, MModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMModelElement_Name(), ecorePackage.getEString(), "name", null, 0, 1, MModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMModelElement_FullPathName(), ecorePackage.getEString(), "fullPathName", null, 0, 1, MModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMModelElement_MProject(), this.getMProject(), null, "mProject", null, 0, 1, MModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMModelElement_MStereotypes(), this.getMStereotype(), null, "mStereotypes", null, 0, -1, MModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMModelElement_MAllTags(), this.getMTag(), null, "mAllTags", null, 0, -1, MModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMModelElement_MLocalTags(), this.getMTag(), null, "mLocalTags", null, 0, -1, MModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMModelElement_MNestedElements(), this.getMModelElement(), null, "mNestedElements", null, 0, -1, MModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMModelElement_MDependencies(), this.getMDependency(), null, "mDependencies", null, 0, -1, MModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMModelElement_Uri(), ecorePackage.getEString(), "uri", null, 0, 1, MModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMModelElement_MModelElementRefs(), this.getMModelElementRef(), null, "mModelElementRefs", null, 0, -1, MModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mModelElementRefEClass, MModelElementRef.class, "MModelElementRef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMModelElementRef_Reference(), this.getMModelElement(), null, "reference", null, 1, 1, MModelElementRef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMModelElementRef_StructuralFeatureName(), ecorePackage.getEString(), "structuralFeatureName", null, 0, 1, MModelElementRef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mModuleEClass, MModule.class, "MModule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mObjectModelDiagramEClass, MObjectModelDiagram.class, "MObjectModelDiagram", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mOperationEClass, MOperation.class, "MOperation", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMOperation_ReturnType(), this.getMClassifier(), null, "returnType", null, 0, 1, MOperation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mPackageEClass, MPackage.class, "MPackage", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMPackage_MClasses(), this.getMClass(), null, "mClasses", null, 0, -1, MPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMPackage_MLinks(), this.getMLink(), null, "mLinks", null, 0, -1, MPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMPackage_MTypes(), this.getMType(), null, "mTypes", null, 0, -1, MPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMPackage_MPackages(), this.getMPackage(), null, "mPackages", null, 0, -1, MPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mPortEClass, MPort.class, "MPort", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mProfileEClass, MProfile.class, "MProfile", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mProjectEClass, MProject.class, "MProject", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMProject_MComponents(), this.getMComponent(), null, "mComponents", null, 0, -1, MProject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMProject_MObjectModelDiagrams(), this.getMObjectModelDiagram(), null, "mObjectModelDiagrams", null, 0, -1, MProject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMProject_MProfiles(), this.getMProfile(), null, "mProfiles", null, 0, -1, MProject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMProject_MStructureDiagrams(), this.getMStructureDiagram(), null, "mStructureDiagrams", null, 0, -1, MProject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMProject_MModelElements(), this.getMModelElement(), null, "mModelElements", null, 0, -1, MProject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mRelationEClass, MRelation.class, "MRelation", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMRelation_OtherClass(), this.getMClassifier(), null, "otherClass", null, 0, 1, MRelation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMRelation_OfClass(), this.getMClassifier(), null, "ofClass", null, 0, 1, MRelation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMRelation_Multiplicity(), ecorePackage.getEString(), "multiplicity", null, 0, 1, MRelation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mStereotypeEClass, MStereotype.class, "MStereotype", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMStereotype_IsNewTerm(), ecorePackage.getEInt(), "isNewTerm", null, 0, 1, MStereotype.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMStereotype_OfMetaClass(), ecorePackage.getEString(), "ofMetaClass", null, 0, 1, MStereotype.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mStructureDiagramEClass, MStructureDiagram.class, "MStructureDiagram", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mSysMLPortEClass, MSysMLPort.class, "MSysMLPort", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMSysMLPort_Type(), this.getMClassifier(), null, "type", null, 0, 1, MSysMLPort.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMSysMLPort_PortDirection(), ecorePackage.getEString(), "portDirection", "", 0, 1, MSysMLPort.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mTagEClass, MTag.class, "MTag", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMTag_Value(), ecorePackage.getEString(), "value", null, 0, 1, MTag.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mTemplateParameterEClass, MTemplateParameter.class, "MTemplateParameter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mTypeEClass, MType.class, "MType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mUnitEClass, MUnit.class, "MUnit", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mUnsupportedModelElementEClass, MUnsupportedModelElement.class, "MUnsupportedModelElement", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMUnsupportedModelElement_ClassName(), ecorePackage.getEString(), "className", null, 0, 1, MUnsupportedModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMUnsupportedModelElement_StructuralFeatureName(), ecorePackage.getEString(), "structuralFeatureName", null, 0, 1, MUnsupportedModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mValueSpecificationEClass, MValueSpecification.class, "MValueSpecification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mVariableEClass, MVariable.class, "MVariable", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMVariable_Type(), this.getMClassifier(), null, "type", null, 0, 1, MVariable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMVariable_DefaultValue(), ecorePackage.getEString(), "defaultValue", null, 0, 1, MVariable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMVariable_MValueSpecifications(), this.getMValueSpecification(), null, "mValueSpecifications", null, 0, -1, MVariable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Create resource
		createResource(eNS_URI);
	}

} //RpypluginsPackageImpl
