
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.util;

import com.eu.ales.rpyplugins.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see com.eu.ales.rpyplugins.RpypluginsPackage
 * @generated
 */
public class RpypluginsAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static RpypluginsPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RpypluginsAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = RpypluginsPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RpypluginsSwitch<Adapter> modelSwitch =
		new RpypluginsSwitch<Adapter>() {
			@Override
			public Adapter caseMAttribute(MAttribute object) {
				return createMAttributeAdapter();
			}
			@Override
			public Adapter caseMClass(MClass object) {
				return createMClassAdapter();
			}
			@Override
			public Adapter caseMClassifier(MClassifier object) {
				return createMClassifierAdapter();
			}
			@Override
			public Adapter caseMComponent(MComponent object) {
				return createMComponentAdapter();
			}
			@Override
			public Adapter caseMConfiguration(MConfiguration object) {
				return createMConfigurationAdapter();
			}
			@Override
			public Adapter caseMDependency(MDependency object) {
				return createMDependencyAdapter();
			}
			@Override
			public Adapter caseMDiagram(MDiagram object) {
				return createMDiagramAdapter();
			}
			@Override
			public Adapter caseMEnumerationLiteral(MEnumerationLiteral object) {
				return createMEnumerationLiteralAdapter();
			}
			@Override
			public Adapter caseMFile(MFile object) {
				return createMFileAdapter();
			}
			@Override
			public Adapter caseMFlow(MFlow object) {
				return createMFlowAdapter();
			}
			@Override
			public Adapter caseMFlowItem(MFlowItem object) {
				return createMFlowItemAdapter();
			}
			@Override
			public Adapter caseMGeneralization(MGeneralization object) {
				return createMGeneralizationAdapter();
			}
			@Override
			public Adapter caseMInstance(MInstance object) {
				return createMInstanceAdapter();
			}
			@Override
			public Adapter caseMInterfaceItem(MInterfaceItem object) {
				return createMInterfaceItemAdapter();
			}
			@Override
			public Adapter caseMLink(MLink object) {
				return createMLinkAdapter();
			}
			@Override
			public Adapter caseMLiteralSpecification(MLiteralSpecification object) {
				return createMLiteralSpecificationAdapter();
			}
			@Override
			public Adapter caseMModelElement(MModelElement object) {
				return createMModelElementAdapter();
			}
			@Override
			public Adapter caseMModelElementRef(MModelElementRef object) {
				return createMModelElementRefAdapter();
			}
			@Override
			public Adapter caseMModule(MModule object) {
				return createMModuleAdapter();
			}
			@Override
			public Adapter caseMObjectModelDiagram(MObjectModelDiagram object) {
				return createMObjectModelDiagramAdapter();
			}
			@Override
			public Adapter caseMOperation(MOperation object) {
				return createMOperationAdapter();
			}
			@Override
			public Adapter caseMPackage(MPackage object) {
				return createMPackageAdapter();
			}
			@Override
			public Adapter caseMPort(MPort object) {
				return createMPortAdapter();
			}
			@Override
			public Adapter caseMProfile(MProfile object) {
				return createMProfileAdapter();
			}
			@Override
			public Adapter caseMProject(MProject object) {
				return createMProjectAdapter();
			}
			@Override
			public Adapter caseMRelation(MRelation object) {
				return createMRelationAdapter();
			}
			@Override
			public Adapter caseMStereotype(MStereotype object) {
				return createMStereotypeAdapter();
			}
			@Override
			public Adapter caseMStructureDiagram(MStructureDiagram object) {
				return createMStructureDiagramAdapter();
			}
			@Override
			public Adapter caseMSysMLPort(MSysMLPort object) {
				return createMSysMLPortAdapter();
			}
			@Override
			public Adapter caseMTag(MTag object) {
				return createMTagAdapter();
			}
			@Override
			public Adapter caseMTemplateParameter(MTemplateParameter object) {
				return createMTemplateParameterAdapter();
			}
			@Override
			public Adapter caseMType(MType object) {
				return createMTypeAdapter();
			}
			@Override
			public Adapter caseMUnit(MUnit object) {
				return createMUnitAdapter();
			}
			@Override
			public Adapter caseMUnsupportedModelElement(MUnsupportedModelElement object) {
				return createMUnsupportedModelElementAdapter();
			}
			@Override
			public Adapter caseMValueSpecification(MValueSpecification object) {
				return createMValueSpecificationAdapter();
			}
			@Override
			public Adapter caseMVariable(MVariable object) {
				return createMVariableAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MAttribute <em>MAttribute</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MAttribute
	 * @generated
	 */
	public Adapter createMAttributeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MClass <em>MClass</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MClass
	 * @generated
	 */
	public Adapter createMClassAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MClassifier <em>MClassifier</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MClassifier
	 * @generated
	 */
	public Adapter createMClassifierAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MComponent <em>MComponent</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MComponent
	 * @generated
	 */
	public Adapter createMComponentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MConfiguration <em>MConfiguration</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MConfiguration
	 * @generated
	 */
	public Adapter createMConfigurationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MDependency <em>MDependency</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MDependency
	 * @generated
	 */
	public Adapter createMDependencyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MDiagram <em>MDiagram</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MDiagram
	 * @generated
	 */
	public Adapter createMDiagramAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MEnumerationLiteral <em>MEnumeration Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MEnumerationLiteral
	 * @generated
	 */
	public Adapter createMEnumerationLiteralAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MFile <em>MFile</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MFile
	 * @generated
	 */
	public Adapter createMFileAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MFlow <em>MFlow</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MFlow
	 * @generated
	 */
	public Adapter createMFlowAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MFlowItem <em>MFlow Item</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MFlowItem
	 * @generated
	 */
	public Adapter createMFlowItemAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MGeneralization <em>MGeneralization</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MGeneralization
	 * @generated
	 */
	public Adapter createMGeneralizationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MInstance <em>MInstance</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MInstance
	 * @generated
	 */
	public Adapter createMInstanceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MInterfaceItem <em>MInterface Item</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MInterfaceItem
	 * @generated
	 */
	public Adapter createMInterfaceItemAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MLink <em>MLink</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MLink
	 * @generated
	 */
	public Adapter createMLinkAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MLiteralSpecification <em>MLiteral Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MLiteralSpecification
	 * @generated
	 */
	public Adapter createMLiteralSpecificationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MModelElement <em>MModel Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MModelElement
	 * @generated
	 */
	public Adapter createMModelElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MModelElementRef <em>MModel Element Ref</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MModelElementRef
	 * @generated
	 */
	public Adapter createMModelElementRefAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MModule <em>MModule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MModule
	 * @generated
	 */
	public Adapter createMModuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MObjectModelDiagram <em>MObject Model Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MObjectModelDiagram
	 * @generated
	 */
	public Adapter createMObjectModelDiagramAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MOperation <em>MOperation</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MOperation
	 * @generated
	 */
	public Adapter createMOperationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MPackage <em>MPackage</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MPackage
	 * @generated
	 */
	public Adapter createMPackageAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MPort <em>MPort</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MPort
	 * @generated
	 */
	public Adapter createMPortAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MProfile <em>MProfile</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MProfile
	 * @generated
	 */
	public Adapter createMProfileAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MProject <em>MProject</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MProject
	 * @generated
	 */
	public Adapter createMProjectAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MRelation <em>MRelation</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MRelation
	 * @generated
	 */
	public Adapter createMRelationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MStereotype <em>MStereotype</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MStereotype
	 * @generated
	 */
	public Adapter createMStereotypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MStructureDiagram <em>MStructure Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MStructureDiagram
	 * @generated
	 */
	public Adapter createMStructureDiagramAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MSysMLPort <em>MSys ML Port</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MSysMLPort
	 * @generated
	 */
	public Adapter createMSysMLPortAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MTag <em>MTag</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MTag
	 * @generated
	 */
	public Adapter createMTagAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MTemplateParameter <em>MTemplate Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MTemplateParameter
	 * @generated
	 */
	public Adapter createMTemplateParameterAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MType <em>MType</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MType
	 * @generated
	 */
	public Adapter createMTypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MUnit <em>MUnit</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MUnit
	 * @generated
	 */
	public Adapter createMUnitAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MUnsupportedModelElement <em>MUnsupported Model Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MUnsupportedModelElement
	 * @generated
	 */
	public Adapter createMUnsupportedModelElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MValueSpecification <em>MValue Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MValueSpecification
	 * @generated
	 */
	public Adapter createMValueSpecificationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.eu.ales.rpyplugins.MVariable <em>MVariable</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.eu.ales.rpyplugins.MVariable
	 * @generated
	 */
	public Adapter createMVariableAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //RpypluginsAdapterFactory
