
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.util;

import com.eu.ales.rpyplugins.*;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see com.eu.ales.rpyplugins.RpypluginsPackage
 * @generated
 */
public class RpypluginsSwitch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static RpypluginsPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RpypluginsSwitch() {
		if (modelPackage == null) {
			modelPackage = RpypluginsPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public T doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List<EClass> eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch(eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case RpypluginsPackage.MATTRIBUTE: {
				MAttribute mAttribute = (MAttribute)theEObject;
				T result = caseMAttribute(mAttribute);
				if (result == null) result = caseMVariable(mAttribute);
				if (result == null) result = caseMModelElement(mAttribute);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MCLASS: {
				MClass mClass = (MClass)theEObject;
				T result = caseMClass(mClass);
				if (result == null) result = caseMClassifier(mClass);
				if (result == null) result = caseMUnit(mClass);
				if (result == null) result = caseMModelElement(mClass);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MCLASSIFIER: {
				MClassifier mClassifier = (MClassifier)theEObject;
				T result = caseMClassifier(mClassifier);
				if (result == null) result = caseMUnit(mClassifier);
				if (result == null) result = caseMModelElement(mClassifier);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MCOMPONENT: {
				MComponent mComponent = (MComponent)theEObject;
				T result = caseMComponent(mComponent);
				if (result == null) result = caseMUnit(mComponent);
				if (result == null) result = caseMModelElement(mComponent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MCONFIGURATION: {
				MConfiguration mConfiguration = (MConfiguration)theEObject;
				T result = caseMConfiguration(mConfiguration);
				if (result == null) result = caseMModelElement(mConfiguration);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MDEPENDENCY: {
				MDependency mDependency = (MDependency)theEObject;
				T result = caseMDependency(mDependency);
				if (result == null) result = caseMModelElement(mDependency);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MDIAGRAM: {
				MDiagram mDiagram = (MDiagram)theEObject;
				T result = caseMDiagram(mDiagram);
				if (result == null) result = caseMUnit(mDiagram);
				if (result == null) result = caseMModelElement(mDiagram);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MENUMERATION_LITERAL: {
				MEnumerationLiteral mEnumerationLiteral = (MEnumerationLiteral)theEObject;
				T result = caseMEnumerationLiteral(mEnumerationLiteral);
				if (result == null) result = caseMModelElement(mEnumerationLiteral);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MFILE: {
				MFile mFile = (MFile)theEObject;
				T result = caseMFile(mFile);
				if (result == null) result = caseMUnit(mFile);
				if (result == null) result = caseMModelElement(mFile);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MFLOW: {
				MFlow mFlow = (MFlow)theEObject;
				T result = caseMFlow(mFlow);
				if (result == null) result = caseMModelElement(mFlow);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MFLOW_ITEM: {
				MFlowItem mFlowItem = (MFlowItem)theEObject;
				T result = caseMFlowItem(mFlowItem);
				if (result == null) result = caseMClassifier(mFlowItem);
				if (result == null) result = caseMUnit(mFlowItem);
				if (result == null) result = caseMModelElement(mFlowItem);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MGENERALIZATION: {
				MGeneralization mGeneralization = (MGeneralization)theEObject;
				T result = caseMGeneralization(mGeneralization);
				if (result == null) result = caseMModelElement(mGeneralization);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MINSTANCE: {
				MInstance mInstance = (MInstance)theEObject;
				T result = caseMInstance(mInstance);
				if (result == null) result = caseMRelation(mInstance);
				if (result == null) result = caseMUnit(mInstance);
				if (result == null) result = caseMModelElement(mInstance);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MINTERFACE_ITEM: {
				MInterfaceItem mInterfaceItem = (MInterfaceItem)theEObject;
				T result = caseMInterfaceItem(mInterfaceItem);
				if (result == null) result = caseMClassifier(mInterfaceItem);
				if (result == null) result = caseMUnit(mInterfaceItem);
				if (result == null) result = caseMModelElement(mInterfaceItem);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MLINK: {
				MLink mLink = (MLink)theEObject;
				T result = caseMLink(mLink);
				if (result == null) result = caseMModelElement(mLink);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MLITERAL_SPECIFICATION: {
				MLiteralSpecification mLiteralSpecification = (MLiteralSpecification)theEObject;
				T result = caseMLiteralSpecification(mLiteralSpecification);
				if (result == null) result = caseMValueSpecification(mLiteralSpecification);
				if (result == null) result = caseMModelElement(mLiteralSpecification);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MMODEL_ELEMENT: {
				MModelElement mModelElement = (MModelElement)theEObject;
				T result = caseMModelElement(mModelElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MMODEL_ELEMENT_REF: {
				MModelElementRef mModelElementRef = (MModelElementRef)theEObject;
				T result = caseMModelElementRef(mModelElementRef);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MMODULE: {
				MModule mModule = (MModule)theEObject;
				T result = caseMModule(mModule);
				if (result == null) result = caseMInstance(mModule);
				if (result == null) result = caseMRelation(mModule);
				if (result == null) result = caseMUnit(mModule);
				if (result == null) result = caseMModelElement(mModule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MOBJECT_MODEL_DIAGRAM: {
				MObjectModelDiagram mObjectModelDiagram = (MObjectModelDiagram)theEObject;
				T result = caseMObjectModelDiagram(mObjectModelDiagram);
				if (result == null) result = caseMDiagram(mObjectModelDiagram);
				if (result == null) result = caseMUnit(mObjectModelDiagram);
				if (result == null) result = caseMModelElement(mObjectModelDiagram);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MOPERATION: {
				MOperation mOperation = (MOperation)theEObject;
				T result = caseMOperation(mOperation);
				if (result == null) result = caseMInterfaceItem(mOperation);
				if (result == null) result = caseMClassifier(mOperation);
				if (result == null) result = caseMUnit(mOperation);
				if (result == null) result = caseMModelElement(mOperation);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MPACKAGE: {
				MPackage mPackage = (MPackage)theEObject;
				T result = caseMPackage(mPackage);
				if (result == null) result = caseMUnit(mPackage);
				if (result == null) result = caseMModelElement(mPackage);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MPORT: {
				MPort mPort = (MPort)theEObject;
				T result = caseMPort(mPort);
				if (result == null) result = caseMInstance(mPort);
				if (result == null) result = caseMRelation(mPort);
				if (result == null) result = caseMUnit(mPort);
				if (result == null) result = caseMModelElement(mPort);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MPROFILE: {
				MProfile mProfile = (MProfile)theEObject;
				T result = caseMProfile(mProfile);
				if (result == null) result = caseMPackage(mProfile);
				if (result == null) result = caseMUnit(mProfile);
				if (result == null) result = caseMModelElement(mProfile);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MPROJECT: {
				MProject mProject = (MProject)theEObject;
				T result = caseMProject(mProject);
				if (result == null) result = caseMPackage(mProject);
				if (result == null) result = caseMUnit(mProject);
				if (result == null) result = caseMModelElement(mProject);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MRELATION: {
				MRelation mRelation = (MRelation)theEObject;
				T result = caseMRelation(mRelation);
				if (result == null) result = caseMUnit(mRelation);
				if (result == null) result = caseMModelElement(mRelation);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MSTEREOTYPE: {
				MStereotype mStereotype = (MStereotype)theEObject;
				T result = caseMStereotype(mStereotype);
				if (result == null) result = caseMClassifier(mStereotype);
				if (result == null) result = caseMUnit(mStereotype);
				if (result == null) result = caseMModelElement(mStereotype);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MSTRUCTURE_DIAGRAM: {
				MStructureDiagram mStructureDiagram = (MStructureDiagram)theEObject;
				T result = caseMStructureDiagram(mStructureDiagram);
				if (result == null) result = caseMDiagram(mStructureDiagram);
				if (result == null) result = caseMUnit(mStructureDiagram);
				if (result == null) result = caseMModelElement(mStructureDiagram);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MSYS_ML_PORT: {
				MSysMLPort mSysMLPort = (MSysMLPort)theEObject;
				T result = caseMSysMLPort(mSysMLPort);
				if (result == null) result = caseMInstance(mSysMLPort);
				if (result == null) result = caseMRelation(mSysMLPort);
				if (result == null) result = caseMUnit(mSysMLPort);
				if (result == null) result = caseMModelElement(mSysMLPort);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MTAG: {
				MTag mTag = (MTag)theEObject;
				T result = caseMTag(mTag);
				if (result == null) result = caseMVariable(mTag);
				if (result == null) result = caseMModelElement(mTag);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MTEMPLATE_PARAMETER: {
				MTemplateParameter mTemplateParameter = (MTemplateParameter)theEObject;
				T result = caseMTemplateParameter(mTemplateParameter);
				if (result == null) result = caseMVariable(mTemplateParameter);
				if (result == null) result = caseMModelElement(mTemplateParameter);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MTYPE: {
				MType mType = (MType)theEObject;
				T result = caseMType(mType);
				if (result == null) result = caseMClassifier(mType);
				if (result == null) result = caseMUnit(mType);
				if (result == null) result = caseMModelElement(mType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MUNIT: {
				MUnit mUnit = (MUnit)theEObject;
				T result = caseMUnit(mUnit);
				if (result == null) result = caseMModelElement(mUnit);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MUNSUPPORTED_MODEL_ELEMENT: {
				MUnsupportedModelElement mUnsupportedModelElement = (MUnsupportedModelElement)theEObject;
				T result = caseMUnsupportedModelElement(mUnsupportedModelElement);
				if (result == null) result = caseMModelElement(mUnsupportedModelElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MVALUE_SPECIFICATION: {
				MValueSpecification mValueSpecification = (MValueSpecification)theEObject;
				T result = caseMValueSpecification(mValueSpecification);
				if (result == null) result = caseMModelElement(mValueSpecification);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RpypluginsPackage.MVARIABLE: {
				MVariable mVariable = (MVariable)theEObject;
				T result = caseMVariable(mVariable);
				if (result == null) result = caseMModelElement(mVariable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MAttribute</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MAttribute</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMAttribute(MAttribute object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MClass</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MClass</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMClass(MClass object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MClassifier</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MClassifier</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMClassifier(MClassifier object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MComponent</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MComponent</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMComponent(MComponent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MConfiguration</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MConfiguration</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMConfiguration(MConfiguration object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MDependency</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MDependency</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMDependency(MDependency object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MDiagram</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MDiagram</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMDiagram(MDiagram object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MEnumeration Literal</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MEnumeration Literal</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMEnumerationLiteral(MEnumerationLiteral object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MFile</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MFile</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMFile(MFile object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MFlow</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MFlow</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMFlow(MFlow object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MFlow Item</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MFlow Item</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMFlowItem(MFlowItem object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MGeneralization</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MGeneralization</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMGeneralization(MGeneralization object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MInstance</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MInstance</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMInstance(MInstance object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MInterface Item</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MInterface Item</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMInterfaceItem(MInterfaceItem object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MLink</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MLink</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLink(MLink object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MLiteral Specification</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MLiteral Specification</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLiteralSpecification(MLiteralSpecification object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MModel Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MModel Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMModelElement(MModelElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MModel Element Ref</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MModel Element Ref</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMModelElementRef(MModelElementRef object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MModule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MModule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMModule(MModule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MObject Model Diagram</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MObject Model Diagram</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMObjectModelDiagram(MObjectModelDiagram object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MOperation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MOperation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMOperation(MOperation object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MPackage</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MPackage</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMPackage(MPackage object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MPort</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MPort</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMPort(MPort object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MProfile</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MProfile</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMProfile(MProfile object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MProject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MProject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMProject(MProject object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MRelation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MRelation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMRelation(MRelation object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MStereotype</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MStereotype</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMStereotype(MStereotype object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MStructure Diagram</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MStructure Diagram</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMStructureDiagram(MStructureDiagram object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MSys ML Port</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MSys ML Port</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMSysMLPort(MSysMLPort object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MTag</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MTag</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMTag(MTag object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MTemplate Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MTemplate Parameter</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMTemplateParameter(MTemplateParameter object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MType</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MType</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMType(MType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MUnit</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MUnit</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMUnit(MUnit object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MUnsupported Model Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MUnsupported Model Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMUnsupportedModelElement(MUnsupportedModelElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MValue Specification</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MValue Specification</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMValueSpecification(MValueSpecification object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MVariable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MVariable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMVariable(MVariable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public T defaultCase(EObject object) {
		return null;
	}

} //RpypluginsSwitch
