
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins.rpyparser;

import java.io.IOException;

/**
 * This class provides the interface to the Rhapsody parser.
 * See RpyParserImpl for documentation on how the parser works.
 * @author leon
 *
 */
public interface RpyParser {
	/**
	 * This function causes the parser to start.
	 */
	void create();

	/**
	 * This function returns the root of the parsed model.
	 * @return
	 */
	com.eu.ales.rpyplugins.MProject getModel();
	
	/**
	 * This function saves the parsed model to file in xmi format.
	 * @param outputFile
	 * @throws IOException
	 */
	void saveToFile();

	/**
	 * Print out model to Rhapsody Log pane
	 */
	void printOut();
}
