
/****************************************************************************************
#  Copyright (c) 2011, ALES S.r.l. - Via C. Bartolomeo Piazza 13, 00161 Roma Italy      #
#  Developed with the sponsorship of the Defense Advanced Research Projects             #
#  Agency (DARPA).                                                                      #
#                                                                                       #
#  Delivered to the Government with Unlimited Rights under Contract #FA8650-10-C-7074.  #
#                                                                                       #
#  THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR               #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,             #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE          #
#  AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE          #
#  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF                   #
#  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE          #
#  DATA OR THE USE OR OTHER DEALINGS IN THE DATA.                                       #
****************************************************************************************/

package com.eu.ales.rpyplugins;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.eu.ales.rpyplugins.RpypluginsFactory
 * @model kind="package"
 * @generated
 */
public interface RpypluginsPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "rpyplugins";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.ales.eu.com/2011/rpyplugins";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "rpyplugins";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	RpypluginsPackage eINSTANCE = com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MModelElementImpl <em>MModel Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MModelElementImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMModelElement()
	 * @generated
	 */
	int MMODEL_ELEMENT = 16;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT__NAME = 1;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT__FULL_PATH_NAME = 2;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT__MPROJECT = 3;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT__MSTEREOTYPES = 4;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT__MALL_TAGS = 5;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT__MLOCAL_TAGS = 6;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT__MNESTED_ELEMENTS = 7;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT__MDEPENDENCIES = 8;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT__URI = 9;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT__MMODEL_ELEMENT_REFS = 10;

	/**
	 * The number of structural features of the '<em>MModel Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT_FEATURE_COUNT = 11;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MVariableImpl <em>MVariable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MVariableImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMVariable()
	 * @generated
	 */
	int MVARIABLE = 35;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE__MUNSUPPORTED_MODEL_ELEMENTS = MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE__NAME = MMODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE__FULL_PATH_NAME = MMODEL_ELEMENT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE__MPROJECT = MMODEL_ELEMENT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE__MSTEREOTYPES = MMODEL_ELEMENT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE__MALL_TAGS = MMODEL_ELEMENT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE__MLOCAL_TAGS = MMODEL_ELEMENT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE__MNESTED_ELEMENTS = MMODEL_ELEMENT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE__MDEPENDENCIES = MMODEL_ELEMENT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE__URI = MMODEL_ELEMENT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE__MMODEL_ELEMENT_REFS = MMODEL_ELEMENT__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE__TYPE = MMODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE__DEFAULT_VALUE = MMODEL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>MValue Specifications</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE__MVALUE_SPECIFICATIONS = MMODEL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>MVariable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVARIABLE_FEATURE_COUNT = MMODEL_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MAttributeImpl <em>MAttribute</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MAttributeImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMAttribute()
	 * @generated
	 */
	int MATTRIBUTE = 0;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__MUNSUPPORTED_MODEL_ELEMENTS = MVARIABLE__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__NAME = MVARIABLE__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__FULL_PATH_NAME = MVARIABLE__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__MPROJECT = MVARIABLE__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__MSTEREOTYPES = MVARIABLE__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__MALL_TAGS = MVARIABLE__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__MLOCAL_TAGS = MVARIABLE__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__MNESTED_ELEMENTS = MVARIABLE__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__MDEPENDENCIES = MVARIABLE__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__URI = MVARIABLE__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__MMODEL_ELEMENT_REFS = MVARIABLE__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__TYPE = MVARIABLE__TYPE;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__DEFAULT_VALUE = MVARIABLE__DEFAULT_VALUE;

	/**
	 * The feature id for the '<em><b>MValue Specifications</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__MVALUE_SPECIFICATIONS = MVARIABLE__MVALUE_SPECIFICATIONS;

	/**
	 * The feature id for the '<em><b>Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE__MULTIPLICITY = MVARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MAttribute</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATTRIBUTE_FEATURE_COUNT = MVARIABLE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MUnitImpl <em>MUnit</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MUnitImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMUnit()
	 * @generated
	 */
	int MUNIT = 32;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNIT__MUNSUPPORTED_MODEL_ELEMENTS = MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNIT__NAME = MMODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNIT__FULL_PATH_NAME = MMODEL_ELEMENT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNIT__MPROJECT = MMODEL_ELEMENT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNIT__MSTEREOTYPES = MMODEL_ELEMENT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNIT__MALL_TAGS = MMODEL_ELEMENT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNIT__MLOCAL_TAGS = MMODEL_ELEMENT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNIT__MNESTED_ELEMENTS = MMODEL_ELEMENT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNIT__MDEPENDENCIES = MMODEL_ELEMENT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNIT__URI = MMODEL_ELEMENT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNIT__MMODEL_ELEMENT_REFS = MMODEL_ELEMENT__MMODEL_ELEMENT_REFS;

	/**
	 * The number of structural features of the '<em>MUnit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNIT_FEATURE_COUNT = MMODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MClassifierImpl <em>MClassifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MClassifierImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMClassifier()
	 * @generated
	 */
	int MCLASSIFIER = 2;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MUNSUPPORTED_MODEL_ELEMENTS = MUNIT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__NAME = MUNIT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__FULL_PATH_NAME = MUNIT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MPROJECT = MUNIT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MSTEREOTYPES = MUNIT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MALL_TAGS = MUNIT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MLOCAL_TAGS = MUNIT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MNESTED_ELEMENTS = MUNIT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MDEPENDENCIES = MUNIT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__URI = MUNIT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MMODEL_ELEMENT_REFS = MUNIT__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>MPorts</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MPORTS = MUNIT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>MRelations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MRELATIONS = MUNIT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>MOperations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MOPERATIONS = MUNIT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>MGeneralizations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MGENERALIZATIONS = MUNIT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>MAttributes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MATTRIBUTES = MUNIT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>MInterface Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MINTERFACE_ITEMS = MUNIT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>MFlows</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MFLOWS = MUNIT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>MFlow Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MFLOW_ITEMS = MUNIT_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>MLinks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER__MLINKS = MUNIT_FEATURE_COUNT + 8;

	/**
	 * The number of structural features of the '<em>MClassifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSIFIER_FEATURE_COUNT = MUNIT_FEATURE_COUNT + 9;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MClassImpl <em>MClass</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MClassImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMClass()
	 * @generated
	 */
	int MCLASS = 1;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MUNSUPPORTED_MODEL_ELEMENTS = MCLASSIFIER__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__NAME = MCLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__FULL_PATH_NAME = MCLASSIFIER__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MPROJECT = MCLASSIFIER__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MSTEREOTYPES = MCLASSIFIER__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MALL_TAGS = MCLASSIFIER__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MLOCAL_TAGS = MCLASSIFIER__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MNESTED_ELEMENTS = MCLASSIFIER__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MDEPENDENCIES = MCLASSIFIER__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__URI = MCLASSIFIER__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MMODEL_ELEMENT_REFS = MCLASSIFIER__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>MPorts</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MPORTS = MCLASSIFIER__MPORTS;

	/**
	 * The feature id for the '<em><b>MRelations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MRELATIONS = MCLASSIFIER__MRELATIONS;

	/**
	 * The feature id for the '<em><b>MOperations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MOPERATIONS = MCLASSIFIER__MOPERATIONS;

	/**
	 * The feature id for the '<em><b>MGeneralizations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MGENERALIZATIONS = MCLASSIFIER__MGENERALIZATIONS;

	/**
	 * The feature id for the '<em><b>MAttributes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MATTRIBUTES = MCLASSIFIER__MATTRIBUTES;

	/**
	 * The feature id for the '<em><b>MInterface Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MINTERFACE_ITEMS = MCLASSIFIER__MINTERFACE_ITEMS;

	/**
	 * The feature id for the '<em><b>MFlows</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MFLOWS = MCLASSIFIER__MFLOWS;

	/**
	 * The feature id for the '<em><b>MFlow Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MFLOW_ITEMS = MCLASSIFIER__MFLOW_ITEMS;

	/**
	 * The feature id for the '<em><b>MLinks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS__MLINKS = MCLASSIFIER__MLINKS;

	/**
	 * The number of structural features of the '<em>MClass</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASS_FEATURE_COUNT = MCLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MComponentImpl <em>MComponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MComponentImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMComponent()
	 * @generated
	 */
	int MCOMPONENT = 3;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCOMPONENT__MUNSUPPORTED_MODEL_ELEMENTS = MUNIT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCOMPONENT__NAME = MUNIT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCOMPONENT__FULL_PATH_NAME = MUNIT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCOMPONENT__MPROJECT = MUNIT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCOMPONENT__MSTEREOTYPES = MUNIT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCOMPONENT__MALL_TAGS = MUNIT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCOMPONENT__MLOCAL_TAGS = MUNIT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCOMPONENT__MNESTED_ELEMENTS = MUNIT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCOMPONENT__MDEPENDENCIES = MUNIT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCOMPONENT__URI = MUNIT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCOMPONENT__MMODEL_ELEMENT_REFS = MUNIT__MMODEL_ELEMENT_REFS;

	/**
	 * The number of structural features of the '<em>MComponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCOMPONENT_FEATURE_COUNT = MUNIT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MConfigurationImpl <em>MConfiguration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MConfigurationImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMConfiguration()
	 * @generated
	 */
	int MCONFIGURATION = 4;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCONFIGURATION__MUNSUPPORTED_MODEL_ELEMENTS = MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCONFIGURATION__NAME = MMODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCONFIGURATION__FULL_PATH_NAME = MMODEL_ELEMENT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCONFIGURATION__MPROJECT = MMODEL_ELEMENT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCONFIGURATION__MSTEREOTYPES = MMODEL_ELEMENT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCONFIGURATION__MALL_TAGS = MMODEL_ELEMENT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCONFIGURATION__MLOCAL_TAGS = MMODEL_ELEMENT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCONFIGURATION__MNESTED_ELEMENTS = MMODEL_ELEMENT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCONFIGURATION__MDEPENDENCIES = MMODEL_ELEMENT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCONFIGURATION__URI = MMODEL_ELEMENT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCONFIGURATION__MMODEL_ELEMENT_REFS = MMODEL_ELEMENT__MMODEL_ELEMENT_REFS;

	/**
	 * The number of structural features of the '<em>MConfiguration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCONFIGURATION_FEATURE_COUNT = MMODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MDependencyImpl <em>MDependency</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MDependencyImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMDependency()
	 * @generated
	 */
	int MDEPENDENCY = 5;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDEPENDENCY__MUNSUPPORTED_MODEL_ELEMENTS = MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDEPENDENCY__NAME = MMODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDEPENDENCY__FULL_PATH_NAME = MMODEL_ELEMENT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDEPENDENCY__MPROJECT = MMODEL_ELEMENT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDEPENDENCY__MSTEREOTYPES = MMODEL_ELEMENT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDEPENDENCY__MALL_TAGS = MMODEL_ELEMENT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDEPENDENCY__MLOCAL_TAGS = MMODEL_ELEMENT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDEPENDENCY__MNESTED_ELEMENTS = MMODEL_ELEMENT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDEPENDENCY__MDEPENDENCIES = MMODEL_ELEMENT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDEPENDENCY__URI = MMODEL_ELEMENT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDEPENDENCY__MMODEL_ELEMENT_REFS = MMODEL_ELEMENT__MMODEL_ELEMENT_REFS;

	/**
	 * The number of structural features of the '<em>MDependency</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDEPENDENCY_FEATURE_COUNT = MMODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MDiagramImpl <em>MDiagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MDiagramImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMDiagram()
	 * @generated
	 */
	int MDIAGRAM = 6;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDIAGRAM__MUNSUPPORTED_MODEL_ELEMENTS = MUNIT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDIAGRAM__NAME = MUNIT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDIAGRAM__FULL_PATH_NAME = MUNIT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDIAGRAM__MPROJECT = MUNIT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDIAGRAM__MSTEREOTYPES = MUNIT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDIAGRAM__MALL_TAGS = MUNIT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDIAGRAM__MLOCAL_TAGS = MUNIT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDIAGRAM__MNESTED_ELEMENTS = MUNIT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDIAGRAM__MDEPENDENCIES = MUNIT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDIAGRAM__URI = MUNIT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDIAGRAM__MMODEL_ELEMENT_REFS = MUNIT__MMODEL_ELEMENT_REFS;

	/**
	 * The number of structural features of the '<em>MDiagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDIAGRAM_FEATURE_COUNT = MUNIT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MEnumerationLiteralImpl <em>MEnumeration Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MEnumerationLiteralImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMEnumerationLiteral()
	 * @generated
	 */
	int MENUMERATION_LITERAL = 7;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MENUMERATION_LITERAL__MUNSUPPORTED_MODEL_ELEMENTS = MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MENUMERATION_LITERAL__NAME = MMODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MENUMERATION_LITERAL__FULL_PATH_NAME = MMODEL_ELEMENT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MENUMERATION_LITERAL__MPROJECT = MMODEL_ELEMENT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MENUMERATION_LITERAL__MSTEREOTYPES = MMODEL_ELEMENT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MENUMERATION_LITERAL__MALL_TAGS = MMODEL_ELEMENT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MENUMERATION_LITERAL__MLOCAL_TAGS = MMODEL_ELEMENT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MENUMERATION_LITERAL__MNESTED_ELEMENTS = MMODEL_ELEMENT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MENUMERATION_LITERAL__MDEPENDENCIES = MMODEL_ELEMENT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MENUMERATION_LITERAL__URI = MMODEL_ELEMENT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MENUMERATION_LITERAL__MMODEL_ELEMENT_REFS = MMODEL_ELEMENT__MMODEL_ELEMENT_REFS;

	/**
	 * The number of structural features of the '<em>MEnumeration Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MENUMERATION_LITERAL_FEATURE_COUNT = MMODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MFileImpl <em>MFile</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MFileImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMFile()
	 * @generated
	 */
	int MFILE = 8;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFILE__MUNSUPPORTED_MODEL_ELEMENTS = MUNIT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFILE__NAME = MUNIT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFILE__FULL_PATH_NAME = MUNIT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFILE__MPROJECT = MUNIT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFILE__MSTEREOTYPES = MUNIT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFILE__MALL_TAGS = MUNIT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFILE__MLOCAL_TAGS = MUNIT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFILE__MNESTED_ELEMENTS = MUNIT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFILE__MDEPENDENCIES = MUNIT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFILE__URI = MUNIT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFILE__MMODEL_ELEMENT_REFS = MUNIT__MMODEL_ELEMENT_REFS;

	/**
	 * The number of structural features of the '<em>MFile</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFILE_FEATURE_COUNT = MUNIT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MFlowImpl <em>MFlow</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MFlowImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMFlow()
	 * @generated
	 */
	int MFLOW = 9;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW__MUNSUPPORTED_MODEL_ELEMENTS = MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW__NAME = MMODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW__FULL_PATH_NAME = MMODEL_ELEMENT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW__MPROJECT = MMODEL_ELEMENT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW__MSTEREOTYPES = MMODEL_ELEMENT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW__MALL_TAGS = MMODEL_ELEMENT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW__MLOCAL_TAGS = MMODEL_ELEMENT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW__MNESTED_ELEMENTS = MMODEL_ELEMENT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW__MDEPENDENCIES = MMODEL_ELEMENT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW__URI = MMODEL_ELEMENT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW__MMODEL_ELEMENT_REFS = MMODEL_ELEMENT__MMODEL_ELEMENT_REFS;

	/**
	 * The number of structural features of the '<em>MFlow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_FEATURE_COUNT = MMODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MFlowItemImpl <em>MFlow Item</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MFlowItemImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMFlowItem()
	 * @generated
	 */
	int MFLOW_ITEM = 10;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MUNSUPPORTED_MODEL_ELEMENTS = MCLASSIFIER__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__NAME = MCLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__FULL_PATH_NAME = MCLASSIFIER__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MPROJECT = MCLASSIFIER__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MSTEREOTYPES = MCLASSIFIER__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MALL_TAGS = MCLASSIFIER__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MLOCAL_TAGS = MCLASSIFIER__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MNESTED_ELEMENTS = MCLASSIFIER__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MDEPENDENCIES = MCLASSIFIER__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__URI = MCLASSIFIER__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MMODEL_ELEMENT_REFS = MCLASSIFIER__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>MPorts</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MPORTS = MCLASSIFIER__MPORTS;

	/**
	 * The feature id for the '<em><b>MRelations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MRELATIONS = MCLASSIFIER__MRELATIONS;

	/**
	 * The feature id for the '<em><b>MOperations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MOPERATIONS = MCLASSIFIER__MOPERATIONS;

	/**
	 * The feature id for the '<em><b>MGeneralizations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MGENERALIZATIONS = MCLASSIFIER__MGENERALIZATIONS;

	/**
	 * The feature id for the '<em><b>MAttributes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MATTRIBUTES = MCLASSIFIER__MATTRIBUTES;

	/**
	 * The feature id for the '<em><b>MInterface Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MINTERFACE_ITEMS = MCLASSIFIER__MINTERFACE_ITEMS;

	/**
	 * The feature id for the '<em><b>MFlows</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MFLOWS = MCLASSIFIER__MFLOWS;

	/**
	 * The feature id for the '<em><b>MFlow Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MFLOW_ITEMS = MCLASSIFIER__MFLOW_ITEMS;

	/**
	 * The feature id for the '<em><b>MLinks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM__MLINKS = MCLASSIFIER__MLINKS;

	/**
	 * The number of structural features of the '<em>MFlow Item</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MFLOW_ITEM_FEATURE_COUNT = MCLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MGeneralizationImpl <em>MGeneralization</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MGeneralizationImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMGeneralization()
	 * @generated
	 */
	int MGENERALIZATION = 11;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MGENERALIZATION__MUNSUPPORTED_MODEL_ELEMENTS = MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MGENERALIZATION__NAME = MMODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MGENERALIZATION__FULL_PATH_NAME = MMODEL_ELEMENT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MGENERALIZATION__MPROJECT = MMODEL_ELEMENT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MGENERALIZATION__MSTEREOTYPES = MMODEL_ELEMENT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MGENERALIZATION__MALL_TAGS = MMODEL_ELEMENT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MGENERALIZATION__MLOCAL_TAGS = MMODEL_ELEMENT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MGENERALIZATION__MNESTED_ELEMENTS = MMODEL_ELEMENT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MGENERALIZATION__MDEPENDENCIES = MMODEL_ELEMENT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MGENERALIZATION__URI = MMODEL_ELEMENT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MGENERALIZATION__MMODEL_ELEMENT_REFS = MMODEL_ELEMENT__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>Base Class</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MGENERALIZATION__BASE_CLASS = MMODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Derived Class</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MGENERALIZATION__DERIVED_CLASS = MMODEL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>MGeneralization</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MGENERALIZATION_FEATURE_COUNT = MMODEL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MRelationImpl <em>MRelation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MRelationImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMRelation()
	 * @generated
	 */
	int MRELATION = 25;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION__MUNSUPPORTED_MODEL_ELEMENTS = MUNIT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION__NAME = MUNIT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION__FULL_PATH_NAME = MUNIT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION__MPROJECT = MUNIT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION__MSTEREOTYPES = MUNIT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION__MALL_TAGS = MUNIT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION__MLOCAL_TAGS = MUNIT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION__MNESTED_ELEMENTS = MUNIT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION__MDEPENDENCIES = MUNIT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION__URI = MUNIT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION__MMODEL_ELEMENT_REFS = MUNIT__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>Other Class</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION__OTHER_CLASS = MUNIT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Of Class</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION__OF_CLASS = MUNIT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION__MULTIPLICITY = MUNIT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>MRelation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MRELATION_FEATURE_COUNT = MUNIT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MInstanceImpl <em>MInstance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MInstanceImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMInstance()
	 * @generated
	 */
	int MINSTANCE = 12;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__MUNSUPPORTED_MODEL_ELEMENTS = MRELATION__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__NAME = MRELATION__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__FULL_PATH_NAME = MRELATION__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__MPROJECT = MRELATION__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__MSTEREOTYPES = MRELATION__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__MALL_TAGS = MRELATION__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__MLOCAL_TAGS = MRELATION__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__MNESTED_ELEMENTS = MRELATION__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__MDEPENDENCIES = MRELATION__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__URI = MRELATION__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__MMODEL_ELEMENT_REFS = MRELATION__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>Other Class</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__OTHER_CLASS = MRELATION__OTHER_CLASS;

	/**
	 * The feature id for the '<em><b>Of Class</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__OF_CLASS = MRELATION__OF_CLASS;

	/**
	 * The feature id for the '<em><b>Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__MULTIPLICITY = MRELATION__MULTIPLICITY;

	/**
	 * The feature id for the '<em><b>MAttribute Values</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE__MATTRIBUTE_VALUES = MRELATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MInstance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINSTANCE_FEATURE_COUNT = MRELATION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MInterfaceItemImpl <em>MInterface Item</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MInterfaceItemImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMInterfaceItem()
	 * @generated
	 */
	int MINTERFACE_ITEM = 13;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MUNSUPPORTED_MODEL_ELEMENTS = MCLASSIFIER__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__NAME = MCLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__FULL_PATH_NAME = MCLASSIFIER__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MPROJECT = MCLASSIFIER__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MSTEREOTYPES = MCLASSIFIER__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MALL_TAGS = MCLASSIFIER__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MLOCAL_TAGS = MCLASSIFIER__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MNESTED_ELEMENTS = MCLASSIFIER__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MDEPENDENCIES = MCLASSIFIER__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__URI = MCLASSIFIER__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MMODEL_ELEMENT_REFS = MCLASSIFIER__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>MPorts</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MPORTS = MCLASSIFIER__MPORTS;

	/**
	 * The feature id for the '<em><b>MRelations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MRELATIONS = MCLASSIFIER__MRELATIONS;

	/**
	 * The feature id for the '<em><b>MOperations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MOPERATIONS = MCLASSIFIER__MOPERATIONS;

	/**
	 * The feature id for the '<em><b>MGeneralizations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MGENERALIZATIONS = MCLASSIFIER__MGENERALIZATIONS;

	/**
	 * The feature id for the '<em><b>MAttributes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MATTRIBUTES = MCLASSIFIER__MATTRIBUTES;

	/**
	 * The feature id for the '<em><b>MInterface Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MINTERFACE_ITEMS = MCLASSIFIER__MINTERFACE_ITEMS;

	/**
	 * The feature id for the '<em><b>MFlows</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MFLOWS = MCLASSIFIER__MFLOWS;

	/**
	 * The feature id for the '<em><b>MFlow Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MFLOW_ITEMS = MCLASSIFIER__MFLOW_ITEMS;

	/**
	 * The feature id for the '<em><b>MLinks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM__MLINKS = MCLASSIFIER__MLINKS;

	/**
	 * The number of structural features of the '<em>MInterface Item</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERFACE_ITEM_FEATURE_COUNT = MCLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MLinkImpl <em>MLink</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MLinkImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMLink()
	 * @generated
	 */
	int MLINK = 14;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__MUNSUPPORTED_MODEL_ELEMENTS = MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__NAME = MMODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__FULL_PATH_NAME = MMODEL_ELEMENT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__MPROJECT = MMODEL_ELEMENT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__MSTEREOTYPES = MMODEL_ELEMENT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__MALL_TAGS = MMODEL_ELEMENT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__MLOCAL_TAGS = MMODEL_ELEMENT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__MNESTED_ELEMENTS = MMODEL_ELEMENT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__MDEPENDENCIES = MMODEL_ELEMENT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__URI = MMODEL_ELEMENT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__MMODEL_ELEMENT_REFS = MMODEL_ELEMENT__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>From</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__FROM = MMODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>To</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__TO = MMODEL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>From Sys ML Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__FROM_SYS_ML_PORT = MMODEL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>To Sys ML Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__TO_SYS_ML_PORT = MMODEL_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>From Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__FROM_PORT = MMODEL_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>To Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK__TO_PORT = MMODEL_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>MLink</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLINK_FEATURE_COUNT = MMODEL_ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MValueSpecificationImpl <em>MValue Specification</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MValueSpecificationImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMValueSpecification()
	 * @generated
	 */
	int MVALUE_SPECIFICATION = 34;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVALUE_SPECIFICATION__MUNSUPPORTED_MODEL_ELEMENTS = MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVALUE_SPECIFICATION__NAME = MMODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVALUE_SPECIFICATION__FULL_PATH_NAME = MMODEL_ELEMENT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVALUE_SPECIFICATION__MPROJECT = MMODEL_ELEMENT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVALUE_SPECIFICATION__MSTEREOTYPES = MMODEL_ELEMENT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVALUE_SPECIFICATION__MALL_TAGS = MMODEL_ELEMENT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVALUE_SPECIFICATION__MLOCAL_TAGS = MMODEL_ELEMENT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVALUE_SPECIFICATION__MNESTED_ELEMENTS = MMODEL_ELEMENT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVALUE_SPECIFICATION__MDEPENDENCIES = MMODEL_ELEMENT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVALUE_SPECIFICATION__URI = MMODEL_ELEMENT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVALUE_SPECIFICATION__MMODEL_ELEMENT_REFS = MMODEL_ELEMENT__MMODEL_ELEMENT_REFS;

	/**
	 * The number of structural features of the '<em>MValue Specification</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVALUE_SPECIFICATION_FEATURE_COUNT = MMODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MLiteralSpecificationImpl <em>MLiteral Specification</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MLiteralSpecificationImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMLiteralSpecification()
	 * @generated
	 */
	int MLITERAL_SPECIFICATION = 15;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLITERAL_SPECIFICATION__MUNSUPPORTED_MODEL_ELEMENTS = MVALUE_SPECIFICATION__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLITERAL_SPECIFICATION__NAME = MVALUE_SPECIFICATION__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLITERAL_SPECIFICATION__FULL_PATH_NAME = MVALUE_SPECIFICATION__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLITERAL_SPECIFICATION__MPROJECT = MVALUE_SPECIFICATION__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLITERAL_SPECIFICATION__MSTEREOTYPES = MVALUE_SPECIFICATION__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLITERAL_SPECIFICATION__MALL_TAGS = MVALUE_SPECIFICATION__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLITERAL_SPECIFICATION__MLOCAL_TAGS = MVALUE_SPECIFICATION__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLITERAL_SPECIFICATION__MNESTED_ELEMENTS = MVALUE_SPECIFICATION__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLITERAL_SPECIFICATION__MDEPENDENCIES = MVALUE_SPECIFICATION__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLITERAL_SPECIFICATION__URI = MVALUE_SPECIFICATION__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLITERAL_SPECIFICATION__MMODEL_ELEMENT_REFS = MVALUE_SPECIFICATION__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLITERAL_SPECIFICATION__VALUE = MVALUE_SPECIFICATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MLiteral Specification</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MLITERAL_SPECIFICATION_FEATURE_COUNT = MVALUE_SPECIFICATION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MModelElementRefImpl <em>MModel Element Ref</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MModelElementRefImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMModelElementRef()
	 * @generated
	 */
	int MMODEL_ELEMENT_REF = 17;

	/**
	 * The feature id for the '<em><b>Reference</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT_REF__REFERENCE = 0;

	/**
	 * The feature id for the '<em><b>Structural Feature Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT_REF__STRUCTURAL_FEATURE_NAME = 1;

	/**
	 * The number of structural features of the '<em>MModel Element Ref</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODEL_ELEMENT_REF_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MModuleImpl <em>MModule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MModuleImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMModule()
	 * @generated
	 */
	int MMODULE = 18;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__MUNSUPPORTED_MODEL_ELEMENTS = MINSTANCE__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__NAME = MINSTANCE__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__FULL_PATH_NAME = MINSTANCE__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__MPROJECT = MINSTANCE__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__MSTEREOTYPES = MINSTANCE__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__MALL_TAGS = MINSTANCE__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__MLOCAL_TAGS = MINSTANCE__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__MNESTED_ELEMENTS = MINSTANCE__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__MDEPENDENCIES = MINSTANCE__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__URI = MINSTANCE__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__MMODEL_ELEMENT_REFS = MINSTANCE__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>Other Class</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__OTHER_CLASS = MINSTANCE__OTHER_CLASS;

	/**
	 * The feature id for the '<em><b>Of Class</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__OF_CLASS = MINSTANCE__OF_CLASS;

	/**
	 * The feature id for the '<em><b>Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__MULTIPLICITY = MINSTANCE__MULTIPLICITY;

	/**
	 * The feature id for the '<em><b>MAttribute Values</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE__MATTRIBUTE_VALUES = MINSTANCE__MATTRIBUTE_VALUES;

	/**
	 * The number of structural features of the '<em>MModule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMODULE_FEATURE_COUNT = MINSTANCE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MObjectModelDiagramImpl <em>MObject Model Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MObjectModelDiagramImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMObjectModelDiagram()
	 * @generated
	 */
	int MOBJECT_MODEL_DIAGRAM = 19;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOBJECT_MODEL_DIAGRAM__MUNSUPPORTED_MODEL_ELEMENTS = MDIAGRAM__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOBJECT_MODEL_DIAGRAM__NAME = MDIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOBJECT_MODEL_DIAGRAM__FULL_PATH_NAME = MDIAGRAM__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOBJECT_MODEL_DIAGRAM__MPROJECT = MDIAGRAM__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOBJECT_MODEL_DIAGRAM__MSTEREOTYPES = MDIAGRAM__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOBJECT_MODEL_DIAGRAM__MALL_TAGS = MDIAGRAM__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOBJECT_MODEL_DIAGRAM__MLOCAL_TAGS = MDIAGRAM__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOBJECT_MODEL_DIAGRAM__MNESTED_ELEMENTS = MDIAGRAM__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOBJECT_MODEL_DIAGRAM__MDEPENDENCIES = MDIAGRAM__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOBJECT_MODEL_DIAGRAM__URI = MDIAGRAM__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOBJECT_MODEL_DIAGRAM__MMODEL_ELEMENT_REFS = MDIAGRAM__MMODEL_ELEMENT_REFS;

	/**
	 * The number of structural features of the '<em>MObject Model Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOBJECT_MODEL_DIAGRAM_FEATURE_COUNT = MDIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MOperationImpl <em>MOperation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MOperationImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMOperation()
	 * @generated
	 */
	int MOPERATION = 20;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MUNSUPPORTED_MODEL_ELEMENTS = MINTERFACE_ITEM__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__NAME = MINTERFACE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__FULL_PATH_NAME = MINTERFACE_ITEM__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MPROJECT = MINTERFACE_ITEM__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MSTEREOTYPES = MINTERFACE_ITEM__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MALL_TAGS = MINTERFACE_ITEM__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MLOCAL_TAGS = MINTERFACE_ITEM__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MNESTED_ELEMENTS = MINTERFACE_ITEM__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MDEPENDENCIES = MINTERFACE_ITEM__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__URI = MINTERFACE_ITEM__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MMODEL_ELEMENT_REFS = MINTERFACE_ITEM__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>MPorts</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MPORTS = MINTERFACE_ITEM__MPORTS;

	/**
	 * The feature id for the '<em><b>MRelations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MRELATIONS = MINTERFACE_ITEM__MRELATIONS;

	/**
	 * The feature id for the '<em><b>MOperations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MOPERATIONS = MINTERFACE_ITEM__MOPERATIONS;

	/**
	 * The feature id for the '<em><b>MGeneralizations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MGENERALIZATIONS = MINTERFACE_ITEM__MGENERALIZATIONS;

	/**
	 * The feature id for the '<em><b>MAttributes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MATTRIBUTES = MINTERFACE_ITEM__MATTRIBUTES;

	/**
	 * The feature id for the '<em><b>MInterface Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MINTERFACE_ITEMS = MINTERFACE_ITEM__MINTERFACE_ITEMS;

	/**
	 * The feature id for the '<em><b>MFlows</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MFLOWS = MINTERFACE_ITEM__MFLOWS;

	/**
	 * The feature id for the '<em><b>MFlow Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MFLOW_ITEMS = MINTERFACE_ITEM__MFLOW_ITEMS;

	/**
	 * The feature id for the '<em><b>MLinks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__MLINKS = MINTERFACE_ITEM__MLINKS;

	/**
	 * The feature id for the '<em><b>Return Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION__RETURN_TYPE = MINTERFACE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MOperation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOPERATION_FEATURE_COUNT = MINTERFACE_ITEM_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MPackageImpl <em>MPackage</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MPackageImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMPackage()
	 * @generated
	 */
	int MPACKAGE = 21;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__MUNSUPPORTED_MODEL_ELEMENTS = MUNIT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__NAME = MUNIT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__FULL_PATH_NAME = MUNIT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__MPROJECT = MUNIT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__MSTEREOTYPES = MUNIT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__MALL_TAGS = MUNIT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__MLOCAL_TAGS = MUNIT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__MNESTED_ELEMENTS = MUNIT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__MDEPENDENCIES = MUNIT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__URI = MUNIT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__MMODEL_ELEMENT_REFS = MUNIT__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>MClasses</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__MCLASSES = MUNIT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>MLinks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__MLINKS = MUNIT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>MTypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__MTYPES = MUNIT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>MPackages</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE__MPACKAGES = MUNIT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>MPackage</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPACKAGE_FEATURE_COUNT = MUNIT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MPortImpl <em>MPort</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MPortImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMPort()
	 * @generated
	 */
	int MPORT = 22;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__MUNSUPPORTED_MODEL_ELEMENTS = MINSTANCE__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__NAME = MINSTANCE__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__FULL_PATH_NAME = MINSTANCE__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__MPROJECT = MINSTANCE__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__MSTEREOTYPES = MINSTANCE__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__MALL_TAGS = MINSTANCE__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__MLOCAL_TAGS = MINSTANCE__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__MNESTED_ELEMENTS = MINSTANCE__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__MDEPENDENCIES = MINSTANCE__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__URI = MINSTANCE__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__MMODEL_ELEMENT_REFS = MINSTANCE__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>Other Class</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__OTHER_CLASS = MINSTANCE__OTHER_CLASS;

	/**
	 * The feature id for the '<em><b>Of Class</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__OF_CLASS = MINSTANCE__OF_CLASS;

	/**
	 * The feature id for the '<em><b>Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__MULTIPLICITY = MINSTANCE__MULTIPLICITY;

	/**
	 * The feature id for the '<em><b>MAttribute Values</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT__MATTRIBUTE_VALUES = MINSTANCE__MATTRIBUTE_VALUES;

	/**
	 * The number of structural features of the '<em>MPort</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPORT_FEATURE_COUNT = MINSTANCE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MProfileImpl <em>MProfile</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MProfileImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMProfile()
	 * @generated
	 */
	int MPROFILE = 23;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__MUNSUPPORTED_MODEL_ELEMENTS = MPACKAGE__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__NAME = MPACKAGE__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__FULL_PATH_NAME = MPACKAGE__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__MPROJECT = MPACKAGE__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__MSTEREOTYPES = MPACKAGE__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__MALL_TAGS = MPACKAGE__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__MLOCAL_TAGS = MPACKAGE__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__MNESTED_ELEMENTS = MPACKAGE__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__MDEPENDENCIES = MPACKAGE__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__URI = MPACKAGE__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__MMODEL_ELEMENT_REFS = MPACKAGE__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>MClasses</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__MCLASSES = MPACKAGE__MCLASSES;

	/**
	 * The feature id for the '<em><b>MLinks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__MLINKS = MPACKAGE__MLINKS;

	/**
	 * The feature id for the '<em><b>MTypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__MTYPES = MPACKAGE__MTYPES;

	/**
	 * The feature id for the '<em><b>MPackages</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE__MPACKAGES = MPACKAGE__MPACKAGES;

	/**
	 * The number of structural features of the '<em>MProfile</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROFILE_FEATURE_COUNT = MPACKAGE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MProjectImpl <em>MProject</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MProjectImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMProject()
	 * @generated
	 */
	int MPROJECT = 24;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MUNSUPPORTED_MODEL_ELEMENTS = MPACKAGE__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__NAME = MPACKAGE__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__FULL_PATH_NAME = MPACKAGE__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MPROJECT = MPACKAGE__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MSTEREOTYPES = MPACKAGE__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MALL_TAGS = MPACKAGE__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MLOCAL_TAGS = MPACKAGE__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MNESTED_ELEMENTS = MPACKAGE__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MDEPENDENCIES = MPACKAGE__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__URI = MPACKAGE__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MMODEL_ELEMENT_REFS = MPACKAGE__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>MClasses</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MCLASSES = MPACKAGE__MCLASSES;

	/**
	 * The feature id for the '<em><b>MLinks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MLINKS = MPACKAGE__MLINKS;

	/**
	 * The feature id for the '<em><b>MTypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MTYPES = MPACKAGE__MTYPES;

	/**
	 * The feature id for the '<em><b>MPackages</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MPACKAGES = MPACKAGE__MPACKAGES;

	/**
	 * The feature id for the '<em><b>MComponents</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MCOMPONENTS = MPACKAGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>MObject Model Diagrams</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MOBJECT_MODEL_DIAGRAMS = MPACKAGE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>MProfiles</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MPROFILES = MPACKAGE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>MStructure Diagrams</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MSTRUCTURE_DIAGRAMS = MPACKAGE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>MModel Elements</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT__MMODEL_ELEMENTS = MPACKAGE_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>MProject</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MPROJECT_FEATURE_COUNT = MPACKAGE_FEATURE_COUNT + 5;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MStereotypeImpl <em>MStereotype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MStereotypeImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMStereotype()
	 * @generated
	 */
	int MSTEREOTYPE = 26;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MUNSUPPORTED_MODEL_ELEMENTS = MCLASSIFIER__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__NAME = MCLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__FULL_PATH_NAME = MCLASSIFIER__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MPROJECT = MCLASSIFIER__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MSTEREOTYPES = MCLASSIFIER__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MALL_TAGS = MCLASSIFIER__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MLOCAL_TAGS = MCLASSIFIER__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MNESTED_ELEMENTS = MCLASSIFIER__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MDEPENDENCIES = MCLASSIFIER__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__URI = MCLASSIFIER__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MMODEL_ELEMENT_REFS = MCLASSIFIER__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>MPorts</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MPORTS = MCLASSIFIER__MPORTS;

	/**
	 * The feature id for the '<em><b>MRelations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MRELATIONS = MCLASSIFIER__MRELATIONS;

	/**
	 * The feature id for the '<em><b>MOperations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MOPERATIONS = MCLASSIFIER__MOPERATIONS;

	/**
	 * The feature id for the '<em><b>MGeneralizations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MGENERALIZATIONS = MCLASSIFIER__MGENERALIZATIONS;

	/**
	 * The feature id for the '<em><b>MAttributes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MATTRIBUTES = MCLASSIFIER__MATTRIBUTES;

	/**
	 * The feature id for the '<em><b>MInterface Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MINTERFACE_ITEMS = MCLASSIFIER__MINTERFACE_ITEMS;

	/**
	 * The feature id for the '<em><b>MFlows</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MFLOWS = MCLASSIFIER__MFLOWS;

	/**
	 * The feature id for the '<em><b>MFlow Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MFLOW_ITEMS = MCLASSIFIER__MFLOW_ITEMS;

	/**
	 * The feature id for the '<em><b>MLinks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__MLINKS = MCLASSIFIER__MLINKS;

	/**
	 * The feature id for the '<em><b>Is New Term</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__IS_NEW_TERM = MCLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Of Meta Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE__OF_META_CLASS = MCLASSIFIER_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>MStereotype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTEREOTYPE_FEATURE_COUNT = MCLASSIFIER_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MStructureDiagramImpl <em>MStructure Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MStructureDiagramImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMStructureDiagram()
	 * @generated
	 */
	int MSTRUCTURE_DIAGRAM = 27;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTRUCTURE_DIAGRAM__MUNSUPPORTED_MODEL_ELEMENTS = MDIAGRAM__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTRUCTURE_DIAGRAM__NAME = MDIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTRUCTURE_DIAGRAM__FULL_PATH_NAME = MDIAGRAM__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTRUCTURE_DIAGRAM__MPROJECT = MDIAGRAM__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTRUCTURE_DIAGRAM__MSTEREOTYPES = MDIAGRAM__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTRUCTURE_DIAGRAM__MALL_TAGS = MDIAGRAM__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTRUCTURE_DIAGRAM__MLOCAL_TAGS = MDIAGRAM__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTRUCTURE_DIAGRAM__MNESTED_ELEMENTS = MDIAGRAM__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTRUCTURE_DIAGRAM__MDEPENDENCIES = MDIAGRAM__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTRUCTURE_DIAGRAM__URI = MDIAGRAM__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTRUCTURE_DIAGRAM__MMODEL_ELEMENT_REFS = MDIAGRAM__MMODEL_ELEMENT_REFS;

	/**
	 * The number of structural features of the '<em>MStructure Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSTRUCTURE_DIAGRAM_FEATURE_COUNT = MDIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MSysMLPortImpl <em>MSys ML Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MSysMLPortImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMSysMLPort()
	 * @generated
	 */
	int MSYS_ML_PORT = 28;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__MUNSUPPORTED_MODEL_ELEMENTS = MINSTANCE__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__NAME = MINSTANCE__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__FULL_PATH_NAME = MINSTANCE__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__MPROJECT = MINSTANCE__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__MSTEREOTYPES = MINSTANCE__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__MALL_TAGS = MINSTANCE__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__MLOCAL_TAGS = MINSTANCE__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__MNESTED_ELEMENTS = MINSTANCE__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__MDEPENDENCIES = MINSTANCE__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__URI = MINSTANCE__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__MMODEL_ELEMENT_REFS = MINSTANCE__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>Other Class</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__OTHER_CLASS = MINSTANCE__OTHER_CLASS;

	/**
	 * The feature id for the '<em><b>Of Class</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__OF_CLASS = MINSTANCE__OF_CLASS;

	/**
	 * The feature id for the '<em><b>Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__MULTIPLICITY = MINSTANCE__MULTIPLICITY;

	/**
	 * The feature id for the '<em><b>MAttribute Values</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__MATTRIBUTE_VALUES = MINSTANCE__MATTRIBUTE_VALUES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__TYPE = MINSTANCE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Port Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT__PORT_DIRECTION = MINSTANCE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>MSys ML Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSYS_ML_PORT_FEATURE_COUNT = MINSTANCE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MTagImpl <em>MTag</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MTagImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMTag()
	 * @generated
	 */
	int MTAG = 29;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__MUNSUPPORTED_MODEL_ELEMENTS = MVARIABLE__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__NAME = MVARIABLE__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__FULL_PATH_NAME = MVARIABLE__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__MPROJECT = MVARIABLE__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__MSTEREOTYPES = MVARIABLE__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__MALL_TAGS = MVARIABLE__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__MLOCAL_TAGS = MVARIABLE__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__MNESTED_ELEMENTS = MVARIABLE__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__MDEPENDENCIES = MVARIABLE__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__URI = MVARIABLE__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__MMODEL_ELEMENT_REFS = MVARIABLE__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__TYPE = MVARIABLE__TYPE;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__DEFAULT_VALUE = MVARIABLE__DEFAULT_VALUE;

	/**
	 * The feature id for the '<em><b>MValue Specifications</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__MVALUE_SPECIFICATIONS = MVARIABLE__MVALUE_SPECIFICATIONS;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG__VALUE = MVARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MTag</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTAG_FEATURE_COUNT = MVARIABLE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MTemplateParameterImpl <em>MTemplate Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MTemplateParameterImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMTemplateParameter()
	 * @generated
	 */
	int MTEMPLATE_PARAMETER = 30;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER__MUNSUPPORTED_MODEL_ELEMENTS = MVARIABLE__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER__NAME = MVARIABLE__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER__FULL_PATH_NAME = MVARIABLE__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER__MPROJECT = MVARIABLE__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER__MSTEREOTYPES = MVARIABLE__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER__MALL_TAGS = MVARIABLE__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER__MLOCAL_TAGS = MVARIABLE__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER__MNESTED_ELEMENTS = MVARIABLE__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER__MDEPENDENCIES = MVARIABLE__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER__URI = MVARIABLE__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER__MMODEL_ELEMENT_REFS = MVARIABLE__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER__TYPE = MVARIABLE__TYPE;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER__DEFAULT_VALUE = MVARIABLE__DEFAULT_VALUE;

	/**
	 * The feature id for the '<em><b>MValue Specifications</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER__MVALUE_SPECIFICATIONS = MVARIABLE__MVALUE_SPECIFICATIONS;

	/**
	 * The number of structural features of the '<em>MTemplate Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTEMPLATE_PARAMETER_FEATURE_COUNT = MVARIABLE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MTypeImpl <em>MType</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MTypeImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMType()
	 * @generated
	 */
	int MTYPE = 31;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MUNSUPPORTED_MODEL_ELEMENTS = MCLASSIFIER__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__NAME = MCLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__FULL_PATH_NAME = MCLASSIFIER__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MPROJECT = MCLASSIFIER__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MSTEREOTYPES = MCLASSIFIER__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MALL_TAGS = MCLASSIFIER__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MLOCAL_TAGS = MCLASSIFIER__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MNESTED_ELEMENTS = MCLASSIFIER__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MDEPENDENCIES = MCLASSIFIER__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__URI = MCLASSIFIER__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MMODEL_ELEMENT_REFS = MCLASSIFIER__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>MPorts</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MPORTS = MCLASSIFIER__MPORTS;

	/**
	 * The feature id for the '<em><b>MRelations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MRELATIONS = MCLASSIFIER__MRELATIONS;

	/**
	 * The feature id for the '<em><b>MOperations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MOPERATIONS = MCLASSIFIER__MOPERATIONS;

	/**
	 * The feature id for the '<em><b>MGeneralizations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MGENERALIZATIONS = MCLASSIFIER__MGENERALIZATIONS;

	/**
	 * The feature id for the '<em><b>MAttributes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MATTRIBUTES = MCLASSIFIER__MATTRIBUTES;

	/**
	 * The feature id for the '<em><b>MInterface Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MINTERFACE_ITEMS = MCLASSIFIER__MINTERFACE_ITEMS;

	/**
	 * The feature id for the '<em><b>MFlows</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MFLOWS = MCLASSIFIER__MFLOWS;

	/**
	 * The feature id for the '<em><b>MFlow Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MFLOW_ITEMS = MCLASSIFIER__MFLOW_ITEMS;

	/**
	 * The feature id for the '<em><b>MLinks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE__MLINKS = MCLASSIFIER__MLINKS;

	/**
	 * The number of structural features of the '<em>MType</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MTYPE_FEATURE_COUNT = MCLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.eu.ales.rpyplugins.impl.MUnsupportedModelElementImpl <em>MUnsupported Model Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.eu.ales.rpyplugins.impl.MUnsupportedModelElementImpl
	 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMUnsupportedModelElement()
	 * @generated
	 */
	int MUNSUPPORTED_MODEL_ELEMENT = 33;

	/**
	 * The feature id for the '<em><b>MUnsupported Model Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNSUPPORTED_MODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS = MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNSUPPORTED_MODEL_ELEMENT__NAME = MMODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Full Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNSUPPORTED_MODEL_ELEMENT__FULL_PATH_NAME = MMODEL_ELEMENT__FULL_PATH_NAME;

	/**
	 * The feature id for the '<em><b>MProject</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNSUPPORTED_MODEL_ELEMENT__MPROJECT = MMODEL_ELEMENT__MPROJECT;

	/**
	 * The feature id for the '<em><b>MStereotypes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNSUPPORTED_MODEL_ELEMENT__MSTEREOTYPES = MMODEL_ELEMENT__MSTEREOTYPES;

	/**
	 * The feature id for the '<em><b>MAll Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNSUPPORTED_MODEL_ELEMENT__MALL_TAGS = MMODEL_ELEMENT__MALL_TAGS;

	/**
	 * The feature id for the '<em><b>MLocal Tags</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNSUPPORTED_MODEL_ELEMENT__MLOCAL_TAGS = MMODEL_ELEMENT__MLOCAL_TAGS;

	/**
	 * The feature id for the '<em><b>MNested Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNSUPPORTED_MODEL_ELEMENT__MNESTED_ELEMENTS = MMODEL_ELEMENT__MNESTED_ELEMENTS;

	/**
	 * The feature id for the '<em><b>MDependencies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNSUPPORTED_MODEL_ELEMENT__MDEPENDENCIES = MMODEL_ELEMENT__MDEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNSUPPORTED_MODEL_ELEMENT__URI = MMODEL_ELEMENT__URI;

	/**
	 * The feature id for the '<em><b>MModel Element Refs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNSUPPORTED_MODEL_ELEMENT__MMODEL_ELEMENT_REFS = MMODEL_ELEMENT__MMODEL_ELEMENT_REFS;

	/**
	 * The feature id for the '<em><b>Class Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNSUPPORTED_MODEL_ELEMENT__CLASS_NAME = MMODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Structural Feature Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNSUPPORTED_MODEL_ELEMENT__STRUCTURAL_FEATURE_NAME = MMODEL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>MUnsupported Model Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUNSUPPORTED_MODEL_ELEMENT_FEATURE_COUNT = MMODEL_ELEMENT_FEATURE_COUNT + 2;


	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MAttribute <em>MAttribute</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MAttribute</em>'.
	 * @see com.eu.ales.rpyplugins.MAttribute
	 * @generated
	 */
	EClass getMAttribute();

	/**
	 * Returns the meta object for the attribute '{@link com.eu.ales.rpyplugins.MAttribute#getMultiplicity <em>Multiplicity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Multiplicity</em>'.
	 * @see com.eu.ales.rpyplugins.MAttribute#getMultiplicity()
	 * @see #getMAttribute()
	 * @generated
	 */
	EAttribute getMAttribute_Multiplicity();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MClass <em>MClass</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MClass</em>'.
	 * @see com.eu.ales.rpyplugins.MClass
	 * @generated
	 */
	EClass getMClass();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MClassifier <em>MClassifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MClassifier</em>'.
	 * @see com.eu.ales.rpyplugins.MClassifier
	 * @generated
	 */
	EClass getMClassifier();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MClassifier#getMPorts <em>MPorts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MPorts</em>'.
	 * @see com.eu.ales.rpyplugins.MClassifier#getMPorts()
	 * @see #getMClassifier()
	 * @generated
	 */
	EReference getMClassifier_MPorts();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MClassifier#getMRelations <em>MRelations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MRelations</em>'.
	 * @see com.eu.ales.rpyplugins.MClassifier#getMRelations()
	 * @see #getMClassifier()
	 * @generated
	 */
	EReference getMClassifier_MRelations();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MClassifier#getMOperations <em>MOperations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MOperations</em>'.
	 * @see com.eu.ales.rpyplugins.MClassifier#getMOperations()
	 * @see #getMClassifier()
	 * @generated
	 */
	EReference getMClassifier_MOperations();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MClassifier#getMGeneralizations <em>MGeneralizations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MGeneralizations</em>'.
	 * @see com.eu.ales.rpyplugins.MClassifier#getMGeneralizations()
	 * @see #getMClassifier()
	 * @generated
	 */
	EReference getMClassifier_MGeneralizations();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MClassifier#getMAttributes <em>MAttributes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MAttributes</em>'.
	 * @see com.eu.ales.rpyplugins.MClassifier#getMAttributes()
	 * @see #getMClassifier()
	 * @generated
	 */
	EReference getMClassifier_MAttributes();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MClassifier#getMInterfaceItems <em>MInterface Items</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MInterface Items</em>'.
	 * @see com.eu.ales.rpyplugins.MClassifier#getMInterfaceItems()
	 * @see #getMClassifier()
	 * @generated
	 */
	EReference getMClassifier_MInterfaceItems();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MClassifier#getMFlows <em>MFlows</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MFlows</em>'.
	 * @see com.eu.ales.rpyplugins.MClassifier#getMFlows()
	 * @see #getMClassifier()
	 * @generated
	 */
	EReference getMClassifier_MFlows();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MClassifier#getMFlowItems <em>MFlow Items</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MFlow Items</em>'.
	 * @see com.eu.ales.rpyplugins.MClassifier#getMFlowItems()
	 * @see #getMClassifier()
	 * @generated
	 */
	EReference getMClassifier_MFlowItems();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MClassifier#getMLinks <em>MLinks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MLinks</em>'.
	 * @see com.eu.ales.rpyplugins.MClassifier#getMLinks()
	 * @see #getMClassifier()
	 * @generated
	 */
	EReference getMClassifier_MLinks();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MComponent <em>MComponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MComponent</em>'.
	 * @see com.eu.ales.rpyplugins.MComponent
	 * @generated
	 */
	EClass getMComponent();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MConfiguration <em>MConfiguration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MConfiguration</em>'.
	 * @see com.eu.ales.rpyplugins.MConfiguration
	 * @generated
	 */
	EClass getMConfiguration();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MDependency <em>MDependency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MDependency</em>'.
	 * @see com.eu.ales.rpyplugins.MDependency
	 * @generated
	 */
	EClass getMDependency();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MDiagram <em>MDiagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MDiagram</em>'.
	 * @see com.eu.ales.rpyplugins.MDiagram
	 * @generated
	 */
	EClass getMDiagram();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MEnumerationLiteral <em>MEnumeration Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MEnumeration Literal</em>'.
	 * @see com.eu.ales.rpyplugins.MEnumerationLiteral
	 * @generated
	 */
	EClass getMEnumerationLiteral();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MFile <em>MFile</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MFile</em>'.
	 * @see com.eu.ales.rpyplugins.MFile
	 * @generated
	 */
	EClass getMFile();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MFlow <em>MFlow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MFlow</em>'.
	 * @see com.eu.ales.rpyplugins.MFlow
	 * @generated
	 */
	EClass getMFlow();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MFlowItem <em>MFlow Item</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MFlow Item</em>'.
	 * @see com.eu.ales.rpyplugins.MFlowItem
	 * @generated
	 */
	EClass getMFlowItem();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MGeneralization <em>MGeneralization</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MGeneralization</em>'.
	 * @see com.eu.ales.rpyplugins.MGeneralization
	 * @generated
	 */
	EClass getMGeneralization();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MGeneralization#getBaseClass <em>Base Class</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Base Class</em>'.
	 * @see com.eu.ales.rpyplugins.MGeneralization#getBaseClass()
	 * @see #getMGeneralization()
	 * @generated
	 */
	EReference getMGeneralization_BaseClass();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MGeneralization#getDerivedClass <em>Derived Class</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Derived Class</em>'.
	 * @see com.eu.ales.rpyplugins.MGeneralization#getDerivedClass()
	 * @see #getMGeneralization()
	 * @generated
	 */
	EReference getMGeneralization_DerivedClass();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MInstance <em>MInstance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MInstance</em>'.
	 * @see com.eu.ales.rpyplugins.MInstance
	 * @generated
	 */
	EClass getMInstance();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MInstance#getMAttributeValues <em>MAttribute Values</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MAttribute Values</em>'.
	 * @see com.eu.ales.rpyplugins.MInstance#getMAttributeValues()
	 * @see #getMInstance()
	 * @generated
	 */
	EReference getMInstance_MAttributeValues();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MInterfaceItem <em>MInterface Item</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MInterface Item</em>'.
	 * @see com.eu.ales.rpyplugins.MInterfaceItem
	 * @generated
	 */
	EClass getMInterfaceItem();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MLink <em>MLink</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MLink</em>'.
	 * @see com.eu.ales.rpyplugins.MLink
	 * @generated
	 */
	EClass getMLink();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MLink#getFrom <em>From</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>From</em>'.
	 * @see com.eu.ales.rpyplugins.MLink#getFrom()
	 * @see #getMLink()
	 * @generated
	 */
	EReference getMLink_From();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MLink#getTo <em>To</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>To</em>'.
	 * @see com.eu.ales.rpyplugins.MLink#getTo()
	 * @see #getMLink()
	 * @generated
	 */
	EReference getMLink_To();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MLink#getFromSysMLPort <em>From Sys ML Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>From Sys ML Port</em>'.
	 * @see com.eu.ales.rpyplugins.MLink#getFromSysMLPort()
	 * @see #getMLink()
	 * @generated
	 */
	EReference getMLink_FromSysMLPort();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MLink#getToSysMLPort <em>To Sys ML Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>To Sys ML Port</em>'.
	 * @see com.eu.ales.rpyplugins.MLink#getToSysMLPort()
	 * @see #getMLink()
	 * @generated
	 */
	EReference getMLink_ToSysMLPort();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MLink#getFromPort <em>From Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>From Port</em>'.
	 * @see com.eu.ales.rpyplugins.MLink#getFromPort()
	 * @see #getMLink()
	 * @generated
	 */
	EReference getMLink_FromPort();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MLink#getToPort <em>To Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>To Port</em>'.
	 * @see com.eu.ales.rpyplugins.MLink#getToPort()
	 * @see #getMLink()
	 * @generated
	 */
	EReference getMLink_ToPort();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MLiteralSpecification <em>MLiteral Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MLiteral Specification</em>'.
	 * @see com.eu.ales.rpyplugins.MLiteralSpecification
	 * @generated
	 */
	EClass getMLiteralSpecification();

	/**
	 * Returns the meta object for the attribute '{@link com.eu.ales.rpyplugins.MLiteralSpecification#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see com.eu.ales.rpyplugins.MLiteralSpecification#getValue()
	 * @see #getMLiteralSpecification()
	 * @generated
	 */
	EAttribute getMLiteralSpecification_Value();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MModelElement <em>MModel Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MModel Element</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElement
	 * @generated
	 */
	EClass getMModelElement();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MModelElement#getMUnsupportedModelElements <em>MUnsupported Model Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MUnsupported Model Elements</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElement#getMUnsupportedModelElements()
	 * @see #getMModelElement()
	 * @generated
	 */
	EReference getMModelElement_MUnsupportedModelElements();

	/**
	 * Returns the meta object for the attribute '{@link com.eu.ales.rpyplugins.MModelElement#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElement#getName()
	 * @see #getMModelElement()
	 * @generated
	 */
	EAttribute getMModelElement_Name();

	/**
	 * Returns the meta object for the attribute '{@link com.eu.ales.rpyplugins.MModelElement#getFullPathName <em>Full Path Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Full Path Name</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElement#getFullPathName()
	 * @see #getMModelElement()
	 * @generated
	 */
	EAttribute getMModelElement_FullPathName();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MModelElement#getMProject <em>MProject</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>MProject</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElement#getMProject()
	 * @see #getMModelElement()
	 * @generated
	 */
	EReference getMModelElement_MProject();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MModelElement#getMStereotypes <em>MStereotypes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MStereotypes</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElement#getMStereotypes()
	 * @see #getMModelElement()
	 * @generated
	 */
	EReference getMModelElement_MStereotypes();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MModelElement#getMAllTags <em>MAll Tags</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MAll Tags</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElement#getMAllTags()
	 * @see #getMModelElement()
	 * @generated
	 */
	EReference getMModelElement_MAllTags();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MModelElement#getMLocalTags <em>MLocal Tags</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MLocal Tags</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElement#getMLocalTags()
	 * @see #getMModelElement()
	 * @generated
	 */
	EReference getMModelElement_MLocalTags();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MModelElement#getMNestedElements <em>MNested Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MNested Elements</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElement#getMNestedElements()
	 * @see #getMModelElement()
	 * @generated
	 */
	EReference getMModelElement_MNestedElements();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MModelElement#getMDependencies <em>MDependencies</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MDependencies</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElement#getMDependencies()
	 * @see #getMModelElement()
	 * @generated
	 */
	EReference getMModelElement_MDependencies();

	/**
	 * Returns the meta object for the attribute '{@link com.eu.ales.rpyplugins.MModelElement#getUri <em>Uri</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Uri</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElement#getUri()
	 * @see #getMModelElement()
	 * @generated
	 */
	EAttribute getMModelElement_Uri();

	/**
	 * Returns the meta object for the containment reference list '{@link com.eu.ales.rpyplugins.MModelElement#getMModelElementRefs <em>MModel Element Refs</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>MModel Element Refs</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElement#getMModelElementRefs()
	 * @see #getMModelElement()
	 * @generated
	 */
	EReference getMModelElement_MModelElementRefs();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MModelElementRef <em>MModel Element Ref</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MModel Element Ref</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElementRef
	 * @generated
	 */
	EClass getMModelElementRef();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MModelElementRef#getReference <em>Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Reference</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElementRef#getReference()
	 * @see #getMModelElementRef()
	 * @generated
	 */
	EReference getMModelElementRef_Reference();

	/**
	 * Returns the meta object for the attribute '{@link com.eu.ales.rpyplugins.MModelElementRef#getStructuralFeatureName <em>Structural Feature Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Structural Feature Name</em>'.
	 * @see com.eu.ales.rpyplugins.MModelElementRef#getStructuralFeatureName()
	 * @see #getMModelElementRef()
	 * @generated
	 */
	EAttribute getMModelElementRef_StructuralFeatureName();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MModule <em>MModule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MModule</em>'.
	 * @see com.eu.ales.rpyplugins.MModule
	 * @generated
	 */
	EClass getMModule();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MObjectModelDiagram <em>MObject Model Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MObject Model Diagram</em>'.
	 * @see com.eu.ales.rpyplugins.MObjectModelDiagram
	 * @generated
	 */
	EClass getMObjectModelDiagram();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MOperation <em>MOperation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MOperation</em>'.
	 * @see com.eu.ales.rpyplugins.MOperation
	 * @generated
	 */
	EClass getMOperation();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MOperation#getReturnType <em>Return Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Return Type</em>'.
	 * @see com.eu.ales.rpyplugins.MOperation#getReturnType()
	 * @see #getMOperation()
	 * @generated
	 */
	EReference getMOperation_ReturnType();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MPackage <em>MPackage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MPackage</em>'.
	 * @see com.eu.ales.rpyplugins.MPackage
	 * @generated
	 */
	EClass getMPackage();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MPackage#getMClasses <em>MClasses</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MClasses</em>'.
	 * @see com.eu.ales.rpyplugins.MPackage#getMClasses()
	 * @see #getMPackage()
	 * @generated
	 */
	EReference getMPackage_MClasses();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MPackage#getMLinks <em>MLinks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MLinks</em>'.
	 * @see com.eu.ales.rpyplugins.MPackage#getMLinks()
	 * @see #getMPackage()
	 * @generated
	 */
	EReference getMPackage_MLinks();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MPackage#getMTypes <em>MTypes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MTypes</em>'.
	 * @see com.eu.ales.rpyplugins.MPackage#getMTypes()
	 * @see #getMPackage()
	 * @generated
	 */
	EReference getMPackage_MTypes();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MPackage#getMPackages <em>MPackages</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MPackages</em>'.
	 * @see com.eu.ales.rpyplugins.MPackage#getMPackages()
	 * @see #getMPackage()
	 * @generated
	 */
	EReference getMPackage_MPackages();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MPort <em>MPort</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MPort</em>'.
	 * @see com.eu.ales.rpyplugins.MPort
	 * @generated
	 */
	EClass getMPort();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MProfile <em>MProfile</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MProfile</em>'.
	 * @see com.eu.ales.rpyplugins.MProfile
	 * @generated
	 */
	EClass getMProfile();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MProject <em>MProject</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MProject</em>'.
	 * @see com.eu.ales.rpyplugins.MProject
	 * @generated
	 */
	EClass getMProject();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MProject#getMComponents <em>MComponents</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MComponents</em>'.
	 * @see com.eu.ales.rpyplugins.MProject#getMComponents()
	 * @see #getMProject()
	 * @generated
	 */
	EReference getMProject_MComponents();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MProject#getMObjectModelDiagrams <em>MObject Model Diagrams</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MObject Model Diagrams</em>'.
	 * @see com.eu.ales.rpyplugins.MProject#getMObjectModelDiagrams()
	 * @see #getMProject()
	 * @generated
	 */
	EReference getMProject_MObjectModelDiagrams();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MProject#getMProfiles <em>MProfiles</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MProfiles</em>'.
	 * @see com.eu.ales.rpyplugins.MProject#getMProfiles()
	 * @see #getMProject()
	 * @generated
	 */
	EReference getMProject_MProfiles();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MProject#getMStructureDiagrams <em>MStructure Diagrams</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MStructure Diagrams</em>'.
	 * @see com.eu.ales.rpyplugins.MProject#getMStructureDiagrams()
	 * @see #getMProject()
	 * @generated
	 */
	EReference getMProject_MStructureDiagrams();

	/**
	 * Returns the meta object for the containment reference list '{@link com.eu.ales.rpyplugins.MProject#getMModelElements <em>MModel Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>MModel Elements</em>'.
	 * @see com.eu.ales.rpyplugins.MProject#getMModelElements()
	 * @see #getMProject()
	 * @generated
	 */
	EReference getMProject_MModelElements();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MRelation <em>MRelation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MRelation</em>'.
	 * @see com.eu.ales.rpyplugins.MRelation
	 * @generated
	 */
	EClass getMRelation();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MRelation#getOtherClass <em>Other Class</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Other Class</em>'.
	 * @see com.eu.ales.rpyplugins.MRelation#getOtherClass()
	 * @see #getMRelation()
	 * @generated
	 */
	EReference getMRelation_OtherClass();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MRelation#getOfClass <em>Of Class</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Of Class</em>'.
	 * @see com.eu.ales.rpyplugins.MRelation#getOfClass()
	 * @see #getMRelation()
	 * @generated
	 */
	EReference getMRelation_OfClass();

	/**
	 * Returns the meta object for the attribute '{@link com.eu.ales.rpyplugins.MRelation#getMultiplicity <em>Multiplicity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Multiplicity</em>'.
	 * @see com.eu.ales.rpyplugins.MRelation#getMultiplicity()
	 * @see #getMRelation()
	 * @generated
	 */
	EAttribute getMRelation_Multiplicity();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MStereotype <em>MStereotype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MStereotype</em>'.
	 * @see com.eu.ales.rpyplugins.MStereotype
	 * @generated
	 */
	EClass getMStereotype();

	/**
	 * Returns the meta object for the attribute '{@link com.eu.ales.rpyplugins.MStereotype#getIsNewTerm <em>Is New Term</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is New Term</em>'.
	 * @see com.eu.ales.rpyplugins.MStereotype#getIsNewTerm()
	 * @see #getMStereotype()
	 * @generated
	 */
	EAttribute getMStereotype_IsNewTerm();

	/**
	 * Returns the meta object for the attribute '{@link com.eu.ales.rpyplugins.MStereotype#getOfMetaClass <em>Of Meta Class</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Of Meta Class</em>'.
	 * @see com.eu.ales.rpyplugins.MStereotype#getOfMetaClass()
	 * @see #getMStereotype()
	 * @generated
	 */
	EAttribute getMStereotype_OfMetaClass();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MStructureDiagram <em>MStructure Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MStructure Diagram</em>'.
	 * @see com.eu.ales.rpyplugins.MStructureDiagram
	 * @generated
	 */
	EClass getMStructureDiagram();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MSysMLPort <em>MSys ML Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MSys ML Port</em>'.
	 * @see com.eu.ales.rpyplugins.MSysMLPort
	 * @generated
	 */
	EClass getMSysMLPort();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MSysMLPort#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Type</em>'.
	 * @see com.eu.ales.rpyplugins.MSysMLPort#getType()
	 * @see #getMSysMLPort()
	 * @generated
	 */
	EReference getMSysMLPort_Type();

	/**
	 * Returns the meta object for the attribute '{@link com.eu.ales.rpyplugins.MSysMLPort#getPortDirection <em>Port Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Port Direction</em>'.
	 * @see com.eu.ales.rpyplugins.MSysMLPort#getPortDirection()
	 * @see #getMSysMLPort()
	 * @generated
	 */
	EAttribute getMSysMLPort_PortDirection();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MTag <em>MTag</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MTag</em>'.
	 * @see com.eu.ales.rpyplugins.MTag
	 * @generated
	 */
	EClass getMTag();

	/**
	 * Returns the meta object for the attribute '{@link com.eu.ales.rpyplugins.MTag#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see com.eu.ales.rpyplugins.MTag#getValue()
	 * @see #getMTag()
	 * @generated
	 */
	EAttribute getMTag_Value();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MTemplateParameter <em>MTemplate Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MTemplate Parameter</em>'.
	 * @see com.eu.ales.rpyplugins.MTemplateParameter
	 * @generated
	 */
	EClass getMTemplateParameter();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MType <em>MType</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MType</em>'.
	 * @see com.eu.ales.rpyplugins.MType
	 * @generated
	 */
	EClass getMType();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MUnit <em>MUnit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MUnit</em>'.
	 * @see com.eu.ales.rpyplugins.MUnit
	 * @generated
	 */
	EClass getMUnit();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MUnsupportedModelElement <em>MUnsupported Model Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MUnsupported Model Element</em>'.
	 * @see com.eu.ales.rpyplugins.MUnsupportedModelElement
	 * @generated
	 */
	EClass getMUnsupportedModelElement();

	/**
	 * Returns the meta object for the attribute '{@link com.eu.ales.rpyplugins.MUnsupportedModelElement#getClassName <em>Class Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Class Name</em>'.
	 * @see com.eu.ales.rpyplugins.MUnsupportedModelElement#getClassName()
	 * @see #getMUnsupportedModelElement()
	 * @generated
	 */
	EAttribute getMUnsupportedModelElement_ClassName();

	/**
	 * Returns the meta object for the attribute '{@link com.eu.ales.rpyplugins.MUnsupportedModelElement#getStructuralFeatureName <em>Structural Feature Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Structural Feature Name</em>'.
	 * @see com.eu.ales.rpyplugins.MUnsupportedModelElement#getStructuralFeatureName()
	 * @see #getMUnsupportedModelElement()
	 * @generated
	 */
	EAttribute getMUnsupportedModelElement_StructuralFeatureName();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MValueSpecification <em>MValue Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MValue Specification</em>'.
	 * @see com.eu.ales.rpyplugins.MValueSpecification
	 * @generated
	 */
	EClass getMValueSpecification();

	/**
	 * Returns the meta object for class '{@link com.eu.ales.rpyplugins.MVariable <em>MVariable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MVariable</em>'.
	 * @see com.eu.ales.rpyplugins.MVariable
	 * @generated
	 */
	EClass getMVariable();

	/**
	 * Returns the meta object for the reference '{@link com.eu.ales.rpyplugins.MVariable#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Type</em>'.
	 * @see com.eu.ales.rpyplugins.MVariable#getType()
	 * @see #getMVariable()
	 * @generated
	 */
	EReference getMVariable_Type();

	/**
	 * Returns the meta object for the attribute '{@link com.eu.ales.rpyplugins.MVariable#getDefaultValue <em>Default Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Default Value</em>'.
	 * @see com.eu.ales.rpyplugins.MVariable#getDefaultValue()
	 * @see #getMVariable()
	 * @generated
	 */
	EAttribute getMVariable_DefaultValue();

	/**
	 * Returns the meta object for the reference list '{@link com.eu.ales.rpyplugins.MVariable#getMValueSpecifications <em>MValue Specifications</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>MValue Specifications</em>'.
	 * @see com.eu.ales.rpyplugins.MVariable#getMValueSpecifications()
	 * @see #getMVariable()
	 * @generated
	 */
	EReference getMVariable_MValueSpecifications();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	RpypluginsFactory getRpypluginsFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MAttributeImpl <em>MAttribute</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MAttributeImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMAttribute()
		 * @generated
		 */
		EClass MATTRIBUTE = eINSTANCE.getMAttribute();

		/**
		 * The meta object literal for the '<em><b>Multiplicity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MATTRIBUTE__MULTIPLICITY = eINSTANCE.getMAttribute_Multiplicity();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MClassImpl <em>MClass</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MClassImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMClass()
		 * @generated
		 */
		EClass MCLASS = eINSTANCE.getMClass();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MClassifierImpl <em>MClassifier</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MClassifierImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMClassifier()
		 * @generated
		 */
		EClass MCLASSIFIER = eINSTANCE.getMClassifier();

		/**
		 * The meta object literal for the '<em><b>MPorts</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MCLASSIFIER__MPORTS = eINSTANCE.getMClassifier_MPorts();

		/**
		 * The meta object literal for the '<em><b>MRelations</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MCLASSIFIER__MRELATIONS = eINSTANCE.getMClassifier_MRelations();

		/**
		 * The meta object literal for the '<em><b>MOperations</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MCLASSIFIER__MOPERATIONS = eINSTANCE.getMClassifier_MOperations();

		/**
		 * The meta object literal for the '<em><b>MGeneralizations</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MCLASSIFIER__MGENERALIZATIONS = eINSTANCE.getMClassifier_MGeneralizations();

		/**
		 * The meta object literal for the '<em><b>MAttributes</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MCLASSIFIER__MATTRIBUTES = eINSTANCE.getMClassifier_MAttributes();

		/**
		 * The meta object literal for the '<em><b>MInterface Items</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MCLASSIFIER__MINTERFACE_ITEMS = eINSTANCE.getMClassifier_MInterfaceItems();

		/**
		 * The meta object literal for the '<em><b>MFlows</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MCLASSIFIER__MFLOWS = eINSTANCE.getMClassifier_MFlows();

		/**
		 * The meta object literal for the '<em><b>MFlow Items</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MCLASSIFIER__MFLOW_ITEMS = eINSTANCE.getMClassifier_MFlowItems();

		/**
		 * The meta object literal for the '<em><b>MLinks</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MCLASSIFIER__MLINKS = eINSTANCE.getMClassifier_MLinks();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MComponentImpl <em>MComponent</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MComponentImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMComponent()
		 * @generated
		 */
		EClass MCOMPONENT = eINSTANCE.getMComponent();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MConfigurationImpl <em>MConfiguration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MConfigurationImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMConfiguration()
		 * @generated
		 */
		EClass MCONFIGURATION = eINSTANCE.getMConfiguration();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MDependencyImpl <em>MDependency</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MDependencyImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMDependency()
		 * @generated
		 */
		EClass MDEPENDENCY = eINSTANCE.getMDependency();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MDiagramImpl <em>MDiagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MDiagramImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMDiagram()
		 * @generated
		 */
		EClass MDIAGRAM = eINSTANCE.getMDiagram();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MEnumerationLiteralImpl <em>MEnumeration Literal</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MEnumerationLiteralImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMEnumerationLiteral()
		 * @generated
		 */
		EClass MENUMERATION_LITERAL = eINSTANCE.getMEnumerationLiteral();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MFileImpl <em>MFile</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MFileImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMFile()
		 * @generated
		 */
		EClass MFILE = eINSTANCE.getMFile();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MFlowImpl <em>MFlow</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MFlowImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMFlow()
		 * @generated
		 */
		EClass MFLOW = eINSTANCE.getMFlow();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MFlowItemImpl <em>MFlow Item</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MFlowItemImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMFlowItem()
		 * @generated
		 */
		EClass MFLOW_ITEM = eINSTANCE.getMFlowItem();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MGeneralizationImpl <em>MGeneralization</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MGeneralizationImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMGeneralization()
		 * @generated
		 */
		EClass MGENERALIZATION = eINSTANCE.getMGeneralization();

		/**
		 * The meta object literal for the '<em><b>Base Class</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MGENERALIZATION__BASE_CLASS = eINSTANCE.getMGeneralization_BaseClass();

		/**
		 * The meta object literal for the '<em><b>Derived Class</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MGENERALIZATION__DERIVED_CLASS = eINSTANCE.getMGeneralization_DerivedClass();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MInstanceImpl <em>MInstance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MInstanceImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMInstance()
		 * @generated
		 */
		EClass MINSTANCE = eINSTANCE.getMInstance();

		/**
		 * The meta object literal for the '<em><b>MAttribute Values</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MINSTANCE__MATTRIBUTE_VALUES = eINSTANCE.getMInstance_MAttributeValues();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MInterfaceItemImpl <em>MInterface Item</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MInterfaceItemImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMInterfaceItem()
		 * @generated
		 */
		EClass MINTERFACE_ITEM = eINSTANCE.getMInterfaceItem();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MLinkImpl <em>MLink</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MLinkImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMLink()
		 * @generated
		 */
		EClass MLINK = eINSTANCE.getMLink();

		/**
		 * The meta object literal for the '<em><b>From</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MLINK__FROM = eINSTANCE.getMLink_From();

		/**
		 * The meta object literal for the '<em><b>To</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MLINK__TO = eINSTANCE.getMLink_To();

		/**
		 * The meta object literal for the '<em><b>From Sys ML Port</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MLINK__FROM_SYS_ML_PORT = eINSTANCE.getMLink_FromSysMLPort();

		/**
		 * The meta object literal for the '<em><b>To Sys ML Port</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MLINK__TO_SYS_ML_PORT = eINSTANCE.getMLink_ToSysMLPort();

		/**
		 * The meta object literal for the '<em><b>From Port</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MLINK__FROM_PORT = eINSTANCE.getMLink_FromPort();

		/**
		 * The meta object literal for the '<em><b>To Port</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MLINK__TO_PORT = eINSTANCE.getMLink_ToPort();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MLiteralSpecificationImpl <em>MLiteral Specification</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MLiteralSpecificationImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMLiteralSpecification()
		 * @generated
		 */
		EClass MLITERAL_SPECIFICATION = eINSTANCE.getMLiteralSpecification();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MLITERAL_SPECIFICATION__VALUE = eINSTANCE.getMLiteralSpecification_Value();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MModelElementImpl <em>MModel Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MModelElementImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMModelElement()
		 * @generated
		 */
		EClass MMODEL_ELEMENT = eINSTANCE.getMModelElement();

		/**
		 * The meta object literal for the '<em><b>MUnsupported Model Elements</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MMODEL_ELEMENT__MUNSUPPORTED_MODEL_ELEMENTS = eINSTANCE.getMModelElement_MUnsupportedModelElements();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MMODEL_ELEMENT__NAME = eINSTANCE.getMModelElement_Name();

		/**
		 * The meta object literal for the '<em><b>Full Path Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MMODEL_ELEMENT__FULL_PATH_NAME = eINSTANCE.getMModelElement_FullPathName();

		/**
		 * The meta object literal for the '<em><b>MProject</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MMODEL_ELEMENT__MPROJECT = eINSTANCE.getMModelElement_MProject();

		/**
		 * The meta object literal for the '<em><b>MStereotypes</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MMODEL_ELEMENT__MSTEREOTYPES = eINSTANCE.getMModelElement_MStereotypes();

		/**
		 * The meta object literal for the '<em><b>MAll Tags</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MMODEL_ELEMENT__MALL_TAGS = eINSTANCE.getMModelElement_MAllTags();

		/**
		 * The meta object literal for the '<em><b>MLocal Tags</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MMODEL_ELEMENT__MLOCAL_TAGS = eINSTANCE.getMModelElement_MLocalTags();

		/**
		 * The meta object literal for the '<em><b>MNested Elements</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MMODEL_ELEMENT__MNESTED_ELEMENTS = eINSTANCE.getMModelElement_MNestedElements();

		/**
		 * The meta object literal for the '<em><b>MDependencies</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MMODEL_ELEMENT__MDEPENDENCIES = eINSTANCE.getMModelElement_MDependencies();

		/**
		 * The meta object literal for the '<em><b>Uri</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MMODEL_ELEMENT__URI = eINSTANCE.getMModelElement_Uri();

		/**
		 * The meta object literal for the '<em><b>MModel Element Refs</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MMODEL_ELEMENT__MMODEL_ELEMENT_REFS = eINSTANCE.getMModelElement_MModelElementRefs();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MModelElementRefImpl <em>MModel Element Ref</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MModelElementRefImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMModelElementRef()
		 * @generated
		 */
		EClass MMODEL_ELEMENT_REF = eINSTANCE.getMModelElementRef();

		/**
		 * The meta object literal for the '<em><b>Reference</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MMODEL_ELEMENT_REF__REFERENCE = eINSTANCE.getMModelElementRef_Reference();

		/**
		 * The meta object literal for the '<em><b>Structural Feature Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MMODEL_ELEMENT_REF__STRUCTURAL_FEATURE_NAME = eINSTANCE.getMModelElementRef_StructuralFeatureName();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MModuleImpl <em>MModule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MModuleImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMModule()
		 * @generated
		 */
		EClass MMODULE = eINSTANCE.getMModule();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MObjectModelDiagramImpl <em>MObject Model Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MObjectModelDiagramImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMObjectModelDiagram()
		 * @generated
		 */
		EClass MOBJECT_MODEL_DIAGRAM = eINSTANCE.getMObjectModelDiagram();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MOperationImpl <em>MOperation</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MOperationImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMOperation()
		 * @generated
		 */
		EClass MOPERATION = eINSTANCE.getMOperation();

		/**
		 * The meta object literal for the '<em><b>Return Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MOPERATION__RETURN_TYPE = eINSTANCE.getMOperation_ReturnType();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MPackageImpl <em>MPackage</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MPackageImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMPackage()
		 * @generated
		 */
		EClass MPACKAGE = eINSTANCE.getMPackage();

		/**
		 * The meta object literal for the '<em><b>MClasses</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MPACKAGE__MCLASSES = eINSTANCE.getMPackage_MClasses();

		/**
		 * The meta object literal for the '<em><b>MLinks</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MPACKAGE__MLINKS = eINSTANCE.getMPackage_MLinks();

		/**
		 * The meta object literal for the '<em><b>MTypes</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MPACKAGE__MTYPES = eINSTANCE.getMPackage_MTypes();

		/**
		 * The meta object literal for the '<em><b>MPackages</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MPACKAGE__MPACKAGES = eINSTANCE.getMPackage_MPackages();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MPortImpl <em>MPort</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MPortImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMPort()
		 * @generated
		 */
		EClass MPORT = eINSTANCE.getMPort();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MProfileImpl <em>MProfile</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MProfileImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMProfile()
		 * @generated
		 */
		EClass MPROFILE = eINSTANCE.getMProfile();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MProjectImpl <em>MProject</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MProjectImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMProject()
		 * @generated
		 */
		EClass MPROJECT = eINSTANCE.getMProject();

		/**
		 * The meta object literal for the '<em><b>MComponents</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MPROJECT__MCOMPONENTS = eINSTANCE.getMProject_MComponents();

		/**
		 * The meta object literal for the '<em><b>MObject Model Diagrams</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MPROJECT__MOBJECT_MODEL_DIAGRAMS = eINSTANCE.getMProject_MObjectModelDiagrams();

		/**
		 * The meta object literal for the '<em><b>MProfiles</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MPROJECT__MPROFILES = eINSTANCE.getMProject_MProfiles();

		/**
		 * The meta object literal for the '<em><b>MStructure Diagrams</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MPROJECT__MSTRUCTURE_DIAGRAMS = eINSTANCE.getMProject_MStructureDiagrams();

		/**
		 * The meta object literal for the '<em><b>MModel Elements</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MPROJECT__MMODEL_ELEMENTS = eINSTANCE.getMProject_MModelElements();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MRelationImpl <em>MRelation</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MRelationImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMRelation()
		 * @generated
		 */
		EClass MRELATION = eINSTANCE.getMRelation();

		/**
		 * The meta object literal for the '<em><b>Other Class</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MRELATION__OTHER_CLASS = eINSTANCE.getMRelation_OtherClass();

		/**
		 * The meta object literal for the '<em><b>Of Class</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MRELATION__OF_CLASS = eINSTANCE.getMRelation_OfClass();

		/**
		 * The meta object literal for the '<em><b>Multiplicity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MRELATION__MULTIPLICITY = eINSTANCE.getMRelation_Multiplicity();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MStereotypeImpl <em>MStereotype</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MStereotypeImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMStereotype()
		 * @generated
		 */
		EClass MSTEREOTYPE = eINSTANCE.getMStereotype();

		/**
		 * The meta object literal for the '<em><b>Is New Term</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MSTEREOTYPE__IS_NEW_TERM = eINSTANCE.getMStereotype_IsNewTerm();

		/**
		 * The meta object literal for the '<em><b>Of Meta Class</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MSTEREOTYPE__OF_META_CLASS = eINSTANCE.getMStereotype_OfMetaClass();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MStructureDiagramImpl <em>MStructure Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MStructureDiagramImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMStructureDiagram()
		 * @generated
		 */
		EClass MSTRUCTURE_DIAGRAM = eINSTANCE.getMStructureDiagram();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MSysMLPortImpl <em>MSys ML Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MSysMLPortImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMSysMLPort()
		 * @generated
		 */
		EClass MSYS_ML_PORT = eINSTANCE.getMSysMLPort();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MSYS_ML_PORT__TYPE = eINSTANCE.getMSysMLPort_Type();

		/**
		 * The meta object literal for the '<em><b>Port Direction</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MSYS_ML_PORT__PORT_DIRECTION = eINSTANCE.getMSysMLPort_PortDirection();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MTagImpl <em>MTag</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MTagImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMTag()
		 * @generated
		 */
		EClass MTAG = eINSTANCE.getMTag();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MTAG__VALUE = eINSTANCE.getMTag_Value();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MTemplateParameterImpl <em>MTemplate Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MTemplateParameterImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMTemplateParameter()
		 * @generated
		 */
		EClass MTEMPLATE_PARAMETER = eINSTANCE.getMTemplateParameter();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MTypeImpl <em>MType</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MTypeImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMType()
		 * @generated
		 */
		EClass MTYPE = eINSTANCE.getMType();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MUnitImpl <em>MUnit</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MUnitImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMUnit()
		 * @generated
		 */
		EClass MUNIT = eINSTANCE.getMUnit();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MUnsupportedModelElementImpl <em>MUnsupported Model Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MUnsupportedModelElementImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMUnsupportedModelElement()
		 * @generated
		 */
		EClass MUNSUPPORTED_MODEL_ELEMENT = eINSTANCE.getMUnsupportedModelElement();

		/**
		 * The meta object literal for the '<em><b>Class Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MUNSUPPORTED_MODEL_ELEMENT__CLASS_NAME = eINSTANCE.getMUnsupportedModelElement_ClassName();

		/**
		 * The meta object literal for the '<em><b>Structural Feature Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MUNSUPPORTED_MODEL_ELEMENT__STRUCTURAL_FEATURE_NAME = eINSTANCE.getMUnsupportedModelElement_StructuralFeatureName();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MValueSpecificationImpl <em>MValue Specification</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MValueSpecificationImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMValueSpecification()
		 * @generated
		 */
		EClass MVALUE_SPECIFICATION = eINSTANCE.getMValueSpecification();

		/**
		 * The meta object literal for the '{@link com.eu.ales.rpyplugins.impl.MVariableImpl <em>MVariable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.eu.ales.rpyplugins.impl.MVariableImpl
		 * @see com.eu.ales.rpyplugins.impl.RpypluginsPackageImpl#getMVariable()
		 * @generated
		 */
		EClass MVARIABLE = eINSTANCE.getMVariable();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MVARIABLE__TYPE = eINSTANCE.getMVariable_Type();

		/**
		 * The meta object literal for the '<em><b>Default Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MVARIABLE__DEFAULT_VALUE = eINSTANCE.getMVariable_DefaultValue();

		/**
		 * The meta object literal for the '<em><b>MValue Specifications</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MVARIABLE__MVALUE_SPECIFICATIONS = eINSTANCE.getMVariable_MValueSpecifications();

	}

} //RpypluginsPackage
